$fs = 0.1;
$fa = 1;  



module chassisBody() {
    color("Lime") translate([0,0,-2.5]) cylinder(h=5, r=25, center=true, $fn=100);
}

module chassisHole() {
    

        color("red")
        linear_extrude(height = 5, center = true, convexity = 10, twist = 0, $fn=100){
        polygon(points = [[-9,5],[9,5],[9,-5],[-9,-5],[-9,5]]);}

    
}
//mountingHoleB();
//mountingHoleS();

module mountingHoleB() {
    
    module mountingHole() {
        color("Blue")
        linear_extrude(height = 9,5, center = false, convexity = 10, twist = 0, $fn=100){
        translate([2,0,0]) circle(r = 2, $fn=100);}
        linear_extrude(height = 7,5, center = false, convexity = 10, twist = 0, $fn=100){
        translate([-2,0,0]) circle(r = 2, $fn=100);}
        linear_extrude(height = 7,5, center = false, convexity = 10, twist = 0, $fn=100){
        polygon(points = [[2,2],[2,-2],[-2,-2],[-2,2],[2,2]]);}
    }
        
        difference() {
            mountingHole();
            color("Green")
            linear_extrude(height = 9,5, center = false, convexity = 10, twist = 0, $fn=100){
            translate([2,0,0]) circle(r = 1.25, $fn=100);
                }
        }

}


module mountingHoleS() {
    difference(){
        color("Blue")
        linear_extrude(height = 9,5, center = false, convexity = 10, twist = 0, $fn=100){
        circle(r = 2, $fn=100);
            }
        color("Orange")
        linear_extrude(height = 9,5, center = false, convexity = 10, twist = 0, $fn=100){
        circle(r = 1.25, $fn=100);
            }
    }
}


module motorHolder() {
    
    difference() {
        color("Yellow")
        linear_extrude(height = 10, center = true, convexity = 10, twist = 0, $fn=100){
        circle(r = 4.5, $fn=100);
            }
        linear_extrude(height = 10, center = true, convexity = 10, twist = 0, $fn=100){
        polygon(points = [[5,1],[5,-1],[1,-1],[1,1],[5,1]]);}
            
    }
    
}

module motorHolderHole() {
    
    color("Yellow")
    linear_extrude(height = 34, center = true, convexity = 10, twist = 0, $fn=100){
    circle(r = 3.25, $fn=100);
    }
    
}






module bearingHolder() {
    
    difference() {
        color("Yellow")
        linear_extrude(height = 3, center = true, convexity = 10, twist = 0, $fn=100){
        circle(r = 4.25, $fn=100);
            }
        linear_extrude(height = 3, center = true, convexity = 10, twist = 0, $fn=100){
        polygon(points = [[4.25,1],[4.25,-1],[1,-1],[1,1],[4.25,1]]);}
    }
    
}


module bearingHolderHole() {
    
    difference() {
        color("red")
        linear_extrude(height = 48, center = true, convexity = 10, twist = 0, $fn=100){
        circle(r = 3.25, $fn=100);
            }
        linear_extrude(height = 3, center = false, convexity = 10, twist = 0, $fn=100){
        polygon(points = [[8,1],[8,-1],[4,-1],[4,1],[8,1]]);}
    }
    
}

module decodeHole() {
    
    difference() {
        color("red")
        linear_extrude(height = 3, center = true, convexity = 10, twist = 0, $fn=100){
        circle(r = 8.5, $fn=100);
            }
        linear_extrude(height = 3, center = true, convexity = 10, twist = 0, $fn=100){
        circle(r = 6.5, $fn=100);}
    }
    
}




//chassis();



module chassis() {
    
    module add() {
chassisBody();
rotate([90,270,180]) translate([1,9.5,1]) motorHolder();
rotate([90,270,180]) translate([1,-9.5,-1]) motorHolder();
    
rotate([90,270,180]) translate([1,0,-20.5])bearingHolder();
rotate([90,270,180]) translate([1,0,-7.5])bearingHolder();
rotate([90,270,180]) translate([1,0,20.5])bearingHolder();
rotate([90,270,180]) translate([1,0,7.5])bearingHolder();
    
translate([17,-15.5,0]) mountingHoleS();
translate([-18,14,0]) mountingHoleS();
rotate([0,0,180]) translate([-10.5-2,-15.5,0]) mountingHoleB();
rotate([0,0,0]) translate([-11.5-2,-16.5,0]) mountingHoleB();
    }  

    
    
    
    module diff() {
translate([0,14,-2.50]) chassisHole();
translate([0,-14,-2.50]) chassisHole();
rotate([90,90,0]) translate([-1,0,-20.4]) decodeHole(); 
rotate([90,90,0]) translate([-1,0,20.4]) decodeHole();



rotate([90,90,0]) translate([-1,-9.5,10]) motorHolderHole();
rotate([90,90,0]) translate([-1,9.5,-10]) motorHolderHole();

rotate([90,90,0]) translate([-1,0,0]) bearingHolderHole();
    }
    
    difference() {
        add();
        diff();
        
        }



    }



























module chassisGround() {
    
    
    color("Lime") translate([0,0,-2.5]) cylinder(h=0.3, r=27, center=true, $fn=100);
    
    
    }
    
module chassisGroundHole() {
    
            color("red")
        linear_extrude(height = 0.3, center = true, convexity = 10, twist = 0, $fn=100){
        polygon(points = [[-7,3],[7,3],[7,-3],[-7,-3],[-7,3]]);}
    
    
}


module printSupport() {
    
    difference(){
        chassisGround();
        translate([0,14,-2.50]) chassisGroundHole();
        translate([0,-14,-2.50]) chassisGroundHole();
    }
    
    
}



module printChassis(){
    

        chassis();
        translate([0,0,-2.5]) printSupport();
        
        
        
    
    
    
    
}

printChassis();


















