/*
 * GccApplication14.c
 *
 * Created: 05.09.2014 22:53:29
 *  Author: Fabio
 */ 


#include <avr/io.h>
#include <avr/interrupt.h>
#include <stdbool.h>

#define F_CPU 8000000UL

#include <util/delay.h>

// #define nop() \ asm volatile ("nop")



volatile uint16_t rc5Command =     0b00000000000000;
volatile uint16_t rc5Commandmask = 0b10000000000000;

volatile uint8_t rc5 = 0;
volatile uint8_t extenalInterrupt = 0;

volatile long tcnt1 = 0;
volatile long tcnt = 0;
volatile uint16_t timerPreload = 0;
volatile uint16_t halfBitTime = 0;
volatile uint16_t fullBitTime = 0;
volatile uint16_t bitTime = 0;
volatile uint8_t sampleBits = 0;


const volatile uint16_t halfBitPeriodMin = 7120;//640 5120 2560
volatile uint16_t halfBitPeriodMax = 11120;//1140 9120 5060

volatile uint16_t fullBitPeriodMin = 12720;//1340 10720 5360
volatile uint16_t fullBitPeriodMax = 19760;//2220 17760 8880


volatile uint32_t bits16 = 65536;
volatile uint8_t clock = 125;
volatile uint16_t div = 1000;

const int delay = 0;



int main(void)
{	
	
	DDRD &= ~(1 << PD2);			
	PORTD |= (1 << PD2);			
	
	DDRD |= (1 << PD6);
	PORTD &= ~(1 << PD6);
	
	DDRB |= ((1 << PB1) | (1 << PB2));
	PORTB |= ((1 << PB1) | (1 << PB2));
	
	
	EICRA |= (1 << ISC00);
	
	EIMSK |= (1 << INT0);
	
	//TIMSK1 |= (1 << TOIE1);
	//_delay_ms(2);
	sei();
	
	
	
	
    while(1)
    {PORTD ^= (1 << PD6);
		if (rc5Command == 0x2C7F)
		{
			/*white*/
			PORTB &= ~((1 << PORTB1) | (1 << PORTB2));
			PORTD &= ~(1 << PORTD6);
		}
		else if (rc5Command == 0x2C7E)
		{
			/*red*/	
			PORTB &= ~(1 << PORTB2);
			PORTB |= (1 << PORTB1);
			PORTD |= (1 << PORTD6);	
		}
		else if (rc5Command == 0x2C7D)
		{
			/*green*/
			PORTD &= ~(1 << PORTD6);
			PORTB |= (1 << PORTB1);
			PORTB |= (1 << PORTB2);
		}
		else if (rc5Command == 0x2C7C)
		{
			/*blue*/
			PORTB &= ~(1 << PORTB1);
			PORTB |= (1 << PORTB2);
			PORTD |= (1 << PORTD6);
		}
		else if (rc5Command == 0x2C7B)
		{
			/*yellow*/
			PORTB &= ~(1 << PORTB2);
			PORTD &= ~(1 << PORTD6);
			PORTB |= (1 << PORTB1);
		}
		else if (rc5Command == 0x2C7A)
		{
			/*purple*/
			PORTB &= ~(1 << PORTB2);
			PORTB &= ~(1 << PORTB1);
			PORTD |= (1 << PORTD6);
		}
		else if (rc5Command == 0x2C79)
		{
			/*turquoise*/
			PORTD &= ~(1 << PORTD6);
			PORTB &= ~(1 << PORTB1);
			PORTB |= (1 << PORTB2);
		}
		else if (rc5Command == 0x2C78)
		{
			/*black*/
			PORTB |= ((1 << PORTB1) | (1 << PORTB2));
			PORTD |= (1 << PORTD6);
		}


        //TODO:: Please write your application code 
    }
}




ISR(INT0_vect)
{
	
extenalInterrupt++;

if (extenalInterrupt == 1)
{
// 	rc5Command = 0b00000000000000;
// 	rc5Commandmask = 0x2000;
	TCNT1 = 0;
	TIMSK1 &= ~(1 << TOIE1);
	TCCR1B |= (1 << CS10);						// Set Clock prescaler 1
	/*PORTD ^= (1 << PD6);*/
	//????EIFR |= (1 << INTF0);
	// 1
	rc5Command |= ((uint16_t)1 << rc5Commandmask);
	rc5Commandmask &= (rc5Commandmask >> (int)1);
	return;
}


else if (extenalInterrupt == 2)
{

 	TCCR1B &= ~((1 << CS12) | (1 << CS11) | (1 << CS10));			// Disconnect Timer1 clock source
 	tcnt1 = TCNT1;												 	// Store Timer1 counts

	if (tcnt1 > halfBitPeriodMin && tcnt1 < halfBitPeriodMax)
	{// 1
		rc5Command |= ((uint16_t)1 << rc5Commandmask);
		rc5Commandmask &= (rc5Commandmask >> (int)1);
		timerPreload = (uint16_t)(bits16 - (tcnt1 * 2));								// Calculate Timer1 preloader ***(clock source )
		return;
	}
	else if (tcnt1 > fullBitPeriodMin && tcnt1 < fullBitPeriodMax)		/*thats the fieldbit 0*/
	{// 0
		rc5Command &= ~((uint16_t)1 << rc5Commandmask);
		rc5Commandmask = (rc5Commandmask >> (int)1);
		EICRA &= ~((1 << ISC10) | (1 << ISC00));
		EIMSK &= ~(1 << INT0);
		timerPreload = (uint16_t)(bits16 - tcnt1);									// Calculate full bit time

		for (int i = 0 ; i < tcnt1*2*0.75; i++)
		{
			// mach was oder chills eifach
			asm volatile ("nop");
		}
		/*(PORTD ^= (1 << PD6);)*/
		
		if (PIND & (1 << PD2))
		{//1
			rc5Command |= ((uint16_t)1 << rc5Commandmask);
			rc5Commandmask &= (rc5Commandmask >> (int)1);
			/*PORTD ^= (1 << PD6);*/
		}
		else if (!(PIND & (1 << PD2)))
		{//0
			rc5Command &= ~((uint16_t)1 << rc5Commandmask);
			rc5Commandmask &= (rc5Commandmask >> (int)1);
		}
		
		//TIFR1 |= (1 << TOV1); //??
		/*EIFR |= (1 << INTF0);*/
		TCCR1B |= (1 << CS10);
		TCNT1 = timerPreload;
		TIMSK1 |= (1 << TOIE1);															// Enable Timer1 OVF Interrupt
		extenalInterrupt = 0;
		return;
	}
	else if (tcnt1 < halfBitPeriodMin || tcnt1 > fullBitPeriodMax)
	{	//fail  // invalid time
		
		EICRA &= ~((1 << ISC10) | (1 << ISC00));
		EIMSK &= ~(1 << INT0);
				
// 		TCCR1B &= ~((1 << CS12) | (1 << CS11) | (1 << CS10));
// 		TIMSK1 &= ~(1 << TOIE1);
// 		EICRA |= (1 << ISC00);
// 		EIMSK |= (1 << INT0);  //??//

 		timerPreload = (uint16_t)(bits16 - tcnt1);
		TCNT1 = timerPreload;
		TCCR1B |= (1 << CS10);
		TIMSK1 |= (1 << TOIE1);															// Enable Timer1 OVF Interrupt
		extenalInterrupt = 0; 
		 
		 
// 		timerPreload = 0;
		bitTime = 0;
		halfBitTime = 0;
		fullBitTime = 0;
		extenalInterrupt = 0;
		return;
	}
	


}


else if (extenalInterrupt == 3)		/*thats the fieldbit 1*/
{/**/
	EICRA &= ~((1 << ISC10) | (1 << ISC00));
	EIMSK &= ~(1 << INT0);
	
	for (int i = 0 ; i < tcnt1*2*0.75; i++)
	{
		// mach was oder chills eifach
		asm volatile ("nop");
	}

	
	if (PIND & (1 << PD2))
	{//1
		rc5Command |= ((uint16_t)1 << rc5Commandmask);
		rc5Commandmask &= (rc5Commandmask >> (int)1);
		/*PORTD ^= (1 << PD6);*/
	}
	else if (!(PIND & (1 << PD2)))
	{//0
		rc5Command &= ~((uint16_t)1 << rc5Commandmask);
		rc5Commandmask &= (rc5Commandmask >> (int)1);
		/*PORTB ^= (1 << PB1);*/		
	}
	
	TCCR1B |= (1 << CS10);
	TCNT1 = timerPreload;						// da odr da bruchts ned
	TIMSK1 |= (1 << TOIE1);						// Enable Timer1 OVF Interrupt
	
	extenalInterrupt = 0;
	return;
}


		
// 	if (extenalInterrupt < 2)
// 	{
 		
// 	}
// 	else
// 	{
// 		extenalInterrupt = 0;
// 	}

// 			if (TCNT1 >= 1000)
// 			{
// 				PORTD ^= (1 << PD6);
// 			}

}


ISR(TIMER1_OVF_vect)
{
/*PORTD ^= (1 << PD6);*/
	if (PIND & (1 << PD2))
	{//1
		rc5Command |= ((uint16_t)1 << rc5Commandmask);
		rc5Commandmask = (rc5Commandmask >> (int)1);
		/*TCNT1 = timerPreload;*///????
		sampleBits++;/* PORTD ^= (1 << PD6);*/
	}
	else if (!(PIND & (1 << PD2)))
	{//0
		rc5Command &= ~((uint16_t)1 << rc5Commandmask);
		rc5Commandmask &= (rc5Commandmask >> (int)1);
		/*TCNT1 = timerPreload;*///????
		sampleBits++;/* PORTB ^= (1 << PB1);*/
	}
	
	if (sampleBits == 13)
	{
// 		if (PIND & (1 << PD2))
// 		{
// 			rc5 = 1;	PORTB ^= (1 << PB1);
// 		}
		sampleBits = 0;
		bitTime = 0;
		halfBitTime = 0;
		fullBitTime = 0;
		timerPreload = 0;
		tcnt1 = 0;
				if (/*rc5 == 1 &&*/ rc5Command & 0x3e7f)
				{
					/*PORTD ^= (1 << PD6);*/
					rc5 = 0;
					rc5Command = 0b00000000000000;
					rc5Commandmask = 0x2000;
				}
		TCNT1 = 0;
		TCCR1B &= ~((1 << CS12) | (1 << CS11) | (1 << CS10));
		TIMSK1 &= ~(1 << TOIE1);
		EICRA |= (1 << ISC00);
		EIMSK |= (1 << INT0);	
	}
	
	//????
	TCNT1 = timerPreload;
	
}













/*


		if (TCNT1 < 8000)
		{
			
		}



		if (tcnt1 < 7990 && tcnt1 > 7940)
		{
			//PORTD ^= (1 << PD6);
		}




		if (bitTime > 40)
		{
			PORTD ^= (1 << PD6);
		}



		if (timerPreload > 57400 && timerPreload < 57800)
		{
			//PORTD ^= (1 << PD6);
		}
		
		
		
		*/



// 	TCCR1B &= ~((1 << CS12) | (1 << CS11) | (1 << CS10));			// Disconnect Timer1 clock source
// 	tcnt1 = TCNT1;
// 	// Store Timer1 counts
// 	bitTime = (uint16_t)((tcnt1 * 125) / 1000);
// 	// Reset TCNT1
//
// 
	// if (bitTime > halfBitPeriodMin && bitTime < halfBitPeriodMax)
	// {// 1
	// 	
	// 	halfBitTime =  (uint16_t)((tcnt1 * 125) / 1000);	//PORTD ^= (1 << PD6);						// breuchts glaub ned ?? aber scho biz // Calculate half bit time
	// 	fullBitTime = (halfBitTime * 2);		//extenalInterrupt++;							// Calculate full bit time
	// 	timerPreload = (long)57536;								// Calculate Timer1 preloader ***(clock source )
	// 	if (timerPreload >= 7500 && timerPreload <= 8500)
	// 	{
	// 		
	// 	}
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
// 	
// 	
// 
// 	ISR(INT0_vect)
// 	{
// 		
// 		extenalInterrupt++;
// 
// 		if (extenalInterrupt == 1)
// 		{
// 
// 			TCNT1 = 0;
// 			TIMSK1 &= ~(1 << TOIE1);
// 			TCCR1B |= (1 << CS10);						// Set Clock prescaler 1
// 			/*PORTD ^= (1 << PD6);*/
// 			//????EIFR |= (1 << INTF0);
// 			// 1
// 		}
// 
// 
// 		if (extenalInterrupt == 2)
// 		{
// 
// 			// 	TCCR1B &= ~((1 << CS12) | (1 << CS11) | (1 << CS10));			// Disconnect Timer1 clock source
// 			// 	tcnt1 = TCNT1;
// 			// 	// Store Timer1 counts
// 			// 	bitTime = (uint16_t)((tcnt1 * 125) / 1000);
// 			// 	// Reset TCNT1
// 			//
// 
// 			if (bitTime > halfBitPeriodMin && bitTime < halfBitPeriodMax)
// 			{// 1
// 				
// 				halfBitTime =  (uint16_t)((tcnt1 * 125) / 1000);	//PORTD ^= (1 << PD6);						// breuchts glaub ned ?? aber scho biz // Calculate half bit time
// 				fullBitTime = (halfBitTime * 2);		//extenalInterrupt++;							// Calculate full bit time
// 				timerPreload = (long)57536;								// Calculate Timer1 preloader ***(clock source )
// 				if (timerPreload >= 7500 && timerPreload <= 8500)
// 				{
// 					PORTB ^= (1 << PB1);
// 				}
// 
// 			}
// 			else if (bitTime > fullBitPeriodMin && bitTime < fullBitPeriodMax)
// 			{// 0
// 
// 				EICRA &= ~((1 << ISC10) | (1 << ISC00));
// 				EIMSK &= ~(1 << INT0);
// 				//PORTB ^= (1 << PB1);
// 				fullBitTime =  (uint16_t)((tcnt1 * 125) / 1000);							// Calculate half bit time
// 				// bruchts ned!! halfBitTime = (fullBitTime / 2);
// 				timerPreload = (uint16_t)(bits16 - ((fullBitTime * 1000) / 125));									// Calculate full bit time
// 
// 				for (int i = 0 ; i < fullBitTime*0.75; i++)
// 				{
// 					// mach was oder chills eifach
// 				}
// 				
// 				if (PIND & (1 << PD2))
// 				{//1
// 					
// 				}
// 				else if (!(PIND & (1 << PD2)))
// 				{//0
// 
// 				}
// 				
// 				//TIFR1 |= (1 << TOV1); //??
// 				TCCR1B |= (1 << CS10);
// 				TCNT1 = timerPreload;
// 				TIMSK1 |= (1 << TOIE1);															// Enable Timer1 OVF Interrupt
// 				extenalInterrupt = 0;
// 
// 			}
// 			else if (bitTime <= halfBitPeriodMin || bitTime >= fullBitPeriodMax)
// 			{	//fail  // invalid time
// 				//PORTB ^= (1 << PB1);
// 				TCCR1B &= ~((1 << CS12) | (1 << CS11) | (1 << CS10));
// 				TIMSK1 &= ~(1 << TOIE1);
// 				EICRA |= (1 << ISC00);
// 				EIMSK |= (1 << INT0);  //??//
// 				TCNT1 = 0;
// 				timerPreload = 0;
// 				bitTime = 0;
// 				halfBitTime = 0;
// 				fullBitTime = 0;
// 				extenalInterrupt = 0;
// 				
// 			}
// 			
// 
// 
// 		}
// 
// 
// 		if (extenalInterrupt == 3)
// 		{
// 			EICRA &= ~((1 << ISC10) | (1 << ISC00));
// 			EIMSK &= ~(1 << INT0);
// 			
// 			for (int i = 0 ; i < fullBitTime*0.75; i++)
// 			{
// 				// mach was oder chills eifach
// 			}
// 			
// 			if (PIND & (1 << PD2))
// 			{//1
// 				
// 			}
// 			else if (!(PIND & (1 << PD2)))
// 			{//0
// 
// 			}
// 			
// 			TCCR1B |= (1 << CS10);
// 			TCNT1 = timerPreload;						// da odr da bruchts ned
// 			TIMSK1 |= (1 << TOIE1);						// Enable Timer1 OVF Interrupt
// 			
// 			extenalInterrupt = 0;
// 		}
// 
// 
// 		
// 		// 	if (extenalInterrupt < 2)
// 		// 	{
// 		
// 		// 	}
// 		// 	else
// 		// 	{
// 		// 		extenalInterrupt = 0;
// 		// 	}
// 
// 		// 			if (TCNT1 >= 1000)
// 		// 			{
// 		// 				PORTD ^= (1 << PD6);
// 		// 			}
// 
// 	}
// 
// 
// 	ISR(TIMER1_OVF_vect)
// 	{
// 
// 		if (PIND & (1 << PD2))
// 		{//1
// 			/*TCNT1 = timerPreload;*///????
// 			sampleBits++;PORTD ^= (1 << PD6);
// 		}
// 		else if (!(PIND & (1 << PD2)))
// 		{//0
// 			/*TCNT1 = timerPreload;*///????
// 			sampleBits++;PORTB ^= (1 << PB1);
// 		}
// 		
// 		if (sampleBits == 13)
// 		{
// 			
// 			sampleBits = 0;
// 			bitTime = 0;
// 			halfBitTime = 0;
// 			fullBitTime = 0;
// 			timerPreload = 0;
// 			tcnt1 = 0;
// 			TCNT1 = 0;
// 			TCCR1B &= ~((1 << CS12) | (1 << CS11) | (1 << CS10));
// 			TIMSK1 &= ~(1 << TOIE1);
// 			EICRA |= (1 << ISC00);
// 			EIMSK |= (1 << INT0);
// 		}
// 		
// 		//????
// 		TCNT1 = timerPreload;
// 		
// 	}
