/*
 * GccApplication21.c
 *
 * Created: 01.02.2015 16:45:20
 *  Author: Fabio
 */ 


#include <avr/io.h>
#include <util/twi.h>
#include <util/delay.h>
#define F_CPU 8000000UL 
#define F_TW_SCL 100000L


#define TW_START 0x08
#define TW_REPEATED_START 0x10

#define TW_MT_SLA_ACK 0x18
#define TW_MT_SLA_NACK 0x20
#define TW_MT_DATA_ACK 0x28
#define TW_MT_DATA_NACK 0x30
#define TW_MT_ARBITRATION 0x38

#define TW_MR_ARBITRATION 0x38
#define TW_MR_SLA_ACK 0x40
#define TW_MR_SLA_NACK 0x48
#define TW_MR_DATA_ACK 0x50
#define TW_MR_DATA_NACK 0x58

#define TW_NO_INFO 0xF8
#define TW_STOP 0xA0






	#define AVERAGE_BIT  6
	#define AVERAGE_LENGHT  2
	
	#define AVERAGE_1  0x00
	#define AVERAGE_2  0x01
	#define AVERAGE_4  0x02
	#define AVERAGE_8  0x03
	


	#define DATARATE_BIT  4
	#define DATARATE_LENGHT  3
	
	#define DATARATE_0_75  0x00
	#define DATARATE_1_5  0x20
	#define DATARATE_3  0x40
	#define DATARATE_7_5  0x60
	#define DATARATE_15  0x80
	#define DATARATE_30  0xA0
	#define DATARATE_75  0xC0
	

	
	#define BAIS_BIT  1
	#define BAIS_LENGHT  2
	
	#define BAIS_NORMAL  0x00
	#define BAIS_POSITIV  0x01
	#define BAIS_NEGATIV  0x02
	


	#define GAIN_BIT  7
	#define GAIN_LENGHT  3
	
	#define GAIN_1370 0x00
	#define GAIN_1090 0x01
	#define GAIN_820 0x02
	#define GAIN_660 0x03
	#define GAIN_440 0x04
	#define GAIN_390 0x05
	#define GAIN_330 0x06
	#define GAIN_220 0x07
	


	#define MODE_BIT  1
	#define MODE_LENGHT  2
	
	#define MODE_CONTINUOUS  0x00
	#define MODE_SINGLE  0x01
	#define MODE_IDLE  0x02
	
	
	#define STATUS_BIT    1
	#define STATUS_LENGHT    1
	
	#define STATUS_VAL   0x02
	
	
	
	#define CR_SLA_W 0x3C
	#define CR_SLA_R 0x3D

	#define CR_RA_A  0x00
	#define CR_RA_B  0x01
	#define CR_RA_MR  0x02
	#define CR_RA_DO_XH  0x03
	#define CR_RA_DO_XL  0x04
	#define CR_RA_DO_YH  0x05
	#define CR_RA_DO_YL  0x06
	#define CR_RA_DO_ZH  0x07
	#define CR_RA_DO_ZL  0x08
	#define CR_RA_SR  0x09
	#define CR_RA_IR_A  0x0A
	#define CR_RA_IR_B  0x0B
	#define CR_RA_IR_C  0x0C
	



	uint8_t CR_A;
	
	uint8_t CR_B;
	
	uint8_t CR_MR;
	
	
uint8_t DATA5 = 0;
uint8_t DATA4 = 0;	
uint8_t DATA3 = 0;
uint8_t DATA2 = 0;
uint8_t DATA1 = 0;
uint8_t DATA0 = 0;
uint8_t data[];
uint8_t datar[];


int main(void)
{
		DDRD |= (1 << PORTD6);														
		PORTD |= (1 << PORTD6);
		
	DDRB |= ((1 << PORTB1) | (1 << PORTB2));
	PORTB |= ((1 << PORTB1) | (1 << PORTB2));
	
	twi_init();
	hmc5883l_init();
	
    while(1)
    {
		uint16_t DATA01 = (((uint16_t)DATA2) << 8) | DATA3;
		
		if (DATA2 <= (uint8_t)127)
		{
			PORTB &= ~(1 << PORTB1);
		}
		
		if (DATA3 >= 127)
		{
			PORTD &= ~(1 << PORTD6);
		}
				
		if (DATA01 >= (uint16_t)694)
		{
			PORTB &= ~(1 << PORTB2);
		}
		
		
		//hmc5883l_init();
		/*delay();*/
		
		
//         	if ((TWSR & TW_NO_INFO) != TW_START)
//         	{
// 	        	PORTB &= ~(1 << PORTB2);
// 				PORTB |= (1 << PORTB2);
//         	}
//         	
//         	if ((TWSR & TW_NO_INFO) != TW_MR_SLA_ACK)
//         	{
// 	        	PORTB &= ~(1 << PORTB1);
// 				PORTB |= (1 << PORTB1);
//         	}
    }
}


  





	

	









void CR_A_init(uint8_t average, uint8_t rate, uint8_t bias) {

	CR_A = (average << (AVERAGE_BIT - AVERAGE_LENGHT + 1)) |
	       (rate << (DATARATE_BIT - DATARATE_LENGHT + 1)) |
		   (bias << (BAIS_BIT - BAIS_LENGHT + 1));
	data[0]	= CR_A;  
}


void CR_B_init(uint8_t gain) {

	CR_B = gain;
	data[1]	= CR_B;
}

void CR_MR_init(uint8_t mode) {
	
	CR_MR = mode;
	data[2]	= CR_MR;
}


void hmc5883l_init(void) {
	
	CR_A_init(AVERAGE_1, DATARATE_15, BAIS_NORMAL);
	CR_B_init(GAIN_1090);
	CR_MR_init(MODE_SINGLE);
	writeByte(CR_SLA_W, CR_RA_A, 3, data[0]);
	hmc5883l_readRegister_init(CR_SLA_W, CR_RA_DO_XH);
	readByte(CR_SLA_R, CR_RA_DO_XH, 1, datar[1]);
}


void hmc5883l_readRegister_init(uint8_t devAddr, uint8_t regAddr) {
	
		TWCR = (1 << TWINT) | (1 << TWSTA) | (1 << TWEN);
		while (!(TWCR & (1<<TWINT)));
		if ((TWSR & TW_NO_INFO) != TW_REPEATED_START){PORTB &= ~(1 << PORTB1);
		ERROR();}
		
		TWDR = devAddr;
		TWCR = (1<<TWINT) | (1<<TWEN);
		while (!(TWCR & (1<<TWINT)));
		if ((TWSR & TW_NO_INFO) != TW_MT_SLA_ACK){/*PORTD &= ~(1 << PORTD6);*/
		ERROR();}
		
		TWDR = regAddr;
		TWCR = (1<<TWINT) | (1<<TWEN);
		while (!(TWCR & (1<<TWINT)));
		if ((TWSR & TW_NO_INFO) != TW_MT_DATA_ACK){/*PORTD &= ~(1 << PORTD6);*/
		ERROR();}
}






void twi_init(void) {

	TWSR =  (1 <<TWPS1) | (1 << TWPS0);
	TWBR = ((F_CPU/F_TW_SCL)-16)/2;
		
}





void writeByte(uint8_t devAddr, uint8_t regId, uint8_t bytesOfData, uint8_t data[0]) {
 
	TWCR = (1 << TWINT) | (1 << TWSTA) | (1 << TWEN);
	while (!(TWCR & (1<<TWINT)));
		if ((TWSR & TW_NO_INFO) != TW_START)
			ERROR();
	TWDR = devAddr;
	TWCR = (1<<TWINT) | (1<<TWEN);
	
	while (!(TWCR & (1<<TWINT)));
		if ((TWSR & TW_NO_INFO) != TW_MT_SLA_ACK)
			ERROR();
	TWDR = regId;
	TWCR = (1<<TWINT) | (1<<TWEN);

	for (int i = 0; bytesOfData > i; i++)
	{
		while (!(TWCR & (1<<TWINT)));
			if ((TWSR & TW_NO_INFO) != TW_MT_DATA_ACK)
			ERROR();
		TWDR = data[i];
		TWCR = (1<<TWINT) | (1<<TWEN);
	}

	while (!(TWCR & (1<<TWINT)));
		if ((TWSR & TW_NO_INFO) != TW_MT_DATA_ACK)
			ERROR();
 	
 	TWCR = (1<<TWINT) | (1<<TWEN) | (1<<TWSTO);
// 	/*volatile nop();*/
// 	while (!(TWCR & (1<<TWSTO))){PORTB &= ~(1 << PORTB1);} 

}






void ERROR(void) {
	  PORTB &= ~(1 << PORTB2);
// 	if ((TWSR & TW_NO_INFO) != TW_REPEATED_START)
// 	{
// 		PORTD &= ~(1 << PORTD6);
// 	}
}





void readByte(uint8_t devAddr, uint8_t regId, uint8_t bytesOfData, uint8_t *datar[]) {

  	TWCR = (1 << TWINT) | (1 << TWSTA) | (1 << TWEN);
  	while (!(TWCR & (1<<TWINT)));
  		if ((TWSR & TW_NO_INFO) != TW_REPEATED_START){/*PORTB &= ~(1 << PORTB1)*/
 			 ERROR();} 
 			
 	TWDR = devAddr;
 	TWCR = (1<<TWINT) | (1<<TWEN);
 	while (!(TWCR & (1<<TWINT)));
 		if ((TWSR & TW_NO_INFO) != TW_MR_SLA_ACK){/*PORTD &= ~(1 << PORTD6);*/
 			ERROR();}
	
	TWCR = (1<<TWINT) | (1<<TWEA) | (1<<TWEN);		 
	while (!(TWCR & (1<<TWINT)));		 
		if ((TWSR & TW_NO_INFO) != TW_MR_DATA_ACK){/*PORTD &= ~(1 << PORTD6);*/
		ERROR();}	
			DATA0 = TWDR;	
	
	TWCR = (1<<TWINT) | (1<<TWEA) | (1<<TWEN);
	while (!(TWCR & (1<<TWINT)));
	if ((TWSR & TW_NO_INFO) != TW_MR_DATA_ACK){/*PORTD &= ~(1 << PORTD6);*/
	ERROR();}
	DATA1 = TWDR;
	
	TWCR = (1<<TWINT) | (1<<TWEA) | (1<<TWEN);
	while (!(TWCR & (1<<TWINT)));
	if ((TWSR & TW_NO_INFO) != TW_MR_DATA_ACK){/*PORTD &= ~(1 << PORTD6);*/
	ERROR();}
	DATA2 = TWDR;
	
	TWCR = (1<<TWINT) | (1<<TWEA) | (1<<TWEN);
	while (!(TWCR & (1<<TWINT)));
	if ((TWSR & TW_NO_INFO) != TW_MR_DATA_ACK){/*PORTD &= ~(1 << PORTD6);*/
	ERROR();}
	DATA3 = TWDR;
	
	TWCR = (1<<TWINT) | (1<<TWEA) | (1<<TWEN);
	while (!(TWCR & (1<<TWINT)));
	if ((TWSR & TW_NO_INFO) != TW_MR_DATA_ACK){/*PORTD &= ~(1 << PORTD6);*/
	ERROR();}
	DATA4 = TWDR;
	
	TWCR = (1<<TWINT) | (1<<TWEN);
	while (!(TWCR & (1<<TWINT)));
		if ((TWSR & TW_NO_INFO) != TW_MR_DATA_NACK){/*PORTD &= ~(1 << PORTD6);*/
		ERROR();}
			DATA5 = TWDR;
			
//  	TWDR = regId;
//  	TWCR = (1<<TWINT) | (1<<TWEN);

//  	for (int i = 0; bytesOfData > i; i++)
//  	{
//  		while (!(TWCR & (1<<TWINT)));
//  			if ((TWSR & TW_NO_INFO) != TW_MR_DATA_ACK){/*PORTD &= ~(1 << PORTD6);*/
//  			/*ERROR();*/}
//  		datar[i] = TWDR;
//  		TWCR = (1<<TWINT) | (1<<TWEN);
//  	}
 
//  	while (!(TWCR & (1<<TWINT)));
//  		if ((TWSR & TW_NO_INFO) != TW_MR_DATA_ACK)
//  			ERROR();
 	TWCR = (1<<TWINT) | (1<<TWEN) | (1<<TWSTO);
 
 	
}









// void readByte(uint8_t devAddr, uint8_t regId, uint8_t bytesOfData, uint8_t datar[]) {
//
// 	TWCR = (1 << TWINT) | (1 << TWSTA) | (1 << TWEN);
// 	while (!(TWCR & (1<<TWINT)));
// 	if ((TWSR & TW_NO_INFO) != TW_REPEATED_START){PORTB &= ~(1 << PORTB1);
// 	ERROR();}
// 	TWDR = CR_SLA_W;
// 	TWCR = (1<<TWINT) | (1<<TWEN);
//
// 	while (!(TWCR & (1<<TWINT)));
// 	if ((TWSR & TW_NO_INFO) != TW_MT_SLA_ACK){PORTD &= ~(1 << PORTD6);
// 	ERROR();}
// 	TWDR = regId;
// 	TWCR = (1<<TWINT) | (1<<TWEN);
//
// 	while (!(TWCR & (1<<TWINT)));
// 	if ((TWSR & TW_NO_INFO) != TW_MT_DATA_ACK){PORTD &= ~(1 << PORTD6);
// 	ERROR();}
// 	TWDR = CR_SLA_R;
// 	TWCR = (1<<TWINT) | (1<<TWEN);
//
// 			while (!(TWCR & (1<<TWINT)));
// 			if ((TWSR & TW_NO_INFO) != TW_MR_SLA_ACK){/*PORTD &= ~(1 << PORTD6);*/
// 			ERROR();}
//
// // 	for (int i = 0; bytesOfData > i; i++)
// // 	{
// //
// // 		datar[i] = TWDR;
// // 		TWCR = (1<<TWINT) | (1<<TWEN);
// // 	}
//
// 	while (!(TWCR & (1<<TWINT)));
// 	if ((TWSR & TW_NO_INFO) != TW_MR_DATA_ACK)
// 	/*ERROR();*/
// 	TWCR = (1<<TWINT) | (1<<TWEN) | (1<<TWSTO);
//
//
// }






// 
// void twi_mt_init(void) {
// 	
// /*	DDRD |= (1 << PORTD7) | (1 << PORTD4);*/
// 		
// 	TWCR = (1 << TWINT) | (1 << TWSTA) | (1 << TWEN);
// 	
// 	while (!(TWCR & (1<<TWINT)));
// 		if ((TWSR & 0xF8) != TW_START)
// 		ERROR();
// 		TWDR = CR_SLA_W;
// 		TWCR = (1<<TWINT) | (1<<TWEN);
// 	
// 	
// 	while (!(TWCR & (1<<TWINT)));
// 		if ((TWSR & 0xF8) != TW_MT_SLA_ACK)
// 		ERROR();
// 		TWDR = CR_RA_A;
// 		TWCR = (1<<TWINT) | (1<<TWEN);
// 	
// 	
// 	while (!(TWCR & (1<<TWINT)));
// 		if ((TWSR & 0xF8) != TW_MT_SLA_ACK)
// 		ERROR();
// 		TWDR = CR_CR_A;
// 		TWCR = (1<<TWINT) | (1<<TWEN);
// 	
// 	
// 	while (!(TWCR & (1<<TWINT)));
// 		if ((TWSR & 0xF8) != TW_MT_SLA_ACK)
// 		ERROR();
// 		TWDR = CR_CR_B;
// 		TWCR = (1<<TWINT) | (1<<TWEN);
// 	
// 	
// 	while (!(TWCR & (1<<TWINT)));
// 		if ((TWSR & 0xF8) != TW_MT_SLA_ACK)
// 		ERROR();
// 		TWDR = CR_MR;
// 		TWCR = (1<<TWINT) | (1<<TWEN);
// 
// 	
// 	while (!(TWCR & (1<<TWINT)));
// 		if ((TWSR & 0xF8) != TW_MT_DATA_ACK)
// 		ERROR();
// 		TWCR = (1<<TWINT) | (1<<TWEN) | (1<<TWSTO);
// }
// 
// 
// 
// void twi_mr_init(void) {
// 	
// 	DDRD |= (1 << PORTD7) | (1 << PORTD4);
// 	
// 	TWCR = (1 << TWINT) | (1 << TWSTA) | (1 << TWEN);
// 	
// 	while  (!(TWCR & (1<<TWINT)));
// 	if ((TWSR & 0xF8) != TW_START)
// 	ERROR();
// 	TWDR = CR_SLA_R;
// 	TWCR = (1<<TWINT) | (1<<TWEN);
// 	
// 	
// 	while (!(TWCR & (1<<TWINT)));
// 	if ((TWSR & 0xF8) != TW_MR_SLA_ACK)
// 	ERROR();
// 	DATA = TWDR;
// 	TWCR = (1<<TWINT) | (1<<TWEN);
// 	
// 	
// 	while (!(TWCR & (1<<TWINT)));
// 	if ((TWSR & 0xF8) != TW_MR_DATA_ACK)
// 	ERROR();
// 	TWCR = (1<<TWINT) | (1<<TWEN) | (1<<TWSTO);
// 	
// }
// 
// 
// 
// 
// 
// 
// 
// 
// 
// 
// 
// 
// 
// 
// 






// void ExtInt_init(void) {
// 	
// 	
// }
// 
// 
// void adc_init(void) {
// 	
// 	ADMUX = (1 << REFS0);
// 	
// 	ADCSRA = (1 << ADPS1) | (1 << ADPS0);
// 	ADCSRA = (1 << ADEN);
// 	
// 	ADCSRA |= (1 << ADSC);
// 	while(ADCSRA & (1 << ADSC)) {
// 	}
// 	
// 	(void)ADCW;
// 	
// }
// 
// uint16_t ADC_Read(uint8_t channel) {
// 	ADMUX = (ADMUX & ~(0x1F)) | (channel & 0x1F);
// 	ADCSRA |= (1<<ADSC);
// 	while (ADCSRA & (1<<ADSC)) {
// 	}
// 	return ADCW;
// }