 /*
 * GccApplication24.c
 *
 * Created: 08.03.2015 10:06:54
 *  Author: Fabio
 */ 


#include <avr/io.h>
#include <util/twi.h>
#include <util/delay.h>
#define F_CPU					8000000UL
#define F_TW_SCL				100000L

#define TW_PRESCALE_1			(1 <<TWPS1) | (1 << TWPS0)
#define TW_BITRATE				((F_CPU/F_TW_SCL)-16)/2


#define TWI_START				0x08
#define TWI_REPEATED_START		0x10
#define TWI_NO_INFO				0xF8
#define TWI_STOP					(1<<TWINT) | (1<<TWEN) | (1<<TWSTO)
#define TWI_STATUS_MASK			(TWSR & TW_NO_INFO)
#define TWI_INT_FLAG				(TWCR & (1<<TWINT))


#define TW_MT_SLA_ACK			0x18
#define TW_MT_SLA_NACK			0x20
#define TW_MT_DATA_ACK			0x28
#define TW_MT_DATA_NACK			0x30
#define TW_MT_ARBITRATION		0x38

#define TW_MT_START				(1 << TWINT) | (1 << TWSTA) | (1 << TWEN)
#define TW_MT_SEND_DATA_ACK		(1<<TWINT) | (1<<TWEN)


#define TW_MR_ARBITRATION		0x38
#define TW_MR_SLA_ACK			0x40
#define TW_MR_SLA_NACK			0x48
#define TW_MR_DATA_ACK			0x50
#define TW_MR_DATA_NACK			0x58

#define TW_MR_START				(1 << TWINT) | (1 << TWSTA) | (1 << TWEN)
#define TW_MR_RECEIVE_DATA_ACK	(1<<TWINT) | (1<<TWEA) | (1<<TWEN)
#define TW_MR_RECEIVE_DATA_NACK	(1<<TWINT) | (1<<TWEN)










#define AVERAGE_BIT  6
#define AVERAGE_LENGHT  2

#define AVERAGE_1  0x00
#define AVERAGE_2  0x01
#define AVERAGE_4  0x02
#define AVERAGE_8  0x03



#define DATARATE_BIT  4
#define DATARATE_LENGHT  3

#define DATARATE_0_75  0x00
#define DATARATE_1_5  0x20
#define DATARATE_3  0x40
#define DATARATE_7_5  0x60
#define DATARATE_15  0x80
#define DATARATE_30  0xA0
#define DATARATE_75  0xC0



#define BIAS_BIT  1
#define BIAS_LENGHT  2

#define BIAS_NORMAL  0x00
#define BIAS_POSITIV  0x01
#define BIAS_NEGATIV  0x02



#define GAIN_BIT  7
#define GAIN_LENGHT  3

#define GAIN_1370 0x00
#define GAIN_1090 0x01
#define GAIN_820 0x02
#define GAIN_660 0x03
#define GAIN_440 0x04
#define GAIN_390 0x05
#define GAIN_330 0x06
#define GAIN_220 0x07



#define MODE_BIT  1
#define MODE_LENGHT  2

#define MODE_CONTINUOUS  0x00
#define MODE_SINGLE  0x01
#define MODE_IDLE  0x02



#define STATUS_BIT    0
#define STATUS_LENGHT    1
	
#define STATUS_VAL   0x01



#define CR_SLA_W 0x3C
#define CR_SLA_R 0x3D

#define CR_RA_A  0x00
#define CR_RA_B  0x01
#define CR_RA_MR  0x02
#define CR_RA_DO_XH  0x03
#define CR_RA_DO_XL  0x04
#define CR_RA_DO_YH  0x05
#define CR_RA_DO_YL  0x06
#define CR_RA_DO_ZH  0x07
#define CR_RA_DO_ZL  0x08
#define CR_RA_SR  0x09
#define CR_RA_IR_A  0x0A
#define CR_RA_IR_B  0x0B
#define CR_RA_IR_C  0x0C

uint8_t CR_A;
uint8_t CR_B;
uint8_t CR_MR;
uint8_t CR_SR;




uint8_t DATA5 = 0;
uint8_t DATA4 = 0;
uint8_t DATA3 = 0;
uint8_t DATA2 = 0;
uint8_t DATA1 = 0;
uint8_t DATA0 = 0;
uint8_t data_W[];
uint8_t data_R[];


uint8_t status = 0;




int main(void)
{

	DDRD |= ((1 << PORTD3) | (1 << PORTD5));
	PORTD |= ((1 << PORTD3) | (1 << PORTB5));
	
	DDRB |= (1 << PORTB3);
	PORTB |= (1 << PORTB3);
	
	twi_init();
	hmc5883l_init(AVERAGE_8, DATARATE_15, BIAS_NORMAL, GAIN_1090, MODE_SINGLE);
	hmc5883l_config_reg(CR_SLA_W, CR_RA_A, 3, data_W[0]);
	hmc5883l_read_datareg(CR_SLA_R, 6, data_R[0]);
	
	CR_SR_init(STATUS_VAL);
	
	
	while(1)
	{
		uint16_t DATA01 = (((uint16_t)DATA0) << 8) | DATA1;
		
		if (DATA0 >= (uint8_t)127)
		{
			PORTB &= ~(1 << PORTB1);
			
		}else
		{
		PORTB &= ~(1 << PORTB2);
		}
		
		if (DATA1 <= (uint8_t)127)
		{
			PORTD &= ~(1 << PORTD6);
		}else
		{
		PORTB &= ~(1 << PORTB2);
		}
		
		if (DATA01 <= (uint16_t)32000)
		{
			PORTB &= ~(1 << PORTB2);
		}
		
		get_CR_SR(CR_SLA_W, CR_SLA_R, CR_RA_SR);
		/*status = (status << (STATUS_BIT - STATUS_LENGHT + 1));*/
		if ((status & STATUS_VAL))
		{/*PORTB &= ~(1 << PORTB1);PORTB |= (1 << PORTB1);*/
/*hmc5883l_config_reg(CR_SLA_W, CR_RA_A, 3, data_W[0]);*/
point_to_datareg(CR_SLA_W, CR_RA_DO_XH);
hmc5883l_read_datareg(CR_SLA_R, 6, data_R[0]);
		
		PORTB |= (1 << PORTB1);
		PORTD |= (1 << PORTD6);
		PORTB |= (1 << PORTB2);
		}
		
		
		
	}
}

void point_to_datareg(uint8_t devAddr, uint8_t regAddr) {
	
		TWCR = TW_MT_START;
		while (!TWI_INT_FLAG);
		if (TWI_STATUS_MASK != TWI_REPEATED_START)
		ERROR();
		
		TWDR = devAddr;
		TWCR = TW_MT_SEND_DATA_ACK;
		while (!TWI_INT_FLAG);
		if (TWI_STATUS_MASK != TW_MT_SLA_ACK)
		ERROR();
		
		TWDR = regAddr;
		TWCR = TW_MT_SEND_DATA_ACK;
		while (!TWI_INT_FLAG);
		if (TWI_STATUS_MASK != TW_MT_DATA_ACK)
		ERROR();
	
}


void hmc5883l_config_reg(uint8_t devAddr, uint8_t regAddr, uint8_t dataByte, uint8_t *data_W[]) {
	
	TWCR = TW_MT_START;
	while (!TWI_INT_FLAG);
	if (TWI_STATUS_MASK != TWI_START)
	ERROR();
	
	TWDR = devAddr;
	TWCR = TW_MT_SEND_DATA_ACK;
	while (!TWI_INT_FLAG);
	if (TWI_STATUS_MASK != TW_MT_SLA_ACK)
	ERROR();
	
	TWDR = regAddr;
	TWCR = TW_MT_SEND_DATA_ACK;
	while (!TWI_INT_FLAG);
	if (TWI_STATUS_MASK != TW_MT_DATA_ACK)
	ERROR();
	
	for (int i = 0; dataByte >= i; i++)
	{
		TWDR = *data_W[i];
		TWCR = TW_MT_SEND_DATA_ACK;
		while (!TWI_INT_FLAG);
		if (TWI_STATUS_MASK != TW_MT_DATA_ACK)
		ERROR();
	}
	
	TWCR = (1<<TWINT) | (1<<TWEN) | (1<<TWSTO);

}





void hmc5883l_read_datareg(uint8_t devAddr, uint8_t dataByte, uint8_t *data_R[0]) {
	
// 	data_R[dataByte];
 	uint8_t lastBit = dataByte;
	
	TWCR = TW_MT_START;
	while (!TWI_INT_FLAG);
	if (TWI_STATUS_MASK != TWI_REPEATED_START)
	ERROR();
	
	TWDR = devAddr;
	TWCR = TW_MT_SEND_DATA_ACK;
	while (!TWI_INT_FLAG);
	if (TWI_STATUS_MASK != TW_MR_SLA_ACK)
	ERROR();
	
		TWCR = TW_MR_RECEIVE_DATA_ACK;
		while (!TWI_INT_FLAG);
		if (TWI_STATUS_MASK != TW_MR_DATA_ACK)
		ERROR();
		DATA0 = TWDR;
		
		TWCR = TW_MR_RECEIVE_DATA_ACK;
		while (!TWI_INT_FLAG);
		if (TWI_STATUS_MASK != TW_MR_DATA_ACK)
		ERROR();
		DATA1 = TWDR;
		
		TWCR = TW_MR_RECEIVE_DATA_ACK;
		while (!TWI_INT_FLAG);
		if (TWI_STATUS_MASK != TW_MR_DATA_ACK)
		ERROR();
		DATA2 = TWDR;
		
		TWCR = TW_MR_RECEIVE_DATA_ACK;
		while (!TWI_INT_FLAG);
		if (TWI_STATUS_MASK != TW_MR_DATA_ACK)
		ERROR();
		DATA3 = TWDR;
		
		TWCR = TW_MR_RECEIVE_DATA_ACK;
		while (!TWI_INT_FLAG);
		if (TWI_STATUS_MASK != TW_MR_DATA_ACK)
		ERROR();
		DATA4 = TWDR;
		
		TWCR = TW_MR_RECEIVE_DATA_NACK;
		while (!TWI_INT_FLAG);
		if (TWI_STATUS_MASK != TW_MR_DATA_NACK)
		ERROR();
		DATA5 = TWDR;
										
// 	for (int i = 0; (dataByte-1) > i; i++)
// 	{
// 		TWCR = TW_MR_RECEIVE_DATA_ACK;
// 		while (!TWI_INT_FLAG);
// 		if (TWI_STATUS_MASK != TW_MR_DATA_ACK)
// 		ERROR();
// 		data_R[i] = TWDR;
// 	}
// 	
//  	TWCR = TW_MR_RECEIVE_DATA_NACK;
//  	while (!TWI_INT_FLAG);
//  	if (TWI_STATUS_MASK != TW_MR_DATA_NACK)
//  	/*ERROR()*/;
//  	data_R[lastBit] = TWDR;
	
	TWCR = (1<<TWINT) | (1<<TWEN) | (1<<TWSTO);
	return *data_R[0];
}



void ERROR(void) {
	
	PORTB &= ~(1 << PORTB2);PORTB &= ~(1 << PORTB1);PORTD &= ~(1 << PORTD6);
}





// 	TWCR = TW_MR_RECEIVE_DATA_ACK;
// 	while (!TWI_INT_FLAG);
// 	if (TWI_STATUS_MASK != TW_MR_DATA_ACK){/*PORTD &= ~(1 << PORTD6);*/
// 	ERROR();}
// 	DATA1 = TWDR;
//
// 	TWCR = TW_MR_RECEIVE_DATA_NACK;
// 	while (!TWI_INT_FLAG);
// 	if (TWI_STATUS_MASK != TW_MR_DATA_NACK){/*PORTD &= ~(1 << PORTD6);*/
// 	ERROR();}
// 	DATA2 = TWDR;




//(uint8_t average, uint8_t datarate, uint8_t bias, uint8_t gain, uint8_t mode)
// writeByte(CR_SLA_W, CR_RA_A, 3, data[0]);
// hmc5883l_readRegister_init(CR_SLA_W, CR_RA_DO_XH);
// readByte(CR_SLA_R, CR_RA_DO_XH, 1, datar[1]);


























void twi_init(void) {

	TWSR =  TW_PRESCALE_1;
	TWBR = TW_BITRATE;
	
}













//
// writeByte(CR_SLA_W, CR_RA_A, 3, data[0]);
// hmc5883l_readRegister_init(CR_SLA_W, CR_RA_DO_XH);
// readByte(CR_SLA_R, CR_RA_DO_XH, 1, datar[1]);





void hmc5883l_init(uint8_t average, uint8_t datarate, uint8_t bias, uint8_t gain, uint8_t mode) {
	
	CR_A_init(average, datarate, bias);
	CR_B_init(gain);
	CR_MR_init(mode);
	
}



void CR_A_init(uint8_t average, uint8_t rate, uint8_t bias) {

	CR_A = (average << (AVERAGE_BIT - AVERAGE_LENGHT + 1)) |
	(rate << (DATARATE_BIT - DATARATE_LENGHT + 1)) |
	(bias << (BIAS_BIT - BIAS_LENGHT + 1));
	data_W[0]	= CR_A;
}


void CR_B_init(uint8_t gain) {

	CR_B = gain;
	data_W[1]	= CR_B;
}

void CR_MR_init(uint8_t mode) {
	
	CR_MR = mode;
	data_W[2]	= CR_MR;
}


void CR_SR_init(uint8_t status) {
	
	CR_SR = (status << (STATUS_BIT - STATUS_LENGHT + 1));
}

void get_CR_SR(uint8_t devAddrW, uint8_t devAddrR,uint8_t regAddr) {
	
	TWCR = TW_MT_START;
	while (!TWI_INT_FLAG);
	if (TWI_STATUS_MASK != TWI_REPEATED_START)
	ERROR();
	
	TWDR = devAddrW;
	TWCR = TW_MT_SEND_DATA_ACK;
	while (!TWI_INT_FLAG);
	if (TWI_STATUS_MASK != TW_MT_SLA_ACK)
	ERROR();
	
	TWDR = regAddr;
	TWCR = TW_MT_SEND_DATA_ACK;
	while (!TWI_INT_FLAG);
	if (TWI_STATUS_MASK != TW_MT_DATA_ACK)
	ERROR();	
	
	TWDR = devAddrR;
	TWCR = TW_MT_SEND_DATA_ACK;
	while (!TWI_INT_FLAG);
	if (TWI_STATUS_MASK != TW_MT_DATA_ACK)
	ERROR();
	
	TWCR = TW_MR_RECEIVE_DATA_NACK;
	while (!TWI_INT_FLAG);
	if (TWI_STATUS_MASK != TW_MT_DATA_ACK)
	ERROR();
	status = TWDR;
		
}



