/*
 * GccApplication6.c
 *
 * Created: 29.05.2014 16:37:04
 *  Author: Fabio
 */ 


#include <avr/io.h>
#include <avr/interrupt.h>

#define F_CPU 8000000UL

#include <util/delay.h>


double dutyCycleRed = 100;
double dutyCycleGreen = 100;
double dutyCycleBlue = 100;

int r = 0;

double i = 100;
double dcr = 0;
double dcg = 0;
double dcb = 0;


int main(void)
{
	  // PB1/OC1A as PWM output for blue led
	  // PB2/OC1B as PWM output for red led
	  DDRB = (1 << PORTB1/*OC1A*/) | (1 << PORTB2/*OC1B*/);

	  // PD6/OC0A as PWM output for green led
	  DDRD = (1 << PORTD6/*OC0A*/) | (1 << PORTD0) | (1 << PORTD1) | (1 << PORTD3) | (1 << PORTD4) | (1 << PORTD5) | (1 << PORTD7);
	  PORTD = (1 << PD7);
	  TCCR0A = (1 << COM0A1) | (1 << WGM00) | (1 << WGM01);
	  TCCR1A = (1 << COM1A1) | (1 << COM1B1) | (1 << WGM10);
	
	  TIMSK0 = (1 << TOIE0);
	  TIMSK1 = (1 << TOIE1);
	  
	  sei();
	  
	  TCCR0B = (1 << CS00);
	  TCCR1B = (1 << CS10) | (1 << WGM12);
	  
    while(1)
    {   
		
		
		
		  i -= 1;      // Increment counter
		  if (i > 600) // First phase of fades
		  {
			  dutyCycleRed   -= 1; // Red down
			  dutyCycleGreen += 1; // Green up
			  dutyCycleBlue   = 100; // Blue low
		  }
		  else if (i > 500) // Second phase of fades
		  {
			  dutyCycleRed    = 100; // Red low
			  dutyCycleGreen -= 1; // Green down
			  dutyCycleBlue  += 1; // Blue up
		  }
		  else if (i > 400) // Third phase of fades
		  {
			  dutyCycleRed  += 1; // Red up
			  dutyCycleGreen = 100; // Green low
			  dutyCycleBlue -= 1; // Blue down
		  }
		  else if (i > 300) // Third phase of fades
		  {
			  dutyCycleRed   += 1; // Red up
			  dutyCycleGreen -= 1; // Green low
			  dutyCycleBlue   = 100; // Blue down
		  }
		  else if (i > 200) // Third phase of fades
		  {
			  dutyCycleRed    = 100; // Red up
			  dutyCycleGreen += 1; // Green low
			  dutyCycleBlue  -= 1; // Blue down
		  }
		  else if (i > 100) // Third phase of fades
		  {
			  dutyCycleRed  -= 1; // Red up
			  dutyCycleGreen = 100; // Green low
			  dutyCycleBlue += 1; // Blue down
		  }		  
		  else // Re-set the counter, and start the fades again
		  {
			  i = 600;
		  }
		  
			_delay_ms(100);
		
				
				OCR0A = (dutyCycleGreen/100.0)*255.0;
				
				OCR1AH = 0x00;
				OCR1AL = (dutyCycleBlue/100.0)*255.0;
				
				OCR1BH = 0x00;
				OCR1BL = (dutyCycleRed/100.0)*255.0;
    }
}

ISR(TIMER0_OVF_vect)
{/*
	OCR0A = (dutyCycleGreen/100.0)*255.0;
	*/
}

ISR(TIMER1_OVF_vect)
{
/*	OCR1AH = 0x00;
	OCR1AL = (dutyCycleBlue/100.0)*255.0;
	OCR1BH = 0x00;
	OCR1BL = (dutyCycleRed/100.0)*255.0;
	*/
}