/*
 * DatabaseManegmentFlags.cpp
 *
 * Created: 30.08.2015 22:51:15
 *  Author: Fabio
 */ 


#include "DatabaseManegmentFlags.h"



volatile uint32_t DatabaseManegmentFlags::DataAndRuleFlags_TX = 0;
volatile uint32_t DatabaseManegmentFlags::DataAndRuleFlags_RX = 0;


databaseFlags_TX_t databaseFlags_TX;
databaseFlags_RX_t databaseFlags_RX;
irCommFlags_t irCommFlags;




DatabaseManegmentFlags::DatabaseManegmentFlags(){}
	
	



void DatabaseManegmentFlags::initialize()
{
	databaseFlags_TX.databaseFlag_TX = 0;
	databaseFlags_TX.databaseEmptyFlag_TX = 1;
	databaseFlags_TX.targetDatabaseFlag_TX = 0;
	databaseFlags_TX.environmentDatabaseFlag_TX = 0;
	databaseFlags_TX.coordinatesDatabaseFlag_TX = 0;
	databaseFlags_TX.positionDatabaseFlag_TX = 0;
	databaseFlags_TX.lightDatabaseFlag_TX = 0;
	databaseFlags_TX.colorDatabaseFlag_TX = 0;
	databaseFlags_TX.speedDatabaseFlag_TX = 0;
	databaseFlags_TX.compassDatabaseFlag_TX = 0;
	databaseFlags_TX.reserveDatabaseFlag_TX = 0;
	databaseFlags_TX.noNewDataFlag_TX = 0;
	
	databaseFlags_RX.databaseFlag_RX = 0;
	databaseFlags_RX.databaseEmptyFlag_RX = 0;
	databaseFlags_RX.targetDatabaseFlag_RX = 0;
	databaseFlags_RX.environmentDatabaseFlag_RX = 0;
	databaseFlags_RX.coordinatesDatabaseFlag_RX = 0;
	databaseFlags_RX.positionDatabaseFlag_RX = 0;
	databaseFlags_RX.lightDatabaseFlag_RX = 0;
	databaseFlags_RX.colorDatabaseFlag_RX = 0;
	databaseFlags_RX.speedDatabaseFlag_RX = 0;
	databaseFlags_RX.compassDatabaseFlag_RX = 0;
	databaseFlags_RX.reserveDatabaseFlag_RX = 0;
	databaseFlags_RX.noNewDataFlag_RX = 0;
	
	irCommFlags.oppenentId = 1;
}




bool DatabaseManegmentFlags::checkDatabaseFlag_TX()
{
	if (!(databaseFlags_TX.databaseFlag_TX == 0))
	{
		return true;
	} 
	else
	{
		return false;
	}
}

void DatabaseManegmentFlags::setDatabaseFlag_TX()
{
	databaseFlags_TX.databaseFlag_TX = 1;
}

void DatabaseManegmentFlags::clearDatabaseFlag_TX()
{
	databaseFlags_TX.databaseFlag_TX = 0;
}

bool DatabaseManegmentFlags::checkDatabaseFlag_RX()
{
	if (!(databaseFlags_RX.databaseFlag_RX == 0))
	{
		return true;
	}
	else
	{
		return false;
	}
}

void DatabaseManegmentFlags::setDatabaseFlag_RX()
{
	databaseFlags_RX.databaseFlag_RX = 1;
}

void DatabaseManegmentFlags::clearDatabaseFlag_RX()
{
	databaseFlags_RX.databaseFlag_RX = 0;
}




bool DatabaseManegmentFlags::checkDatabaseIsntEmptyFlag_TX()
{
	if (!(databaseFlags_TX.databaseEmptyFlag_TX == 0))
	{
		return true;
	}
	else
	{
		return false;
	}
}

void DatabaseManegmentFlags::setDatabaseIsntEmptyFlag_TX()
{
	databaseFlags_TX.databaseEmptyFlag_TX = 1;
}

void DatabaseManegmentFlags::clearDatabaseIsntEmptyFlag_TX()
{
	databaseFlags_TX.databaseEmptyFlag_TX = 0;
}

bool DatabaseManegmentFlags::checkDatabaseIsntEmptyFlag_RX()
{
	if (!(databaseFlags_RX.databaseEmptyFlag_RX == 0))
	{
		return true;
	}
	else
	{
		return false;
	}
}

void DatabaseManegmentFlags::setDatabaseIsntEmptyFlag_RX()
{
	databaseFlags_RX.databaseEmptyFlag_RX = 1;
}

void DatabaseManegmentFlags::clearDatabaseIsntEmptyFlag_RX()
{
	databaseFlags_RX.databaseEmptyFlag_RX = 0;
}




bool DatabaseManegmentFlags::checkTargetDatabaseFlag_TX()
{
	if (!(databaseFlags_TX.targetDatabaseFlag_TX == 0))
	{
		return true;
	}
	else
	{
		return false;
	}
}

void DatabaseManegmentFlags::setTargetDatabaseFlag_TX()
{
	DataAndRuleFlags_TX |= 0x20000;
	databaseFlags_TX.targetDatabaseFlag_TX = 1;
}

void DatabaseManegmentFlags::clearTargetDatabaseFlag_TX()
{
	DataAndRuleFlags_TX &= ~0x20000;
	databaseFlags_TX.targetDatabaseFlag_TX = 0;
}

bool DatabaseManegmentFlags::checkTargetDatabaseFlag_RX()
{
	if (!(databaseFlags_RX.targetDatabaseFlag_RX == 0))
	{
		return true;
	}
	else
	{
		return false;
	}
}

void DatabaseManegmentFlags::setTargetDatabaseFlag_RX()
{
	databaseFlags_RX.targetDatabaseFlag_RX = 1;
}

void DatabaseManegmentFlags::clearTargetDatabaseFlag_RX()
{
	databaseFlags_RX.targetDatabaseFlag_RX = 0;
}





bool DatabaseManegmentFlags::checkEnvironmentDatabaseFlag_TX()
{
	if (!(databaseFlags_TX.environmentDatabaseFlag_TX == 0))
	{
		return true;
	}
	else
	{
		return false;
	}
}

void DatabaseManegmentFlags::setTEnvironmentDatabaseFlag_TX()
{
	DataAndRuleFlags_TX |= 0x10000;
	databaseFlags_TX.environmentDatabaseFlag_TX = 1;
}

void DatabaseManegmentFlags::clearEnvironmentDatabaseFlag_TX()
{
	DataAndRuleFlags_TX &= ~0x10000;
	databaseFlags_TX.environmentDatabaseFlag_TX = 0;
}

bool DatabaseManegmentFlags::checkEnvironmentDatabaseFlag_RX()
{
	if (!(databaseFlags_RX.environmentDatabaseFlag_RX == 0))
	{
		return true;
	}
	else
	{
		return false;
	}
}

void DatabaseManegmentFlags::setEnvironmentDatabaseFlag_RX()
{
	databaseFlags_RX.environmentDatabaseFlag_RX = 1;
}

void DatabaseManegmentFlags::clearEnvironmentDatabaseFlag_RX()
{
	databaseFlags_RX.environmentDatabaseFlag_RX = 0;
}




bool DatabaseManegmentFlags::checkCoordinatesDatabaseFlag_TX()
{
	if (!(databaseFlags_TX.coordinatesDatabaseFlag_TX == 0))
	{
		return true;
	}
	else
	{
		return false;
	}
}

void DatabaseManegmentFlags::setCoordinatesDatabaseFlag_TX()
{
	DataAndRuleFlags_TX |= 0x8000;
	databaseFlags_TX.coordinatesDatabaseFlag_TX = 1;
}

void DatabaseManegmentFlags::clearCoordinatesDatabaseFlag_TX()
{
	DataAndRuleFlags_TX &= ~0x8000;
	databaseFlags_TX.coordinatesDatabaseFlag_TX = 0;
}

bool DatabaseManegmentFlags::checkCoordinatesDatabaseFlag_RX()
{
	if (!(databaseFlags_RX.coordinatesDatabaseFlag_RX == 0))
	{
		return true;
	}
	else
	{
		return true;
	}
}

void DatabaseManegmentFlags::setCoordinatesDatabaseFlag_RX()
{
	databaseFlags_RX.coordinatesDatabaseFlag_RX = 1;
}

void DatabaseManegmentFlags::clearCoordinatesDatabaseFlag_RX()
{
	databaseFlags_RX.coordinatesDatabaseFlag_RX = 0;
}



bool DatabaseManegmentFlags::checkPositionDatabaseFlag_TX()
{
	if (!(databaseFlags_TX.positionDatabaseFlag_TX == 0))
	{
		return true;
	}
	else
	{
		return false;
	}
}

void DatabaseManegmentFlags::setPositionDatabaseFlag_TX()
{
	DataAndRuleFlags_TX |= 0x4000;
	databaseFlags_TX.positionDatabaseFlag_TX = 1;
}

void DatabaseManegmentFlags::clearPositionDatabaseFlag_TX()
{
	DataAndRuleFlags_TX &= ~0x4000;
	databaseFlags_TX.positionDatabaseFlag_TX = 0;
}

bool DatabaseManegmentFlags::checkPositionDatabaseFlag_RX()
{
	if (!(databaseFlags_RX.positionDatabaseFlag_RX == 0))
	{
		return true;
	}
	else
	{
		return false;
	}
}

void DatabaseManegmentFlags::setPositionDatabaseFlag_RX()
{
	databaseFlags_RX.positionDatabaseFlag_RX = 1;
}

void DatabaseManegmentFlags::clearPositionDatabaseFlag_RX()
{
	databaseFlags_RX.positionDatabaseFlag_RX = 0;
}






bool DatabaseManegmentFlags::checkLightDatabaseFlag_TX()
{
	if (!(databaseFlags_TX.lightDatabaseFlag_TX == 0))
	{
		return true;
	}
	else
	{
		return false;
	}
}

void DatabaseManegmentFlags::setLightDatabaseFlag_TX()
{
	DataAndRuleFlags_TX |= 0x2000;
	databaseFlags_TX.lightDatabaseFlag_TX = 1;
}

void DatabaseManegmentFlags::clearLightDatabaseFlag_TX()
{
	DataAndRuleFlags_TX &= ~0x2000;
	databaseFlags_TX.lightDatabaseFlag_TX = 0;
}

bool DatabaseManegmentFlags::checkLightDatabaseFlag_RX()
{
	if (!(databaseFlags_RX.lightDatabaseFlag_RX == 0))
	{
		return true;
	}
	else
	{
		return false;
	}
}

void DatabaseManegmentFlags::setLightDatabaseFlag_RX()
{
	databaseFlags_RX.lightDatabaseFlag_RX = 1;
}

void DatabaseManegmentFlags::clearLightDatabaseFlag_RX()
{
	databaseFlags_RX.lightDatabaseFlag_RX = 0;
}




bool DatabaseManegmentFlags::checkColorDatabaseFlag_TX()
{
	if (databaseFlags_TX.colorDatabaseFlag_TX == 1)
	{
		return true;
	}
	else
	{
		return false;
	}
}

void DatabaseManegmentFlags::setColorDatabaseFlag_TX()
{
	DataAndRuleFlags_TX |= 0x1000;
	databaseFlags_TX.colorDatabaseFlag_TX = 1;
}

void DatabaseManegmentFlags::clearColorDatabaseFlag_TX()
{
	DataAndRuleFlags_TX &= ~0x1000;
	databaseFlags_TX.colorDatabaseFlag_TX = 0;
}

bool DatabaseManegmentFlags::checkColorDatabaseFlag_RX()
{
	if (!(databaseFlags_RX.colorDatabaseFlag_RX == 0))
	{
		return true;
	}
	else
	{
		return false;
	}
}

void DatabaseManegmentFlags::setColorDatabaseFlag_RX()
{
	databaseFlags_RX.colorDatabaseFlag_RX = 1;
}

void DatabaseManegmentFlags::clearColorDatabaseFlag_RX()
{
	databaseFlags_RX.colorDatabaseFlag_RX = 0;
}





bool DatabaseManegmentFlags::checkSpeedDatabaseFlag_TX()
{
	if (!(databaseFlags_TX.speedDatabaseFlag_TX == 0))
	{
		return true;
	}
	else
	{
		return false;
	}
}

void DatabaseManegmentFlags::setSpeedDatabaseFlag_TX()
{
	DataAndRuleFlags_TX |= 0x800;
	databaseFlags_TX.speedDatabaseFlag_TX = 1;
}

void DatabaseManegmentFlags::clearSpeedDatabaseFlag_TX()
{
	DataAndRuleFlags_TX &= ~0x800;
	databaseFlags_TX.speedDatabaseFlag_TX = 0;
}

bool DatabaseManegmentFlags::checkSpeedDatabaseFlag_RX()
{
	if (!(databaseFlags_RX.speedDatabaseFlag_RX == 0))
	{
		return true;
	}
	else
	{
		return false;
	}
}

void DatabaseManegmentFlags::setSpeedDatabaseFlag_RX()
{
	databaseFlags_RX.speedDatabaseFlag_RX = 1;
}

void DatabaseManegmentFlags::clearSpeedDatabaseFlag_RX()
{
	databaseFlags_RX.speedDatabaseFlag_RX = 0;
}





bool DatabaseManegmentFlags::checkCompassDatabaseFlag_TX()
{
	if (!(databaseFlags_TX.compassDatabaseFlag_TX == 0))
	{
		return true;
	}
	else
	{
		return false;
	}
}

void DatabaseManegmentFlags::setCompassDatabaseFlag_TX()
{
	DataAndRuleFlags_TX |= 0x400;
	databaseFlags_TX.compassDatabaseFlag_TX = 1;
}

void DatabaseManegmentFlags::clearCompassDatabaseFlag_TX()
{
	DataAndRuleFlags_TX &= ~0x400;
	databaseFlags_TX.compassDatabaseFlag_TX = 0;
}

bool DatabaseManegmentFlags::checkCompassDatabaseFlag_RX()
{
	if (!(databaseFlags_RX.compassDatabaseFlag_RX == 0))
	{
		return true;
	}
	else
	{
		return false;
	}
}

void DatabaseManegmentFlags::setCompassDatabaseFlag_RX()
{
	databaseFlags_RX.compassDatabaseFlag_RX = 1;
}

void DatabaseManegmentFlags::clearCompassDatabaseFlag_RX()
{
	databaseFlags_RX.compassDatabaseFlag_RX = 0;
}





bool DatabaseManegmentFlags::checkReserveDatabaseFlag_TX()
{
	if (!(databaseFlags_TX.reserveDatabaseFlag_TX == 0))
	{
		return true;
	}
	else
	{
		return false;
	}
}

void DatabaseManegmentFlags::setReserveDatabaseFlag_TX()
{
	DataAndRuleFlags_TX |= 0x200;
	databaseFlags_TX.reserveDatabaseFlag_TX = 1;
}

void DatabaseManegmentFlags::clearReserveDatabaseFlag_TX()
{
	DataAndRuleFlags_TX &= ~0x200;
	databaseFlags_TX.reserveDatabaseFlag_TX = 0;
}

bool DatabaseManegmentFlags::checkReserveDatabaseFlag_RX()
{
	if (!(databaseFlags_RX.reserveDatabaseFlag_RX == 0))
	{
		return true;
	}
	else
	{
		return false;
	}
}

void DatabaseManegmentFlags::setReserveDatabaseFlag_RX()
{
	databaseFlags_RX.databaseEmptyFlag_RX = 1;
}

void DatabaseManegmentFlags::clearReserveDatabaseFlag_RX()
{
	databaseFlags_RX.databaseEmptyFlag_RX = 0;
}




bool DatabaseManegmentFlags::checkNoNewDataFlag_TX()
{
	if (!(databaseFlags_TX.noNewDataFlag_TX == 0))
	{
		return true;
	}
	else
	{
		return false;
	}
}

void DatabaseManegmentFlags::setNoNewDataFlag_TX()
{
	databaseFlags_TX.noNewDataFlag_TX = 1;
}

void DatabaseManegmentFlags::getNoNewDatalag_TX()
{
	databaseFlags_TX.noNewDataFlag_TX = 0;
}

bool DatabaseManegmentFlags::checkNoNewDataFlag_RX()
{
	if (!(databaseFlags_RX.noNewDataFlag_RX == 0))
	{
		return true;
	}
	else
	{
		return false;
	}
}

void DatabaseManegmentFlags::setNoNewDataFlag_RX()
{
	databaseFlags_RX.noNewDataFlag_RX = 1;
}

void DatabaseManegmentFlags::getNoNewDataFlag_RX()
{
	databaseFlags_RX.noNewDataFlag_RX = 0;
}






bool DatabaseManegmentFlags::checkOppenentIdAvailableFlag()
{
	if (!(irCommFlags.oppenentId == 0))
	{
		return true;
	}
	else
	{
		return false;
	}
}

void DatabaseManegmentFlags::setOppenentIdAvailable()
{
	irCommFlags.oppenentId = 1;
}

void DatabaseManegmentFlags::clearOppenentIdAvailable()
{
	irCommFlags.oppenentId = 0;
}



void DatabaseManegmentFlags::checkIfDatabaseIsEmpty()
{
	if (checkTargetDatabaseFlag_TX() &&
	checkEnvironmentDatabaseFlag_TX() &&
	checkCoordinatesDatabaseFlag_TX() &&
	checkPositionDatabaseFlag_TX() &&
	checkLightDatabaseFlag_TX() &&
	checkColorDatabaseFlag_TX() &&
	checkSpeedDatabaseFlag_TX() &&
	checkCompassDatabaseFlag_TX())
	{
		setDatabaseIsntEmptyFlag_TX();
	}
	else
	{
		clearDatabaseIsntEmptyFlag_TX();
	}
}