/*
 * DatabaseManegmentFlags.h
 *
 * Created: 30.08.2015 22:51:24
 *  Author: Fabio
 */ 


#ifndef DATABASEMANEGMENTFLAGS_H_
#define DATABASEMANEGMENTFLAGS_H_

#include <avr/io.h>


class DatabaseManegmentFlags
{
	public:
	
	
	DatabaseManegmentFlags();
	
	
	void initialize();
	
	bool checkDatabaseFlag_TX();
	void setDatabaseFlag_TX();
	void clearDatabaseFlag_TX();
	bool checkDatabaseFlag_RX();
	void setDatabaseFlag_RX();
	void clearDatabaseFlag_RX();
	
	bool checkDatabaseIsntEmptyFlag_TX();
	void setDatabaseIsntEmptyFlag_TX();
	void clearDatabaseIsntEmptyFlag_TX();
	bool checkDatabaseIsntEmptyFlag_RX();
	void setDatabaseIsntEmptyFlag_RX();
	void clearDatabaseIsntEmptyFlag_RX();
	
	bool checkTargetDatabaseFlag_TX();
	void setTargetDatabaseFlag_TX();
	void clearTargetDatabaseFlag_TX();
	bool checkTargetDatabaseFlag_RX();
	void setTargetDatabaseFlag_RX();
	void clearTargetDatabaseFlag_RX();
	
	bool checkEnvironmentDatabaseFlag_TX();
	void setTEnvironmentDatabaseFlag_TX();
	void clearEnvironmentDatabaseFlag_TX();
	bool checkEnvironmentDatabaseFlag_RX();
	void setEnvironmentDatabaseFlag_RX();
	void clearEnvironmentDatabaseFlag_RX();
	
	bool checkCoordinatesDatabaseFlag_TX();
	void setCoordinatesDatabaseFlag_TX();
	void clearCoordinatesDatabaseFlag_TX();
	bool checkCoordinatesDatabaseFlag_RX();
	void setCoordinatesDatabaseFlag_RX();
	void clearCoordinatesDatabaseFlag_RX();
	
	bool checkPositionDatabaseFlag_TX();
	void setPositionDatabaseFlag_TX();
	void clearPositionDatabaseFlag_TX();
	bool checkPositionDatabaseFlag_RX();
	void setPositionDatabaseFlag_RX();
	void clearPositionDatabaseFlag_RX();
	
	bool checkLightDatabaseFlag_TX();
	void setLightDatabaseFlag_TX();
	void clearLightDatabaseFlag_TX();
	bool checkLightDatabaseFlag_RX();
	void setLightDatabaseFlag_RX();
	void clearLightDatabaseFlag_RX();
	
	bool checkColorDatabaseFlag_TX();
	void setColorDatabaseFlag_TX();
	void clearColorDatabaseFlag_TX();
	bool checkColorDatabaseFlag_RX();
	void setColorDatabaseFlag_RX();
	void clearColorDatabaseFlag_RX();
	
	bool checkSpeedDatabaseFlag_TX();
	void setSpeedDatabaseFlag_TX();
	void clearSpeedDatabaseFlag_TX();
	bool checkSpeedDatabaseFlag_RX();
	void setSpeedDatabaseFlag_RX();
	void clearSpeedDatabaseFlag_RX();
	
	bool checkCompassDatabaseFlag_TX();
	void setCompassDatabaseFlag_TX();
	void clearCompassDatabaseFlag_TX();
	bool checkCompassDatabaseFlag_RX();
	void setCompassDatabaseFlag_RX();
	void clearCompassDatabaseFlag_RX();
	
	bool checkReserveDatabaseFlag_TX();
	void setReserveDatabaseFlag_TX();
	void clearReserveDatabaseFlag_TX();
	bool checkReserveDatabaseFlag_RX();
	void setReserveDatabaseFlag_RX();
	void clearReserveDatabaseFlag_RX();
	
	
	
	bool checkNoNewDataFlag_TX();
	void setNoNewDataFlag_TX();
	void getNoNewDatalag_TX();
	bool checkNoNewDataFlag_RX();
	void setNoNewDataFlag_RX();
	void getNoNewDataFlag_RX();
	
	
	
	bool checkOppenentIdAvailableFlag();
	void setOppenentIdAvailable();
	void clearOppenentIdAvailable();

	

	
	void checkIfDatabaseIsEmpty();
	
	
	static volatile uint32_t DataAndRuleFlags_TX;
	static volatile uint32_t DataAndRuleFlags_RX;
	
	
	protected:
	
	private:
	
};


	typedef struct __attribute__ ((__packed__)) databaseFlags_TX
	{
		uint8_t databaseFlag_TX:1;
		uint8_t databaseEmptyFlag_TX:1;
		uint8_t targetDatabaseFlag_TX:1;
		uint8_t environmentDatabaseFlag_TX:1;
		uint8_t coordinatesDatabaseFlag_TX:1;
		uint8_t positionDatabaseFlag_TX:1;
		uint8_t lightDatabaseFlag_TX:1;
		uint8_t colorDatabaseFlag_TX:1;
		uint8_t speedDatabaseFlag_TX:1;
		uint8_t compassDatabaseFlag_TX:1;
		uint8_t reserveDatabaseFlag_TX:1;
		uint8_t noNewDataFlag_TX:1;
		
	}databaseFlags_TX_t;
	
	
	typedef struct __attribute__ ((__packed__)) databaseFlags_RX
	{
		uint8_t databaseFlag_RX:1;
		uint8_t databaseEmptyFlag_RX:1;
		uint8_t targetDatabaseFlag_RX:1;
		uint8_t environmentDatabaseFlag_RX:1;
		uint8_t coordinatesDatabaseFlag_RX:1;
		uint8_t positionDatabaseFlag_RX:1;
		uint8_t lightDatabaseFlag_RX:1;
		uint8_t colorDatabaseFlag_RX:1;
		uint8_t speedDatabaseFlag_RX:1;
		uint8_t compassDatabaseFlag_RX:1;
		uint8_t reserveDatabaseFlag_RX:1;
		uint8_t noNewDataFlag_RX:1;
		
	}databaseFlags_RX_t;
	
	
	typedef struct __attribute__ ((__packed__)) irCommFlags
	{
		uint8_t oppenentId:1;
		
		
	}irCommFlags_t;	
	
#endif /* DATABASEMANEGMENTFLAGS_H_ */