/*
 * IrComm.h
 *
 * Created: 11.08.2015 16:43:43
 *  Author: Fabio
 */ 


#ifndef IRCOMM_H_
#define IRCOMM_H_

#include <avr/interrupt.h>

#include "IrCommHardwareControl/IrCommHardwareControl.h"
//#include "C:\Users\Fabio\Documents\Atmel Studio\6.2\Robot Main v0.1\RobotMain\srcMain\specificLibMain\RobotIrCommHardwareControl\Irmp\irmp.h"

#define	IR_LED_FRONT_MIDDLE_OFF			PORTD &= ~(1 << PORTD7)		//low
#define IR_LED_FRONT_RIGHT_OFF			PORTD &= ~(1 << PORTD5)
#define IR_LED_BACK_RIGHT_OFF			PORTD &= ~(1 << PORTD4)
#define IR_LED_BACK_MIDDLE_OFF			PORTD &= ~(1 << PORTD3)
#define IR_LED_BACK_LEFT_OFF			PORTD &= ~(1 << PORTD1)
#define IR_LED_FRONT_LEFT_OFF			PORTD &= ~(1 << PORTD0)
#define	IR_LED_FRONT_MIDDLE_ON			PORTD |= (1 << PORTD7)		//high
#define IR_LED_FRONT_RIGHT_ON			PORTD |= (1 << PORTD5)
#define IR_LED_BACK_RIGHT_ON			PORTD |= (1 << PORTD4)
#define IR_LED_BACK_MIDDLE_ON			PORTD |= (1 << PORTD3)
#define IR_LED_BACK_LEFT_ON				PORTD |= (1 << PORTD1)
#define IR_LED_FRONT_LEFT_ON			PORTD |= (1 << PORTD0)
#define	IR_LED_FRONT_MIDDLE_TOGGLE		PORTD ^= (1 << PORTD7)		//toggle
#define IR_LED_FRONT_RIGHT_TOGGLE		PORTD ^= (1 << PORTD5)
#define IR_LED_BACK_RIGHT_TOGGLE		PORTD ^= (1 << PORTD4)
#define IR_LED_BACK_MIDDLE_TOGGLE		PORTD ^= (1 << PORTD3)
#define IR_LED_BACK_LEFT_TOGGLE			PORTD ^= (1 << PORTD1)
#define IR_LED_FRONT_LEFT_TOGGLE		PORTD ^= (1 << PORTD0)


#define	IR_PORT			PIND

#define IR_LED_FRONT_MIDDLE_PORT_BIT	0x80
#define IR_LED_FRONT_RIGHT_PORT_BIT		0x20
#define IR_LED_BACK_RIGHT_PORT_BIT		0x10
#define IR_LED_BACK_MIDDLE_PORT_BIT		0x08
#define IR_LED_BACK_LEFT_PORT_BIT		0x02
#define IR_LED_FRONT_LEFT_PORT_BIT		0x01

// #define IR_LED_STATE_OFF			0
// #define IR_LED_STATE_ON				1
#define IR_LED_STATE_TOGGLE			2

// #define	IR_LED_STATE_FRONT_MIDDLE_ON		IR_LED_STATE_ON
// #define	IR_LED_STATE_FRONT_MIDDLE_OFF		IR_LED_STATE_OFF
#define	IR_LED_STATE_FRONT_MIDDLE_TOGGLE	IR_LED_STATE_TOGGLE
// #define IR_LED_STATE_FRONT_RIGHT_ON			IR_LED_STATE_ON
// #define IR_LED_STATE_FRONT_RIGHT_OFF		IR_LED_STATE_OFF
#define	IR_LED_STATE_FRONT_RIGHT_TOGGLE		IR_LED_STATE_TOGGLE
// #define IR_LED_STATE_BACK_RIGHT_ON			IR_LED_STATE_ON
// #define IR_LED_STATE_BACK_RIGHT_OFF			IR_LED_STATE_OFF
#define	IR_LED_STATE_BACK_RIGHT_TOGGLE		IR_LED_STATE_TOGGLE
// #define	IR_LED_STATE_BACK_MIDDLE_ON			IR_LED_STATE_ON
// #define	IR_LED_STATE_BACK_MIDDLE_OFF		IR_LED_STATE_OFF
#define	IR_LED_STATE_BACK_MIDDLE_TOGGLE		IR_LED_STATE_TOGGLE
// #define IR_LED_STATE_BACK_LEFT_ON			IR_LED_STATE_ON
// #define IR_LED_STATE_BACK_LEFT_OFF			IR_LED_STATE_OFF
#define	IR_LED_STATE_BACK_LEFT_TOGGLE		IR_LED_STATE_TOGGLE
// #define IR_LED_STATE_FRONT_LEFT_ON			IR_LED_STATE_ON
// #define IR_LED_STATE_FRONT_LEFT_OFF			IR_LED_STATE_OFF
#define	IR_LED_STATE_FRONT_LEFT_TOGGLE		IR_LED_STATE_TOGGLE




#define	IR_COMM_GLOBAL_ID			0x11
#define	IR_COMM_MY_ID				0b11110
// #define	IR_COMM_OPPENENT_ID			


#define IR_COMM_NEW_DATA_AVAILABLE				0x3F
#define IR_COMM_TARGET_DATA_AVAILABLE			0x3E
#define IR_COMM_ENVIRONMENT_DATA_AVAILABLE		0x3D
#define IR_COMM_COORDINATES_DATA_AVAILABLE		0x3C
#define IR_COMM_POSITION_DATA_AVAILABLE			0x3B
#define IR_COMM_LIGHT_RULE			0x3A
#define IR_COMM_COLOR_RULE			0x39
#define IR_COMM_SPEED_DATA_AVAILABLE			0x38
#define IR_COMM_COMPASS_DATA_AVAILABLE			0x37
#define IR_COMM_RESERVE_DATA_AVAILABLE			0x36

#define  IR_COMM_NO_NEW_DATA_AVAILABLE			0x00





#define IR_LED_FRONT_MIDDLE		0
#define IR_LED_FRONT_RIGHT		1
#define IR_LED_BACK_RIGHT		2
#define IR_LED_BACK_MIDDLE		3
#define IR_LED_BACK_LEFT		4
#define IR_LED_FRONT_LEFT		5


#define RC5_CHECK_TIME			1


#define white 0b111111







#define TARGET_DATA_AVAILABLE				0
#define ENVIRONMENT_DATA_AVAILABLE			1
#define COORDINATES_DATA_AVAILABLE			2
#define POSITION_DATA_AVAILABLE				3
#define LIGHT_DATA_AVAILABLE				4
#define COLOR_DATA_AVAILABLE				5
#define SPEED_DATA_AVAILABLE				4
#define COMPASS_DATA_AVAILABLE				5





		   






class IrComm
{
	public:
	
		IrComm();
		
		void initialize();
		
		
		static void setAllIrLedOff();
		
		
		static uint8_t getIrCommLedToggle();
		static uint8_t setIrCommLedToggle();
		
		static uint8_t getIrCommLedOff();
		static uint8_t setIrCommLedOff();
		
		
		uint8_t getIrLedFrontMiddle();
		void setIrLedFrontMiddle();
		uint8_t getIrLedFrontRight();
		void setIrLedFrontRight();
		uint8_t getIrLedBackRight();
		void setIrLedBackRight();
		uint8_t getIrLedBackMiddle();
		void setIrLedBackMiddle();
		uint8_t getIrLedBackLeft();
		void setIrLedBackLeft();
		uint8_t getIrLedFrontLeft();
		void setIrLedFrontLeft();
		

		
		
		uint8_t generateRc5Command(uint8_t genRc5Command);
		static void generateRc5Frame(uint8_t rc5Id, uint8_t rc5Data);
		static void generateRc5DataFrame(uint64_t irCommSendData0, uint32_t irCommSendData1);
		
		
		
		void startIrComm(uint8_t irLed, uint8_t rc5Id, uint8_t rc5Data);
		//void irCommSendGlobalId(uint8_t irLed);
		static void irCommSendMyId(uint8_t irLed);
		static void irCommRespenseMyId(uint8_t irLed, uint8_t opponentId);
		static void irCommSendMyRule(uint8_t irLed, uint8_t opponentId, uint8_t dataAvailable);
		static void irCommSendDataString(uint8_t irLed, uint8_t opponentId);
		static void irCommSendDataAvailable(uint8_t irLed, uint8_t opponentId, uint8_t dataAvailableIndex);
		
		static void tryToStartIrComm(uint8_t irLed);
		static void prepareNumberOfBytesAvailableDependentOnRuleTX(uint8_t receivedRuleTX);
		static void prepareNumberOfBytesAvailableDependentOnRuleRX(uint8_t receivedRuleRX);
		static void prepareDataAvailableDependentOnRuleTX(uint8_t receivedRuleTX);
		static void prepareDataAvailableDependentOnRuleRX(uint8_t receivedRuleRX);
		static int prepareNumberOfRC5FramesDependentOnAvailableDataBytesTX(uint8_t bytesAvailableTX);
		static int prepareNumberOfRC5FramesDependentOnAvailableDataBytesRX(uint8_t bytesAvailableRX);
		static void putNewDataIntoRC5FramesTX(uint8_t newDataFromDatabaseTX);
		static void putNewDataIntoRC5FramesRX(uint8_t newDataFromDatabaseRX);


		static void sendNumberOfRequestedDataFrames(uint8_t irLed, uint8_t opponentId);
		static void sendRequestedDataAvailable(uint8_t irLed, uint8_t opponentId);
		static void checkIncomingRc5Data(uint8_t checkTime);
		static void sendRequestedData();
		
		static void sendIrframe(uint8_t irLedPin);
		
		static void getExternIrCommRc5Data(uint8_t rc5SelecDataBase);
		
		static void irCommSendDataAndRule(uint8_t irLed, uint8_t opponentId);
		void generateDataAndRuleFrame(uint32_t dataAndRule);

		void getIrmpData();
		void initializeIrmp();
		
		
		static int numberOfRequestedData;
		static uint8_t expectedNumberOfBytesTX/*RequestedBytes*/;
		static uint8_t expectedNumberOfBytesRX/*IncomingBytes*/;
		static uint8_t colorDataAvailableTX[];
		static uint8_t colorDataAvailableRX[];
		static uint8_t numberOfRC5FramesBasedOnBytesTX;
		static uint8_t numberOfRC5FramesBasedOnBytesRX;
		
		static volatile uint8_t selectIrLed;
		/*extern??*/ static uint8_t oppenentId;

		static uint8_t irCommSendData[16];
		static uint8_t irCommDataAndRule[3];
		
		/*extern??*/static uint64_t irCommSendData_00;
		/*extern??*/static uint32_t irCommSendData_01;
		/*extern??*/static uint32_t irCommSendData_02;
		
		
		static uint16_t rc5Start;				// RC5 Start bit must be 1
		static uint16_t rc5Field;				// RC5 Field bit choose the high or low Field of the RC5 Code. Could be 1 or 0.
		static uint16_t rc5Toggle;				// RC5 Toggle bit chance his value even a RC5 Frame being sent
		static uint16_t rc5Address;				// RC5 Address bits selects the device address, for communication with the selected devices
		static uint16_t rc5Code;				// RC5 code bits that are used, to generated the next Code for the following RC5 Frame

		static uint16_t rc5StartBits;						// RC5 Start bits mask
		static uint16_t rc5FieldBits;						// RC5 Field bits mask
		static uint16_t rc5ToggleBits;							// RC5 Toggle bits mask
		static uint16_t rc5AddressBits;		     				// RC5 Address bits mask
		static uint16_t rc5CodeBits;							// RC5 code bits mask


		static uint8_t rc5StartMSB;								// RC5 most significant bit Start bit
		static uint8_t rc5StartLSB;								// RC5 last significant bit Start bit
		static uint8_t rc5FieldMSB;								// RC5 most significant bit Field bits
		static uint8_t rc5FieldLSB;								// RC5 last significant bit Field bits
		static uint8_t rc5ToggleMSB;								// RC5 most significant bit Toggle bits
		static uint8_t rc5ToggleLSB;								// RC5 last significant bit Toggle bits
		static uint8_t rc5AddressMSB;								// RC5 most significant bit Address bits
		static uint8_t rc5AddressLSB; 								// RC5 last significant bit Address bits
		static uint8_t rc5CodeMSB; 								// RC5 most significant bit code bits
		static uint8_t rc5CodeLSB; 								// RC5 last significant bit code bits

		static int i;
		
		
		static volatile uint16_t rc5Command;		// Stores the entire RC5 Command
		static volatile uint16_t rc5Commandmask;		// RC5 Command mask
		
		
		static volatile uint8_t rc5CommandSent;						// Variable to check if the RC5 Frame is sent complete
		static volatile uint8_t compareMatchCounter;					// Variable to determine the transmit half bit time
		static volatile uint8_t sendRc5Command;						// Variable to enable the next RC5 Transmit

		static volatile uint8_t rc5BitTransmit;						// Checks if one bit is transmitted
		static volatile uint8_t selectRc5Code;							// Variable to choice the next RC5 code
		
		
		
		static uint32_t dataAvailable;
		
		
static uint8_t  IR_COMM_LIGHT_DATA;
static uint8_t  IR_COMM_COLOR_DATA;
		
/*
#define IR_COMM_NEW_DATA_AVAILABLE				0x3F
#define IR_COMM_TARGET_DATA_AVAILABLE			0x3E
#define IR_COMM_ENVIRONMENT_DATA_AVAILABLE		0x3D
#define IR_COMM_COORDINATES_DATA_AVAILABLE		0x3C
#define IR_COMM_POSITION_DATA_AVAILABLE			0x3B
#define IR_COMM_LIGHT_DATA_AVAILABLE			0x3A
#define IR_COMM_COLOR_DATA_AVAILABLE			0x39
#define IR_COMM_SPEED_DATA_AVAILABLE			0x38
#define IR_COMM_COMPASS_DATA_AVAILABLE			0x37
#define IR_COMM_RESERVE_DATA_AVAILABLE			0x36

#define  IR_COMM_NO_NEW_DATA_AVAILABLE			0x00*/
			
	protected:
	
	private:
	
};

// 
// extern void irmp_init(void);

//extern IRMP_DATA irmp;






				
				

extern void externIrCommDataBytes ();
extern void externIrCommDataFrame ();
extern void externIrCommDataArray (uint8_t irCommRc5DataArray[12], int bytes);

extern uint8_t externIrCommRc5Data[12];
extern uint8_t *externRc5Data[12];















#ifdef __cplusplus
extern "C"{
#endif

	
	extern uint8_t getIrmpAddress(void);
	extern uint8_t getIrmpCommand(void);
	
	extern uint8_t irmpAddress;
	extern uint8_t irmpCommand;
	
	extern void setIrmpAddress(uint8_t);
	extern void setIrmpCommand(uint8_t);
	

#ifdef __cplusplus
}
#endif






/*

		   typedef struct newDataFlags_t
		   {
			   uint16_t newDataAvailable:1;
			   uint16_t newTargetDataAvailable:1;
			   uint16_t newEnvironmentDataAvailable:1;
			   uint16_t newCoordinatesDataAvailable:1;
			   uint16_t newPositionDataAvailable:1;
			   uint16_t newLightDataAvailable:1;
			   uint16_t newColorDataAvailable:1;
			   uint16_t newSpeedDataAvailable:1;
			   uint16_t newCompassDataAvailable:1;
			   uint16_t newReserveDataAvailable:1;
			   
			   uint16_t noNewDataAvailable:1;
			   
		   };
		   extern newDataFlags_t _dataFlags;
*/




#define selectWhite      0b111111				//63		// RC5 Code selectWhite used to select next RC5 code
#define selectRed        0b111110				//62		// RC5 Code selectRed used to select next RC5 code
#define selectGreen      0b111101				//61		// RC5 Code selectGreen used to select next RC5 code
#define selectBlue       0b111100				//60		// RC5 Code selectYellow used to select next RC5 code
#define selectYellow     0b111011				//59		// RC5 Code selectYellow used to select next RC5 code
#define selectPurple     0b111010				//58		// RC5 Code selectPurple used to select next RC5 code
#define selectTurquoise  0b111001				//57		// RC5 Code selectTurquoise used to select next RC5 code
#define selectBlack		 0b111000				//56		// RC5 Code selectBlack used to select next RC5 code















#endif /* IRCOMM_H_ */




















// 	IrComm::irCommSendMyId(irLed);
// 	
// 	initializeIrmp();
// 	
// 	do
// 	{
// 		getIrmpData();
// 		
// 		masterId = irmp.address;
// 		/*	requested opponent id	*/
// 		if (masterId == IR_COMM_GLOBAL_ID)
// 		{
// 			opponentIdRX = irmp.command;
// 			irCommSendDataLable(irLed, opponentIdRX, IR_COMM_MY_ID);
// 			initializeIrmp();
// 			icdmf.setOppenentIdAvailable();
// 			irch.setIrmpTimer1InitialValue();
// 			}	/*	response from opponent	*/
// 			else if (masterId == IR_COMM_MY_ID)
// 			{
// 				opponentIdTX = irmp.command;
// 			}
// 			else if (i < timeout)
// 			{
// 
// 			}
// 			/*	IRMP get oppenent id*/
// 			i++;
// 		} while (icdmf.checkOppenentIdAvailableFlag() && i < timeout);
// 		
// 		irch.setIrmpTimer1InitialValue();


















































