/*
 * IrCommHardwareControl.h
 *
 * Created: 11.08.2015 16:43:16
 *  Author: Fabio
 */ 


#ifndef IRCOMMHARDWARECONTROL_H_
#define IRCOMMHARDWARECONTROL_H_

#include <avr/io.h>
//#include "C:\Users\Fabio\Documents\Atmel Studio\6.2\Robot Main v0.1\RobotMain\srcMain\specificLibMain\RobotIrCommHardwareControl\Irmp\irmp.h"

#define	IR_LED_FRONT_MIDDLE_OUTPUT		DDRD |= (1 << DDD7)			//output
#define IR_LED_FRONT_RIGHT_OUTPUT		DDRD |= (1 << DDD5)
#define IR_LED_BACK_RIGHT_OUTPUT		DDRD |= (1 << DDD4)
#define IR_LED_BACK_MIDDLE_OUTPUT		DDRD |= (1 << DDD3)
#define IR_LED_BACK_LEFT_OUTPUT			DDRD |= (1 << DDD1)
#define IR_LED_FRONT_LEFT_OUTPUT		DDRD |= (1 << DDD0)

#define IR_COMMUNICATION_INPUT			DDRD &= ~(1 << DDD2)		//input					DDRD |= 0x 1111 1011

#define IR_LED_DDRD		DDRD

#define	IR_LED_FRONT_MIDDLE_OUTPUT_OFF			(0 << DDD7)		//high
#define IR_LED_FRONT_RIGHT_OUTPUT_OFF			(0 << DDD5)
#define IR_LED_BACK_RIGHT_OUTPUT_OFF			(0 << DDD4)
#define IR_LED_BACK_MIDDLE_OUTPUT_OFF			(0 << DDD3)
#define IR_LED_BACK_LEFT_OUTPUT_OFF				(0 << DDD1)
#define IR_LED_FRONT_LEFT_OUTPUT_OFF			(0 << DDD0)
#define	IR_LED_FRONT_MIDDLE_OUTPUT_ON			(1 << DDD7)		//low
#define IR_LED_FRONT_RIGHT_OUTPUT_ON			(1 << DDD5)
#define IR_LED_BACK_RIGHT_OUTPUT_ON				(1 << DDD4)
#define IR_LED_BACK_MIDDLE_OUTPUT_ON			(1 << DDD3)
#define IR_LED_BACK_LEFT_OUTPUT_ON				(1 << DDD1)
#define IR_LED_FRONT_LEFT_OUTPUT_ON				(1 << DDD0)

#define IR_COMMUNICATION_INPUT_OFF				(1 << DDD2)
#define IR_COMMUNICATION_INPUT_ON				(0 << DDD2)


#define ON_OK		1
#define OFF_FAIL	0




#define TIMER0_CONTROL_REGISTER_0A		TCCR0A
#define TIMER0_CONTROL_REGISTER_0B		TCCR0B
#define TIMER0_COMPAREMATCH_INTERRUPT	TIMSK0	
#define RGB_LED_GREEN_OCR				OCR0A

#define CLOCK_SELECT_BIT_NO_PRESCALING_TIMER0			(1 << CS00)
#define NORMAL_TIMER_MODE_TIMER0						(1 << WGM01)

// #define CLOCK_SELECT_BIT_NO_PRESCALING_TIMER0_ON		(1 << CS00)
// #define NORMAL_TIMER_MODE_TIMER0_ON						(1 << WGM01)
// 
// #define CLOCK_SELECT_BIT_NO_PRESCALING_TIMER0_OFF		(0 << CS00)
// #define NORMAL_TIMER_MODE_TIMER0_OFF					(0 << WGM01)

#define	COMPARERMATCH_BIT_ENABLE_INTERRUT				(1 << OCIE0A)














class IrCommandHardwareControl
{
	public:
	
		IrCommandHardwareControl();
		
		
		void initialize();
		uint8_t getInitializeHardwareState();
		uint8_t getSoftwareHardwareSate();
		
		
		uint8_t getIrLedFrontMiddleOutput();
		void setIrLedFrontMiddleOutput();
		uint8_t getIrLedFrontRightOutput();
		void setIrLedFrontRightOutput();
		uint8_t getIrLedBackRightOutput();
		void setIrLedBackRightOutput();
		uint8_t getIrLedBackMiddleOutput();
		void setIrLedBackMiddleOutput();
		uint8_t getIrLedBackLeftOutput();
		void setIrLedBackLeftOutput();
		uint8_t getIrLedFrontLeftOutput();
		void setIrLedFrontLeftOutput();

		uint8_t getIrCommunication_Input();
		void setIrCommunication_Input();
		
				
		uint8_t getTimer0Config();
		void setTimer0Config();
		void setTimer0Off();
		void setTimer0On();
		void setTimer0CompareMatchIntOff();
		void setTimer0CompareMatchIntOn();
		
		void setTimer0InitialValue();
		
		
		void setIrmpTimer1Config();
		void setIrmpTimer1Off();
		void setIrmpTimer1On();
		
		void setIrmpTimer1InitialValue();
	
	
	
	protected:
	
	
	private:


};






#endif /* IRCOMMHARDWARECONTROL_H_ */