/*
 * StatusLight.h
 *
 * Created: 11.08.2015 16:31:05
 *  Author: Fabio
 */ 


#ifndef STATUSLIGHT_H_
#define STATUSLIGHT_H_

#include <stdbool.h>

#include "StatusLightHardwareControl/StatusLightHardwareControl.h"



#define RGB_LED_RED_OCR			OCR1B
#define RGB_LED_GREEN_OCR		OCR0A
#define RGB_LED_BLUE_OCR		OCR1A

#define	RGB_LED_COSTUM_OFF		255


#define RGB_LED_RED_OFF			PORTB |= (1 << PORTB2)
#define RGB_LED_GREEN_OFF		PORTD |= (1 << PORTD6)
#define RGB_LED_BLUE_OFF		PORTB |= (1 << PORTB1)
#define RGB_LED_RED_ON			PORTB &= ~(1 << PORTB2)
#define RGB_LED_GREEN_ON		PORTD &= ~(1 << PORTD6)
#define RGB_LED_BLUE_ON			PORTB &= ~(1 << PORTB1)
#define RGB_LED_RED_TOGGLE		PORTB ^= (1 << PORTB2)
#define RGB_LED_GREEN_TOGGLE	PORTD ^= (1 << PORTD6)
#define RGB_LED_BLUE_TOGGLE		PORTB ^= (1 << PORTB1)


#define	RB_LED_PORT		PINB
#define G_LED_PORT		PIND

#define RGB_LED_R_PORT_BIT		0x04		//(1 << PORTB2)
#define RGB_LED_G_PORT_BIT		0x40		//(1 << PORTD6)
#define RGB_LED_B_PORT_BIT		0x02

#define RGB_LED_STATE_OFF			0
#define RGB_LED_STATE_ON			1
#define RGB_LED_STATE_TOGGLE		2

#define	RGB_LED_STATE_RED_ON		RGB_LED_STATE_ON
#define	RGB_LED_STATE_RED_OFF		RGB_LED_STATE_OFF
#define	RGB_LED_STATE_RED_TOGGLE	RGB_LED_STATE_TOGGLE
#define RGB_LED_STATE_GREEN_ON		RGB_LED_STATE_ON
#define RGB_LED_STATE_GREEN_OFF		RGB_LED_STATE_OFF
#define	RGB_LED_STATE_GREEN_TOGGLE	RGB_LED_STATE_TOGGLE
#define RGB_LED_STATE_BLUE_ON		RGB_LED_STATE_ON
#define RGB_LED_STATE_BLUE_OFF		RGB_LED_STATE_OFF
#define	RGB_LED_STATE_BLUE_TOGGLE	RGB_LED_STATE_TOGGLE







#define RGB_LED_PULSE_COLOR_RED				0
#define RGB_LED_PULSE_COLOR_GREEN			1
#define RGB_LED_PULSE_COLOR_BLUE			2
#define RGB_LED_PULSE_COLOR_YELLOW			3
#define RGB_LED_PULSE_COLOR_MAGENTA			4
#define RGB_LED_PULSE_COLOR_CYAN			5

#define RGB_LED_PULSE_HIGH			127
#define RGB_LED_PULSE_BRIGHT		159
#define RGB_LED_PULSE_AVERAGE		191
#define RGB_LED_PULSE_DARK			222
#define RGB_LED_PULSE_LOW			247
#define RGB_LED_PULSE_OFF			255

#define RGB_LED_LONG_PULSE			225
#define RGB_LED_SHORT_PULSE			75


#define RGB_LED_PULSE_CODE_00		RGB_LED_LONG_PULSE
#define RGB_LED_PULSE_CODE_01		RGB_LED_PULSE_CODE_00 + RGB_LED_SHORT_PULSE
#define RGB_LED_PULSE_CODE_02		RGB_LED_PULSE_CODE_01 + RGB_LED_LONG_PULSE
#define RGB_LED_PULSE_CODE_03		RGB_LED_PULSE_CODE_02 + RGB_LED_SHORT_PULSE
#define RGB_LED_PULSE_CODE_04		RGB_LED_PULSE_CODE_03 + RGB_LED_LONG_PULSE

#define RGB_LED_PULSE_CODE_10		RGB_LED_LONG_PULSE
#define RGB_LED_PULSE_CODE_11		RGB_LED_LONG_PULSE
#define RGB_LED_PULSE_CODE_12		RGB_LED_LONG_PULSE * 2
#define RGB_LED_PULSE_CODE_13		RGB_LED_LONG_PULSE
#define RGB_LED_PULSE_CODE_14		RGB_LED_LONG_PULSE * 3


#define RGB_LED_PULSE_SHORT			 500
#define RGB_LED_PULSE_AVARAGE		1000
#define RGB_LED_PULSE_LONG			1500






class StatusLight
{
	public:
#define RGB_LED_PULSE_LONG			1500
		StatusLight();
		
		
		void initialize();

		
		
		uint8_t getRgbLedCustom();
		static void setRgbLedCustom(uint8_t rgbLedCustomRedValue, uint8_t rgbLedCustomGreenValue, uint8_t rgbLedCustomBlueValue);
		static void setRgbLedCostomOff();
		
		uint8_t getRgbLedCustomRed();
		static void setRgbLedCostumRed(uint8_t rgbLedCustomRedValue);
		static void setRgbLedCostomRedOff();
		
		uint8_t getRgbLedCustomGreen();
		static void setRgbLedCostumGreen(uint8_t rgbLedCustomGreenValue);
		static void setRgbLedCostomGreenOff();
		
		uint8_t getRgbLedCustomBlue();
		static void setRgbLedCostumBlue(uint8_t rgbLedCustomBlueValue);
		static void setRgbLedCostomBlueOff();
		
		
		uint8_t getRgbLedOff();
		void setRgbLedOff();
		uint8_t getRgbLedWhite();
		void setRgbLedWhite();
		uint8_t getRgbLedRed();
		void setRgbLedRed();
		uint8_t getRgbLedGreen();
		void setRgbLedGreen();
		uint8_t getRgbLedBlue();
		void setRgbLedBlue();
		uint8_t getRgbLedPurple();
		void setRgbLedPurple();
		uint8_t getRgbLedTurquoise();
		void setRgbLedTurquoise();
		uint8_t getRgbLedYellow();
		void setRgbLedYellow();
		
		
		
		void setStatusLightOk();
		void setStatusLightFail();
		void setStatusLedIrCommOk();
		void setStatusLedIrCommFail();
		void setStatusLedIrDistanceOk();
		void setStatusLedGetIrDistance();
		
		
		static void setRgbLedLongPulse(char rgbLedColor, uint8_t rgbLedCostumValue, uint16_t msTime);		
		
		static uint8_t getColorDataAvailable();
		static uint8_t getColorDataBytes();
		
		static volatile uint16_t timerValue;		//static volatile uint16_t timerValue;
		static uint16_t currenttimerValue;
		static uint16_t previoustimerValue;
		static uint16_t redPulse;
		static uint16_t greenPulse;
		static uint16_t bluePulse;
		
		static uint16_t cycletimes;
		
		static uint8_t redDone;
		
		
		static char rgbLedColor;
		static char rgbLedColorRed;
		static char rgbLedColorGreen;
		static char rgbLedColorBlue;
		
		static uint8_t rgbLedCostumValue;
		
		
		
		static uint8_t colorDataArray0;
		static uint8_t colorDataArray1;
		static uint8_t colorDataArray2;
		static uint8_t colorDataArray3;
		static uint8_t colorDataArray4;
		static uint8_t colorDataArray5;
		static uint8_t colorDataArray6;
		static uint8_t colorDataArray7;
		static uint8_t colorDataArray8;
		static uint8_t colorDataArray9;
		static uint8_t colorDataArray10;
		static uint8_t colorDataArray11;
		
	
	
	static bool checkColorSensorDataFlag();
	static void setColorSensorDataFlag();
	static void clearColorSensorDataFlag();
	
	static bool checkLedButtomRightDataFlag();
	void setLedButtomRightDataFlag();
	void clearLedButtomRightDataFlag();
	
	static bool checkLedButtomLeftDataFlag();
	void setLedButtomLeftDataFlag();
	void clearLedButtomLeftDataFlag();
	
	static bool checkLedTopDataFlag();
	static void setLedTopDataFlag();
	static void clearTopDataFlag();
						
	protected:
	private:
		
	
	
	
			
};

	extern uint8_t colorDataArray[12];	




	typedef struct __attribute__ ((__packed__)) colorFlags
	{
		uint8_t colorSensorDataFlag:1;
		uint8_t ledButtomRightDataFlag:1;
		uint8_t ledButtomLeftDataFlag:1;
		uint8_t ledTopDataFlag:1;
		
	}colorFlags_t;







	extern void externColorData();





#endif /* STATUSLIGHT_H_ */




















		 		// 		 		uint8_t getRgbLedOff();
		 		// 		 		void setRgbLedOff();
		 		// 		 		uint8_t getRgbLedWhite();
		 		// 		 		void setRgbLedWhite();
		 		// 		 		uint8_t getRgbLedRed();
		 		// 		 		void setRgbLedRed();
		 		// 		 		uint8_t getRgbLedGreen();
		 		// 		 		void setRgbLedGreen();
		 		// 		 		uint8_t getRgbLedBlue();
		 		// 		 		void setRgbLedBlue();
		 		// 		 		uint8_t getRgbLedPurple();
		 		// 		 		void setRgbLedPurple();
		 		// 		 		uint8_t getRgbLedTurquoise();
		 		// 		 		void setRgbLedTurquoise();
		 		// 		 		uint8_t getRgbLedYellow();
		 		// 		 		void setRgbLedYellow();