/* 
* RobotMotorSpeedDecodeHardwareControl.cpp
*
* Created: 02.10.2015 21:56:26
* Author: Fabio
*/

#include "C:\Users\Fabio\Documents\Atmel Studio\6.2\Robot Main v0.1\RobotMainT\srcMott\srcMott.h"
#include "RobotMotorSpeedDecodeHardwareControl.h"
srcMott smo;

// default constructor
RobotMotorSpeedDecodeHardwareControl::RobotMotorSpeedDecodeHardwareControl()
{
} //RobotMotorSpeedDecodeHardwareControl

// default destructor
RobotMotorSpeedDecodeHardwareControl::~RobotMotorSpeedDecodeHardwareControl()
{
} //~RobotMotorSpeedDecodeHardwareControl

void RobotMotorSpeedDecodeHardwareControl::decodeInit()
{
	decodeConfigIO();
	decodeConfigAdc();
	//decodeConfigTimer2();
	
}

void RobotMotorSpeedDecodeHardwareControl::decodeConfigIO()
{
	smo.configIO(DECODE_HARDWARE_DDR_D,DECODE_IR_LED_LEFT,OUTPUT);
	smo.configIO(DECODE_HARDWARE_DDR_D,DECODE_IR_LED_RIGHT,OUTPUT);
	
	smo.configIO(DECODE_HARDWARE_DDR_D,DECODE_IR_TRANSISTOR_LEFT_INTERRUPT,INPUT);
	smo.configIO(DECODE_HARDWARE_DDR_C,DECODE_IR_TRANSISTOR_LEFT_ADC,INPUT);
	smo.configIO(DECODE_HARDWARE_DDR_C,DECODE_IR_TRANSISTOR_RIGHT_ADC,INPUT);
	
// 	DECODE_HARDWARE_DDR_C &= ~DECODE_IR_TRANSISTOR_LEFT_INTERRUPT_INPUT;
// 	DECODE_HARDWARE_DDR_C &= ~DECODE_IR_TRANSISTOR_LEFT_ADC_INPUT | ~DECODE_IR_TRANSISTOR_RIGHT_ADC_INPUT;
}

void RobotMotorSpeedDecodeHardwareControl::decodeConfigAdc()
{
// 	  // die Versorgungsspannung AVcc als Referenz whlen:
//   ADMUX = (1<<REFS0);    
//   // oder interne Referenzspannung als Referenz fr den ADC whlen:
//   // ADMUX = (1<<REFS1) | (1<<REFS0);
//  
//   // Bit ADFR ("free running") in ADCSRA steht beim Einschalten
//   // schon auf 0, also single conversion
//   ADCSRA = (1<<ADPS1) | (1<<ADPS0);     // Frequenzvorteiler
//   ADCSRA |= (1<<ADEN);                  // ADC aktivieren
//  
//   /* nach Aktivieren des ADC wird ein "Dummy-Readout" empfohlen, man liest
//      also einen Wert und verwirft diesen, um den ADC "warmlaufen zu lassen" */
//  
//   ADCSRA |= (1<<ADSC);                  // eine ADC-Wandlung 
//   while (ADCSRA & (1<<ADSC) ) {         // auf Abschluss der Konvertierung warten
//   }
//   /* ADCW muss einmal gelesen werden, sonst wird Ergebnis der nchsten
//      Wandlung nicht bernommen. */
//   (void) ADCW;
  
	DECODE_HARDWARE_ADMUX = DECODE_ADMUX_REFS_0;
	DECODE_HARDWARE_ADCSRA = DECODE_ADCSRA_ADPS1 | DECODE_ADCSRA_ADPS0;
	DECODE_HARDWARE_ADCSRA |= (1<<ADATE);
	DECODE_HARDWARE_ADCSRA |= DECODE_ENABLE_ADC; 
	DECODE_HARDWARE_ADCSRA |= DECODE_READ_ADC;
	ADCSRB = /*(1<<ADTS2)|*/(1<<ADTS1)/*|(1<<)*/;
	while(DECODE_HARDWARE_ADCSRA & DECODE_READ_ADC){	}
	(void) ADCW;
}

void RobotMotorSpeedDecodeHardwareControl::decodeConfigTimer2()
{
	DECODE_HARDWARE_TCCR2A |= DECODE_TIMER2_WGM21;
	DECODE_HARDWARE_TCCR2B |= DECODE_TIMER2_CS2;
	DECODE_HARDWARE_TIMSK2 |= DECODE_HARDWARE_OCIE2A;
	DECODE_HARDWARE_OCR2A = DECODE_HARDWARE_OCR2A_VAL;
}

uint16_t RobotMotorSpeedDecodeHardwareControl::decodeGetAdc(uint8_t channel)
{
// 	  // Kanal waehlen, ohne andere Bits zu beeinfluen
// 	  ADMUX = (ADMUX & ~(0x1F)) | (channel & 0x1F);
// 	  ADCSRA |= (1<<ADSC);            // eine Wandlung "single conversion"
// 	  while (ADCSRA & (1<<ADSC) ) {   // auf Abschluss der Konvertierung warten
// 	  }
// 	  return ADCW;
	
	
	DECODE_HARDWARE_ADMUX = (DECODE_HARDWARE_ADMUX & ~(0x1F)) | (channel & 0x1F);
	DECODE_HARDWARE_ADCSRA |= DECODE_READ_ADC;
	while(DECODE_HARDWARE_ADCSRA & DECODE_READ_ADC){	}
	return ADCW;
}
