/* 
* RobotMotorSpeedDecodeHardwareControl.h
*
* Created: 02.10.2015 21:56:26
* Author: Fabio
*/


#ifndef __ROBOTMOTORSPEEDDECODEHARDWARECONTROL_H__
#define __ROBOTMOTORSPEEDDECODEHARDWARECONTROL_H__

#include <avr/io.h>


#define DECODE_HARDWARE_DDR_D						2
#define DECODE_IR_LED_LEFT							DDD7
#define DECODE_IR_LED_RIGHT							DDD4
#define DECODE_IR_TRANSISTOR_LEFT_INTERRUPT			DDD2

#define DECODE_HARDWARE_DDR_C						1
#define DECODE_IR_TRANSISTOR_LEFT_ADC			DDC1
#define DECODE_IR_TRANSISTOR_RIGHT_ADC		DDC2

#define DECODE_HARDWARE_ADMUX						ADMUX
#define DECODE_ADMUX_REFS_1							(1 << REFS1)
#define DECODE_ADMUX_REFS_0							(1 << REFS0)
#define DECODE_IR_TRANSISTOR_RIGHT					(1 << MUX1)
#define DECODE_IR_TRANSISTOR_LEFT					(1 << MUX0)

#define DECODE_HARDWARE_ADCSRA						ADCSRA
#define DECODE_ENABLE_ADC							(1 << ADEN)
#define DECODE_READ_ADC								(1 << ADSC)
#define DECODE_ADCSRA_ADPS2							(1 << ADPS2)
#define DECODE_ADCSRA_ADPS1							(1 << ADPS1)
#define DECODE_ADCSRA_ADPS0							(1 << ADPS0)
#define DECODE_ADCSRA_ADATE							(1 << ADATE)


#define	DECODE_HARDWARE_TCCR2A						TCCR2A
#define DECODE_TIMER2_WGM21							(1 << WGM21)

#define	DECODE_HARDWARE_TCCR2B						TCCR2B
#define DECODE_TIMER2_CS2							(1 << CS22)

#define	DECODE_HARDWARE_TIMSK2						TIMSK2
#define	DECODE_HARDWARE_OCIE2A						(1 << OCIE2A)

#define	DECODE_HARDWARE_OCR2A						OCR2A
#define	DECODE_HARDWARE_OCR2A_VAL					124



class RobotMotorSpeedDecodeHardwareControl
{
//variables
	public:
	protected:
	private:

//functions
	public:
		RobotMotorSpeedDecodeHardwareControl();
		~RobotMotorSpeedDecodeHardwareControl();
		
		void decodeInit();
		
		void decodeConfigIO();
		void decodeConfigAdc();
		void decodeConfigTimer2();
			
		uint16_t decodeGetAdc(uint8_t channel);
		
		void decodeWheelRight();
		void decodeWheelLeft();
		
		void decodeControlIO();
		void decodeControlAdc();
		void decodeControlTimer2();
		
		
		
	protected:
	private:
		RobotMotorSpeedDecodeHardwareControl( const RobotMotorSpeedDecodeHardwareControl &c );
		RobotMotorSpeedDecodeHardwareControl& operator=( const RobotMotorSpeedDecodeHardwareControl &c );

}; //RobotMotorSpeedDecodeHardwareControl

#endif //__ROBOTMOTORSPEEDDECODEHARDWARECONTROL_H__
