/*
 * IrComm.cpp
 *
 * Created: 11.08.2015 16:43:36
 *  Author: Fabio
 */ 
#define F_CPU 8000000UL
#include <util/delay.h>

#include "IrComm.h"
#include "IrDataFlags.h"
#include "IrCommHardwareControl/IrCommHardwareControl.h"
#include "C:\Users\Fabio\Documents\Atmel Studio\6.2\Robot Main v0.1\RobotMain\srcMain\specificLibMain\RobotIrCommHardwareControl\IrComm\DatabaseManegmentFlags.h"
#include "C:\Users\Fabio\Documents\Atmel Studio\6.2\Robot Main v0.1\RobotMain\srcMain\specificLibMain\RobotIrCommHardwareControl\IrComm\IrCommDatabaseManegment.h"

#include "C:\Users\Fabio\Documents\Atmel Studio\6.2\Robot Main v0.1\RobotMain\srcMain\specificLibMain\RobotIrCommHardwareControl\Irmp\irmp.h"
#include "C:\Users\Fabio\Documents\Atmel Studio\6.2\Robot Main v0.1\RobotMain\srcMain\specificLibMain\RobotStatusLightHardwareControl\StatusLight\StatusLight.h"
#include "C:\Users\Fabio\Documents\Atmel Studio\6.2\Robot Main v0.1\RobotMain\srcMain\specificLibMain\RobotStatusLightHardwareControl\StatusLight\StatusLightHardwareControl\StatusLightHardwareControl.h"

IRMP_DATA irmp;

IrCommDatabaseManegment icdm;
DatabaseManegmentFlags icdmf;

StatusLightHardwareControl islhc;
IrComm irc;
StatusLight isl;
IrCommandHardwareControl irch;

uint8_t IrComm::selectIrLed = 0;


uint8_t externIrCommRc5Data[12] = { 0 };
uint8_t IrComm::irCommSendData[16] = { 0 };
// uint64_t IrComm::irCommSendData_00;
// uint32_t IrComm::irCommSendData_01;
// uint32_t IrComm::irCommSendData_02;	
	

uint16_t IrComm::rc5Start =			 0b10000000000000;				// RC5 Start bit must be 1
uint16_t IrComm::rc5Field =          0b01000000000000;				// RC5 Field bit choose the high or low Field of the RC5 Code. Could be 1 or 0.
uint16_t IrComm::rc5Toggle =         0b00000000000000;				// RC5 Toggle bit chance his value even a RC5 Frame being sent
uint16_t IrComm::rc5Address =        0b00000000000000;				// RC5 Address bits selects the device address, for communication with the selected devices
uint16_t IrComm::rc5Code =           0b00000000000000;				// RC5 code bits that are used, to generated the next Code for the following RC5 Frame

uint16_t IrComm::rc5StartBits =      0x2000;						// RC5 Start bits mask
uint16_t IrComm::rc5FieldBits =      0x1000;						// RC5 Field bits mask
uint16_t IrComm::rc5ToggleBits =     0x800;							// RC5 Toggle bits mask
uint16_t IrComm::rc5AddressBits =    0x400;		     				// RC5 Address bits mask
uint16_t IrComm::rc5CodeBits =       0x20;							// RC5 code bits mask


uint8_t IrComm::rc5StartMSB =       13;								// RC5 most significant bit Start bit
uint8_t IrComm::rc5StartLSB =		13;								// RC5 last significant bit Start bit
uint8_t IrComm::rc5FieldMSB =       12;								// RC5 most significant bit Field bits
uint8_t IrComm::rc5FieldLSB =		12;								// RC5 last significant bit Field bits
uint8_t IrComm::rc5ToggleMSB =		11;								// RC5 most significant bit Toggle bits
uint8_t IrComm::rc5ToggleLSB =		11;								// RC5 last significant bit Toggle bits
uint8_t IrComm::rc5AddressMSB =		10;								// RC5 most significant bit Address bits
uint8_t IrComm::rc5AddressLSB =		6; 								// RC5 last significant bit Address bits
uint8_t IrComm::rc5CodeMSB =		5; 								// RC5 most significant bit code bits
uint8_t IrComm::rc5CodeLSB =		0;

int IrComm::i;


volatile uint16_t IrComm::rc5Command =        0b00000000000000;		// Stores the entire RC5 Command
volatile uint16_t IrComm::rc5Commandmask =    0b10000000000000;		// RC5 Command mask


volatile uint8_t IrComm::rc5CommandSent = 0;						// Variable to check if the RC5 Frame is sent complete
volatile uint8_t IrComm::compareMatchCounter = 0;					// Variable to determine the transmit half bit time
volatile uint8_t IrComm::sendRc5Command = 0;						// Variable to enable the next RC5 Transmit

volatile uint8_t IrComm::rc5BitTransmit = 0;						// Checks if one bit is transmitted
volatile uint8_t IrComm::selectRc5Code = 0;							// Variable to choice the next RC5 code


  					                   /* 15    14    13    12    11    10      9     8     7     6      5      4      3     2      1      0       */
					                /*    |     |     |     |     |     |       |     |     |     |      |      |      |     |      |      |      */
uint64_t IrComm::irCommSendData_00 /*=									  0b101011110000000011111111 00000000 11110000 11110000 11110000 11110000*/;	// 12 bytes
uint32_t IrComm::irCommSendData_01 /*= 0b01011000111111110000000011111110*/;

uint32_t IrComm::dataAvailable = 0;


IrComm::IrComm(){}



void IrComm::initialize()
{
	setAllIrLedOff();   
}


void IrComm::setAllIrLedOff()
{
	IR_LED_FRONT_MIDDLE_OFF;
	IR_LED_FRONT_RIGHT_OFF;
	IR_LED_BACK_RIGHT_OFF;
	IR_LED_BACK_MIDDLE_OFF;
	IR_LED_BACK_LEFT_OFF;
	IR_LED_FRONT_LEFT_OFF;
	
}




void IrComm::irCommSendMyId(uint8_t irLed)
{
	irch.setTimer0InitialValue();
	
	IrComm::generateRc5Frame(IR_COMM_GLOBAL_ID, IR_COMM_MY_ID);
	
	irch.setTimer0Config();
	irch.setTimer0On();
	irch.setTimer0CompareMatchIntOn();

	IrComm::sendIrframe(irLed);

	irch.setTimer0Off();
	irch.setTimer0CompareMatchIntOff();
	
	IrComm::setAllIrLedOff();
}

void IrComm::irCommSendDataLable(uint8_t irLed, uint8_t opponentId, uint32_t dataAvailable)
{
	irch.setTimer0InitialValue();
	
	IrComm::generateRc5Frame(opponentId, dataAvailable);
	
	irch.setTimer0Config();
	irch.setTimer0On();
	irch.setTimer0CompareMatchIntOn();

	IrComm::sendIrframe(irLed);

	irch.setTimer0Off();
	irch.setTimer0CompareMatchIntOff();
	
	IrComm::setAllIrLedOff();	
}

void IrComm::irCommSendDataString(uint8_t irLed, uint8_t opponentId, uint32_t dataLabel, uint8_t sendData[16])
{
	IrComm::irCommSendMyId(irLed);
	_delay_ms(89);
	IrComm::irCommSendDataLable(irLed, opponentId, dataLabel);
	_delay_ms(89);
	
	
	for (int m = 0; m < 16; m++)
	{
		
			irch.setTimer0InitialValue();
			
			IrComm::generateRc5Frame(opponentId, sendData[m]);
			
			irch.setTimer0Config();
			irch.setTimer0On();
			irch.setTimer0CompareMatchIntOn();

			IrComm::sendIrframe(irLed);

			irch.setTimer0Off();
			irch.setTimer0CompareMatchIntOff();
			
			IrComm::setAllIrLedOff();
			_delay_ms(89);
	}
	
}

#define u 1


void IrComm::sendRequestedData()
{
	
}



void IrComm::tryToStartIrComm(uint8_t irLed)
{
	int i = 0;
	int j = 0;
	int timeout = 3;
	uint8_t masterId = 0;
	uint8_t myId = 0;
	uint8_t opponentIdRX = 0;
	uint8_t opponentIdTX = 0;
	uint8_t requestedData = 0;

	IrComm::irCommSendMyId(irLed);	/*	GLOBAL ID		MY ID 	*/
	
	initializeIrmp();
	
	do 
	{
		isl.setStatusLedIrCommFail();
		getIrmpData();
		
		masterId = irmp.address;
		/*	requested opponent id	*/	
		if (masterId == IR_COMM_GLOBAL_ID)
		{	isl.setStatusLedIrCommOk();
			opponentIdRX = irmp.command;
			irCommSendDataLable(irLed, opponentIdRX, IR_COMM_MY_ID);
			initializeIrmp();
			icdmf.setOppenentIdAvailable();
/*			irch.setIrmpTimer1InitialValue();*/  
		}	/*	response from opponent	*/
		else if (masterId == IR_COMM_MY_ID)
		{
			opponentIdTX = irmp.command;
		}
// 		else if (i < timeout)
// 		{	isl.setStatusLedIrCommFail();
// 			//break;
// 		}
		/*	IRMP get oppenent id*/	
//		i++;
	} while (icdmf.checkOppenentIdAvailableFlag()/* && i < timeout*/);
			
	irch.setIrmpTimer1InitialValue();
	
// 	
// 	IrComm::irCommSendDataLable(irLed, opponentIdTX, dataAvailable);  /*   */  
// 	
// 	initializeIrmp();
// 	
// 	do 
// 	{isl.setStatusLedIrCommFail();
// 		getIrmpData();
// 		
// 		myId = irmp.address;
// 		
// 		if (myId == IR_COMM_MY_ID)
// 		{
// 			requestedData = (irmp.command << j);
// 			
// 			if (j == 32)
// 			{
// 				/*icdmf.setOppenentIdAvailable();*/
// 				irch.setIrmpTimer1InitialValue();
// 				break;/*continue;*/
// 			}
// 			
// 			j += 6;
// 		} 
// 		else if (i < timeout)
// 		{
// 			
// 			irch.setIrmpTimer1InitialValue();
// 			break;/*continue;*/
// 		}
// 		
// 		
// 		i++;
// 		
// 		
// 	} while (myId == irmp.address);
// 	
// 
// 	if (requestedData & TARGET_DATA_AVAILABLE)
// 	{
// 		
// 	}



	if (icdmf.checkOppenentIdAvailableFlag())
	{
		 while(icdmf.checkDatabaseIsntEmptyFlag_TX())
		 {
			 if (icdmf.checkTargetDatabaseFlag_TX())
			 {
				 icdm.putNewDataIntoDatabase();
				 icdm.convertDatabaseToRc5Command();
				 
				 IrComm::irCommSendDataString(IR_LED_FRONT_MIDDLE_PORT_BIT, IR_COMM_GLOBAL_ID, IR_COMM_TARGET_DATA_AVAILABLE, irCommDataFrame_TX);
				 
				 icdmf.clearTargetDatabaseFlag_TX();
			 } 
			 else if (icdmf.checkEnvironmentDatabaseFlag_TX())
			 {
				 icdm.putNewDataIntoDatabase();
				 icdm.convertDatabaseToRc5Command();
				 
				 IrComm::irCommSendDataString(IR_LED_FRONT_MIDDLE_PORT_BIT, IR_COMM_GLOBAL_ID, IR_COMM_ENVIRONMENT_DATA_AVAILABLE, irCommDataFrame_TX);
				 
				 icdmf.clearEnvironmentDatabaseFlag_TX();
			 }
			 else if (icdmf.checkCoordinatesDatabaseFlag_TX())
			 {
				 icdm.putNewDataIntoDatabase();
				 icdm.convertDatabaseToRc5Command();
				 
				 IrComm::irCommSendDataString(IR_LED_FRONT_MIDDLE_PORT_BIT, IR_COMM_GLOBAL_ID, IR_COMM_COORDINATES_DATA_AVAILABLE, irCommDataFrame_TX);
				 
				 icdmf.clearCoordinatesDatabaseFlag_TX();
			 }
			 else if (icdmf.checkPositionDatabaseFlag_TX())
			 {
				 icdm.putNewDataIntoDatabase();
				 icdm.convertDatabaseToRc5Command();
				 
				 IrComm::irCommSendDataString(IR_LED_FRONT_MIDDLE_PORT_BIT, IR_COMM_GLOBAL_ID, IR_COMM_COORDINATES_DATA_AVAILABLE, irCommDataFrame_TX);
				 
				 icdmf.clearPositionDatabaseFlag_TX();
			 }
			 else if (icdmf.checkLightDatabaseFlag_TX())
			 {
				 icdm.putNewDataIntoDatabase();
				 icdm.convertDatabaseToRc5Command();
				 
				 IrComm::irCommSendDataString(IR_LED_FRONT_MIDDLE_PORT_BIT, IR_COMM_GLOBAL_ID, IR_COMM_COORDINATES_DATA_AVAILABLE, irCommDataFrame_TX);
				 
				 icdmf.clearLightDatabaseFlag_TX();
			 }
			 else if (icdmf.checkColorDatabaseFlag_TX())
			 {
				 icdm.putNewDataIntoDatabase();
				 icdm.convertDatabaseToRc5Command();
				 
				 IrComm::irCommSendDataString(IR_LED_FRONT_MIDDLE_PORT_BIT, IR_COMM_GLOBAL_ID, IR_COMM_COORDINATES_DATA_AVAILABLE, irCommDataFrame_TX);
				 
				 icdmf.clearColorDatabaseFlag_TX();
			 }
			 else
			 {
				icdmf.clearDatabaseIsntEmptyFlag_TX();
			 }
			 
			 
		 }
	} 
	else
	{
		/*no robot detected		move on		maybe an object*/
	}



// 	
// 	if (/*check opponent id flag*/)
// 	{
// 		
// 	}
// 	
}





// 	do
// 	{
// 	} while (/*check requested data flag	|| i < timeout*/);





void IrComm::sendIrframe(uint8_t irLedPin)
{
	while (IrComm::rc5CommandSent == 0)
	{
			switch(IrComm::compareMatchCounter)												// checks the counts of the timer 0 compare match ISR
			{
				case 63:															// ~64 = (889 us / (1/36000kHz)) * 2
				if(IrComm::rc5BitTransmit == 2)											// half bit transmit timing
				{
					IrComm::rc5BitTransmit = 0;											// reset the half bit transmit timing variable
					IrComm::rc5Commandmask = (IrComm::rc5Commandmask >> (uint16_t)1);			// goes to the next bit of the RC5 command
				}
				IrComm::rc5BitTransmit++;													// increments the half bit transmit timing
				break;																// break switch statement
			}

		if(IrComm::rc5Command & IrComm::rc5Commandmask)											// checks if the RC5 command bit is 1
		{
			if((IrComm::rc5Command & IrComm::rc5Commandmask) && (IrComm::rc5BitTransmit == 1))			// RC5 command bit is 1 and transmit halfbit low
			{
				PORTD &= ~(irLedPin);											// Set the port d 7 low
			}
			if((IrComm::rc5Command & IrComm::rc5Commandmask) && (IrComm::rc5BitTransmit == 2))			// RC5 command bit is 1 and transmit halfbit high
			{
				PORTD ^= (irLedPin);											// Toggle the port d 7 high/low
			}
		}
		else if(!(IrComm::rc5Command & IrComm::rc5Commandmask))									// checks if the RC5 command bit is 0
		{
			if(!(IrComm::rc5Command & IrComm::rc5Commandmask) && (IrComm::rc5BitTransmit == 1))			// RC5 command bit is 1 and transmit halfbit high
			{
				PORTD ^= (irLedPin);											// Toggle the port d 7 high/low
			}
			if(!(IrComm::rc5Command & IrComm::rc5Commandmask) && (IrComm::rc5BitTransmit == 2))			// RC5 command bit is 1 and transmit halfbit low
			{
				PORTD &= ~(irLedPin);											// Set the port d 7 low
			}
		}
	
			if(IrComm::compareMatchCounter <= 63)
			{
				IrComm::compareMatchCounter++;												// increments the timer 0 compare match ISR counter
			}
		
			if(IrComm::compareMatchCounter == 64)
			{
				IrComm::compareMatchCounter = 0;											// resets the timer 0 compare match ISR counter
			}


			if(IrComm::rc5Commandmask == 0x0)
			{
				IrComm::rc5Commandmask = 0x2000;											// resets the RC5 command mask
				IrComm::rc5CommandSent = 1;													// the RC5 command is complete send
			}
	
	
	}
	IrComm::rc5CommandSent = 0;
}

















uint8_t IrComm::generateRc5Command(uint8_t genRc5Command)					// Method to generate the RC5 Code
{
	uint8_t rc5CodeBits =       0x20;						// RC5 code bits mask
	
	uint8_t rc5CodeMSB =		5;							// RC5 most significant bit code bits
	uint8_t rc5CodeLSB =		0;							// RC5 last significant bit code bits
	
	
	for(IrComm::i = IrComm::rc5CodeMSB; i>=IrComm::rc5CodeLSB; IrComm::i--)					// For loop to write the new RC5 code in to the RC5 code
	{
		if(genRc5Command & rc5CodeBits)							// checks if the RC5 code bit is 1
		{
			IrComm::rc5Code |= ((uint8_t)1 << IrComm::i);					// writes the bit (1) in to RC5 code
		}
		else												// else the RC5 code bit is 0
		{
			IrComm::rc5Code &= ~((uint8_t)1 << IrComm::i);					// writes the bit (0) in to RC5 code
		}
		rc5CodeBits = (rc5CodeBits >> (uint8_t)1);			// goes to the next bit of the RC5 code
	}
	
	return IrComm::rc5Code;												// returns the generated RC5 code

}



void IrComm::generateRc5Frame(uint8_t rc5Id, uint8_t rc5Data)									// Method to generate the RC5 Command
{
	uint16_t rc5StartBits =		 0x2000;					// RC5 Start bit mask
	uint16_t rc5FieldBits =      0x1000;					// RC5 Field bit mask
	uint16_t rc5ToggleBits =     0x800;						// RC5 Toggle bit mask
	uint16_t rc5AddressBits =    0x10;						// RC5 Address bits mask
	uint16_t rc5CodeBits =       0x20;						// RC5 Code bits mask
	
// 	IrComm::rc5Address = rc5Id;
// 	IrComm::rc5Code = rc5Data;
	

	for(IrComm::i = IrComm::rc5StartMSB; IrComm::i>=IrComm::rc5StartLSB; IrComm::i--)				// For loop to write the RC5 start bit in to the RC5 command
	{
		if(IrComm::rc5Start & rc5StartBits)							// checks if the RC5 start bit is 1
		{
			IrComm::rc5Command |= ((uint16_t)1 << IrComm::i);				// writes the bit (1) in to RC5 command
		}
	}
	
	
	for(IrComm::i = IrComm::rc5FieldMSB; IrComm::i>=IrComm::rc5FieldLSB; IrComm::i--)				// For loop to write the RC5 field bit in to the RC5 command
	{
		
		if(IrComm::rc5Field & rc5FieldBits)							// checks if the RC5 field bit is 1
		{
			IrComm::rc5Command |= ((uint16_t)1 << IrComm::i);				// writes the bit (1) in to RC5 command
		}
		else												// else the RC5 field bit is 0
		{
			IrComm::rc5Command &= ~((uint16_t)1 << IrComm::i);				// writes the bit (0) in to RC5 command
		}
	}
	
	
	for(IrComm::i = IrComm::rc5ToggleMSB; IrComm::i>=IrComm::rc5ToggleLSB; IrComm::i--)				// For loop to write the RC5 toggle bit in to the RC5 command
	{
		
		if(!(IrComm::rc5Toggle & rc5ToggleBits))					// checks if the RC5 toggle bit is 0
		{
			IrComm::rc5Command &= ~((uint16_t)1 << IrComm::i);				// writes the bit (0) in to RC5 command
			IrComm::rc5Toggle |= ((uint16_t)1 << IrComm::i);				// writes the bit (1) in to RC5 toggle
		}
		else                                                // else the RC5 toggle bit is 1
		{
			IrComm::rc5Command |= ((uint16_t)1 << IrComm::i);				// writes the bit (1) in to RC5 command
			IrComm::rc5Toggle &= ~((uint16_t)1 << IrComm::i);				// writes the bit (0) in to RC5 toggle
		}
	}
	
	
	for(int i = IrComm::rc5AddressMSB; i>=IrComm::rc5AddressLSB; i--)			// For loop to write the RC5 address bits in to the RC5 command
	{
		if(rc5Id & rc5AddressBits)						// checks if the RC5 address bit is 1
		{
			IrComm::rc5Command |= ((uint16_t)1 << i);				// writes the bit (1) in to RC5 command
		}
		else                                                // else the RC5 address bit is 0
		{
			IrComm::rc5Command &= ~((uint16_t)1 << i);				// writes the bit (0) in to RC5 command
		}
		rc5AddressBits = (rc5AddressBits >> (uint16_t)1);	// goes to the next bit of the RC5 address
	}
	
	
	for(IrComm::i = IrComm::rc5CodeMSB; IrComm::i>=IrComm::rc5CodeLSB; IrComm::i--)					// For loop to write the RC5 code bits in to the RC5 command
	{
		if(rc5Data & rc5CodeBits)							// checks if the RC5 code bit is 1
		{
			IrComm::rc5Command |= ((uint16_t)1 << IrComm::i);				// writes the bit (1) in to RC5 command
		}
		else                                                // else the RC5 code bit is 0
		{
			IrComm::rc5Command &= ~((uint16_t)1 << IrComm::i);				// writes the bit (0) in to RC5 command
		}
		rc5CodeBits = (rc5CodeBits >> (uint16_t)1);			// goes to the next bit of the RC5 code
	}
	//return IrComm::rc5Command;
}





// void IrComm::initIrmp()
// {
// 	void irmp_init(void);
// 	void timer1_init(void);
// }
// 
// void irmpTimer1InitialValue()
// {
// 	islhc.setTimer1InitialValue();
// }





/*IRMP_DATA irmp;*/

void IrComm::getIrmpData()
{
	irmp_get_data(&irmp);
}

void IrComm::initializeIrmp()
{
	irmp_init();
	irch.setIrmpTimer1Config();
	irch.setIrmpTimer1On();

}





ISR (TIMER1_COMPA_vect)
{
	/*isl.setStatusLightFail();*/
	(void) irmp_ISR();
}



ISR (TIMER0_COMPA_vect)														// ISR Timer 0 compare match
{


//(void) irmp_ISR();




}








//
// uint8_t IrComm::getIrCommLedToggle()
// {
// //	setIrCommLed();
// }
// uint8_t IrComm::setIrCommLedToggle()
// {
// 	switch (IrComm::selectIrLed)
// 	{
// 	case 0:
// 			return IR_LED_FRONT_MIDDLE_TOGGLE;
// 		break;
// 	case 1:
// 			return IR_LED_FRONT_RIGHT_TOGGLE;
// 		break;
// 	case 2:
// 			return IR_LED_BACK_RIGHT_TOGGLE;
// 		break;
// 	case 3:
// 			return IR_LED_BACK_MIDDLE_TOGGLE;
// 		break;
// 	case 4:
// 			return IR_LED_BACK_LEFT_TOGGLE;
// 		break;
// 	case 5:
// 			return IR_LED_FRONT_LEFT_TOGGLE;
// 		break;
//
// 	}
// }
//
// uint8_t IrComm::getIrCommLedOff()
// {
// 	//	setIrCommLed();
// }
// uint8_t IrComm::setIrCommLedOff()
// {
// 	switch (IrComm::selectIrLed)
// 	{
// 		case 0:
// 		return IR_LED_FRONT_MIDDLE_OFF;
// 		break;
// 		case 1:
// 		return IR_LED_FRONT_RIGHT_OFF;
// 		break;
// 		case 2:
// 		return IR_LED_BACK_RIGHT_OFF;
// 		break;
// 		case 3:
// 		return IR_LED_BACK_MIDDLE_OFF;
// 		break;
// 		case 4:
// 		return IR_LED_BACK_LEFT_OFF;
// 		break;
// 		case 5:
// 		return IR_LED_FRONT_LEFT_OFF;
// 		break;
//
// 	}
// }



















//
//
// uint8_t IrComm::getIrLedFrontMiddle(){}
// void IrComm::setIrLedFrontMiddle()
// {
// 	IR_LED_FRONT_MIDDLE_TOGGLE;
// }
// uint8_t IrComm::getIrLedFrontRight(){}
// void IrComm::setIrLedFrontRight()
// {
// 	IR_LED_FRONT_RIGHT_TOGGLE;
// }
// uint8_t IrComm::getIrLedBackRight(){}
// void IrComm::setIrLedBackRight()
// {
// 	IR_LED_BACK_RIGHT_TOGGLE;
// }
// uint8_t IrComm::getIrLedBackMiddle(){}
// void IrComm::setIrLedBackMiddle()
// {
// 	IR_LED_BACK_MIDDLE_TOGGLE;
// }
// uint8_t IrComm::getIrLedBackLeft(){}
// void IrComm::setIrLedBackLeft()
// {
// 	IR_LED_BACK_LEFT_TOGGLE;
// }
// uint8_t IrComm::getIrLedFrontLeft(){}
// void IrComm::setIrLedFrontLeft()
// {
// 	IR_LED_FRONT_LEFT_TOGGLE;
// }




/*newDataAvailableFlags_t _newDataAvailableFlags = {0,0,0,0,0,0,0,0,0,0,0};*/


//s.newColorDataAvailable = 0;





//sty.newColorDataAvailable = 0;

/*
structType gh;

gh.newColorDataAvailable = 0;

*/

/*gh.newColorDataAvailable;*/

//.newColorDataAvailable;





// IrComm::dataBaseFlags databaseflags;
//
// databaseflags.newColorDataAvailable = 0;


/*
union typedef dataBaseFlags_a;


dataBaseFlags datalags;

datalags.newColorDataAvailable = 0;
*/


/*newDataFlags.newColorDataAvailable = 0;*/

//
// IrComm::dataBaseFlags newDataFlags;
//
// newDataFlags.newColorDataAvailable = 0;













// void startIrComm(uint8_t irLed, uint8_t rc5Id, uint8_t rc5Data)
// {
//
// 	IrComm::selectIrLed = irLed;
//
// /*	irc.generateRc5Command(rc5Data);*/
//
//
// //
// // 	while(rc5CommandSent == 0)							// while RC5 Command is send
// // 	{
// // 		TIMSK0 |= (1<<OCIE0A);								// Enable timer 0 compare match interrupt
// // 	}
// // 	TIMSK0 &= ~(1<<OCIE0A);								// Disable timer 0 campare match interrupt
// // 	//_delay_ms(1000);										// delay 1 s
// // 	rc5CommandSent = 0;
// //
// //
// // 	while ()
// // 	{
// // 	}
// //
// //
//
// }































//
//
// #define NEW_DATA 1
//
//
//
//
// void IrComm::getExternIrCommRc5Data( uint8_t rc5SelecDataBase)
// {
// 	int rc5ByteNum = 12;
//
// 	switch(rc5SelecDataBase)
// 	{
//
// 		case NEW_DATA:
//
// 			selectData(rc5SelecDataBase);
//
// 			for (int i = 0; i < rc5ByteNum; i++)
// 			{
// 				externIrCommDataArray(*externRc5Data, i);
// 			}
//
// 			externIrCommDataBytes();
//
// 			irc.generateRc5DataFrame(IrComm::irCommSendData_00, IrComm::irCommSendData_01);
// 		break;
//
//
// // 		case IR_COMM_ENVIRONMENT_DATA_AVAILABLE:
// // 		break;
// // 		case IR_COMM_COORDINATES_DATA_AVAILABLE:
// // 		break;
// // 		case IR_COMM_POSITION_DATA_AVAILABLE:
// // 		break;
// // 		case IR_COMM_LIGHT_DATA_AVAILABLE:
// // 		break;
// // 		case IR_COMM_COLOR_DATA_AVAILABLE:
// // 		break;
// // 		case IR_COMM_SPEED_DATA_AVAILABLE:
// // 		break;
// // 		case IR_COMM_COMPASS_DATA_AVAILABLE:
// // 		break;
// // 		case IR_COMM_RESERVE_DATA_AVAILABLE:
// // 		break;
// 	}
//
//
//
//
//
// // 	for (int i = 0; i < rc5ByteNum; i++)
// // 	{
// // 		externIrCommDataArray(rc5DataBase, i);
// // 	}
// //
// // 	externIrCommDataBytes();
// //
// // 	irc.generateRc5DataFrame(IrComm::irCommSendData_00, IrComm::irCommSendData_01);
// }




/************************************************************************/
/*                         EXTERN IR DATA INPUT                         */
/************************************************************************/


// void IrComm::generateRc5DataFrame(uint64_t irCommSendData0, uint32_t irCommSendData1)
// {
// 	uint64_t irCommSendDataMask64 = 0x3F;
// 	uint32_t irCommSendDataMask32 = 0xFC;
//
// 	int irComm64 = 0;
// 	int irComm32 = 2;
// 	int irCommBitShift = 6;
//
// 	for(int i = 0; i < 10; i++)
// 	{
// 		irCommSendData[i] = ((irCommSendData0 & irCommSendDataMask64) >> irComm64);
// 		irCommSendDataMask64 = (irCommSendDataMask64 << irCommBitShift);
// 		irComm64 += irCommBitShift;
// 	}
//
// 	uint8_t bitsOf64 = ((irCommSendData0 & 0xF000000000000000) >> 60);
// 	uint8_t bitsOf32 = ((irCommSendData1 & 0x3) << 4);
//
// 	irCommSendData[10] = bitsOf32 | bitsOf64;
//
// 	for(int i = 11; i < 16; i++)
// 	{
// 		irCommSendData[i] = ((irCommSendData1 & irCommSendDataMask32) >> irComm32);
// 		irCommSendDataMask32 = (irCommSendDataMask32 << irCommBitShift);
// 		irComm32 += irCommBitShift;
// 	}
// }
//
//
//
//

//
//
// void externIrCommDataBytes()
// {
// 	uint64_t irCommSendDataMask64 = 0xFF;
// 	uint32_t irCommSendDataMask32 = 0xFF;
//
//  	int irComm64 = 0;
//  	int irComm32 = 0;
//  	int irCommBitShift = 8;
//
// 	for (int i = 0; i < 8; i++)
// 	{
// 		IrComm::irCommSendData_00 |= ((externIrCommRc5Data[i] & irCommSendDataMask64) << irComm64);
// 		irComm64 += irCommBitShift;
// 	}
//
// 	for (int i = 8; i < 12; i++)
// 	{
// 		IrComm::irCommSendData_01 |= ((externIrCommRc5Data[i] & irCommSendDataMask32) << irComm32);
// 		irComm32 += irCommBitShift;
// 	}
// }
//
//
//
// void externIrCommDataArray(uint8_t irCommRc5DataArray[12], int bytes)
// {
//
// 		externIrCommRc5Data[bytes] = irCommRc5DataArray[bytes];
//
//
// }













































