/*
 * IrCommDatabaseManegment.cpp
 *
 * Created: 30.08.2015 21:55:38
 *  Author: Fabio
 */ 
#include <string.h>

#include "IrCommDatabaseManegment.h"
#include "C:\Users\Fabio\Documents\Atmel Studio\6.2\Robot Main v0.1\RobotMain\srcMain\specificLibMain\RobotIrCommHardwareControl\IrComm\DatabaseManegmentFlags.h"
#include "C:\Users\Fabio\Documents\Atmel Studio\6.2\Robot Main v0.1\RobotMain\srcMain\specificLibMain\RobotIrCommHardwareControl\IrComm\IrComm.h"
#include "C:\Users\Fabio\Documents\Atmel Studio\6.2\Robot Main v0.1\RobotMain\srcMain\specificLibMain\RobotStatusLightHardwareControl\StatusLight\StatusLight.h"



DatabaseManegmentFlags dmf;
StatusLight l;
uint8_t IrCommDatabaseManegment::newData_TX[12] = {0};
uint8_t IrCommDatabaseManegment::newData_RX[12] = {0};

uint8_t irCommDataFrame_TX[16] = {0};
uint8_t irCommDataFrame_RX[16] = {0};
	
IrCommDatabaseManegment::IrCommDatabaseManegment(){}
	


void IrCommDatabaseManegment::putNewDataIntoDatabase()
{
	if (dmf.checkDatabaseFlag_TX())
	{
		//l.setStatusLightOk();
		if (dmf.checkTargetDatabaseFlag_TX())
		{
			/*	extern function get target	*/
			memcpy(newData_TX, colorDataArray, sizeof(externIrCommRc5Data));
			dmf.clearTargetDatabaseFlag_TX();
		}
		else if (dmf.checkEnvironmentDatabaseFlag_TX())
		{
			
			memcpy(newData_TX, externIrCommRc5Data, sizeof(externIrCommRc5Data));
			dmf.clearEnvironmentDatabaseFlag_TX();
		}
		else if (dmf.checkCoordinatesDatabaseFlag_TX())
		{
			memcpy(newData_TX, externIrCommRc5Data, sizeof(externIrCommRc5Data));
			dmf.clearCoordinatesDatabaseFlag_TX();
		}
		else if (dmf.checkPositionDatabaseFlag_TX())
		{
			memcpy(newData_TX, externIrCommRc5Data, sizeof(externIrCommRc5Data));
			dmf.clearPositionDatabaseFlag_TX();
		}
		else if (dmf.checkLightDatabaseFlag_TX())
		{
			memcpy(newData_TX, externIrCommRc5Data, sizeof(externIrCommRc5Data));
			dmf.clearLightDatabaseFlag_TX();
		}
		else if (dmf.checkColorDatabaseFlag_TX())
		{
			externColorData();
			for (int i = 0; i < 12; i++)
			{
				newData_TX[i] = colorDataArray[i];
			}
			
			/*memcpy(newData_TX, colorDataArray, sizeof(colorDataArray));*/
			dmf.clearColorDatabaseFlag_TX();
		}
		else if (dmf.checkSpeedDatabaseFlag_TX())
		{
			memcpy(newData_TX, externIrCommRc5Data, sizeof(externIrCommRc5Data));
			dmf.clearSpeedDatabaseFlag_TX();
		}
		else if (dmf.checkCompassDatabaseFlag_TX())
		{
			memcpy(newData_TX, externIrCommRc5Data, sizeof(externIrCommRc5Data));
			dmf.clearCompassDatabaseFlag_TX();
		}
		else if (dmf.checkReserveDatabaseFlag_TX())
		{
			memcpy(newData_TX, externIrCommRc5Data, sizeof(externIrCommRc5Data));
			dmf.clearReserveDatabaseFlag_TX();
		}
	}
}


void IrCommDatabaseManegment::convertDatabaseToRc5Command()
{
	uint64_t irCommData_00 = 0b0;
	uint32_t irCommData_01 = 0b0;
	
	uint64_t irCommDataMask64 = 0xFF;
	uint32_t irCommDataMask32 = 0xFF;
	
	int irComm64 = 0;
	int irComm32 = 0;
	int irCommBitShift = 8;
	
	for (int i = 0; i < 8; i++)
	{
		irCommData_00 |= ((newData_TX[i] & irCommDataMask64) << irComm64);
		irComm64 += irCommBitShift;
	}
	
	for (int i = 8; i < 12; i++)
	{
		irCommData_01 |= ((newData_TX[i] & irCommDataMask32) << irComm32);
		irComm32 += irCommBitShift;
	}
	
	
	irCommDataMask64 = 0x3F;
	irCommDataMask32 = 0xFC;
	
	irComm64 = 0;
	irComm32 = 2;
	irCommBitShift = 6;
	
	for(int i = 0; i < 10; i++)
	{
		irCommDataFrame_TX[i] = ((irCommData_00 & irCommDataMask64) >> irComm64);
		irCommDataMask64 = (irCommDataMask64 << irCommBitShift);
		irComm64 += irCommBitShift;
	}
	
	uint8_t bitsOf64 = ((irCommData_00 & 0xF000000000000000) >> 60);
	uint8_t bitsOf32 = ((irCommData_01 & 0x3) << 4);
	
	irCommDataFrame_TX[10] = bitsOf32 | bitsOf64;
	
	for(int i = 11; i < 16; i++)
	{
		irCommDataFrame_TX[i] = ((irCommData_01 & irCommDataMask32) >> irComm32);
		irCommDataMask32 = (irCommDataMask32 << irCommBitShift);
		irComm32 += irCommBitShift;
	}
}




void IrCommDatabaseManegment::putReceivedIRDataIntoDatabase()
{
	if (dmf.checkDatabaseFlag_RX())
	{
		if (dmf.checkTargetDatabaseFlag_RX())
		{
			/*	extern function get target	*/
			memcpy(newData_RX, colorDataArray, sizeof(externIrCommRc5Data));
			dmf.clearTargetDatabaseFlag_RX();
		}
		else if (dmf.checkEnvironmentDatabaseFlag_RX())
		{
			
			memcpy(newData_RX, externIrCommRc5Data, sizeof(externIrCommRc5Data));
			dmf.clearEnvironmentDatabaseFlag_RX();
		}
		else if (dmf.checkCoordinatesDatabaseFlag_RX())
		{
			memcpy(newData_RX, externIrCommRc5Data, sizeof(externIrCommRc5Data));
			dmf.clearCoordinatesDatabaseFlag_RX();
		}
		else if (dmf.checkPositionDatabaseFlag_RX())
		{
			memcpy(newData_RX, externIrCommRc5Data, sizeof(externIrCommRc5Data));
			dmf.clearPositionDatabaseFlag_RX();
		}
		else if (dmf.checkLightDatabaseFlag_RX())
		{
			memcpy(newData_RX, externIrCommRc5Data, sizeof(externIrCommRc5Data));
			dmf.clearLightDatabaseFlag_RX();
		}
		else if (dmf.checkColorDatabaseFlag_RX())
		{
			/*irmp RX externColorData();*/
			memcpy(newData_RX, colorDataArray, sizeof(colorDataArray));
			dmf.clearColorDatabaseFlag_RX();
		}
		else if (dmf.checkSpeedDatabaseFlag_RX())
		{
			memcpy(newData_RX, externIrCommRc5Data, sizeof(externIrCommRc5Data));
			dmf.clearSpeedDatabaseFlag_RX();
		}
		else if (dmf.checkCompassDatabaseFlag_RX())
		{
			memcpy(newData_RX, externIrCommRc5Data, sizeof(externIrCommRc5Data));
			dmf.clearCompassDatabaseFlag_RX();
		}
		else if (dmf.checkReserveDatabaseFlag_RX())
		{
			memcpy(newData_RX, externIrCommRc5Data, sizeof(externIrCommRc5Data));
			dmf.clearReserveDatabaseFlag_RX();
		}
	}
}






void IrCommDatabaseManegment::clearDatabase()
{
// IRMP_DATA   irmp_data;
// uint8_t cvb = irmp_get_data (IRMP_DATA * addr_t);

}



void IrCommDatabaseManegment::convertRc5CommandToDatabase()
{
	uint64_t irCommData_00 = 0b0;
	uint32_t irCommData_01 = 0b0;	
	
	uint64_t irCommDataMask = 0x3F;

	
	int irComm64 = 0;
	int irComm32 = 2;
	int irCommBitShift = 6;
	
	for(int i = 0; i < 10; i++)
	{
		irCommData_00 |= ((irCommDataFrame_RX[i] & irCommDataMask) << irComm64);
		irComm64 += irCommBitShift;
	}
	
	irCommData_00 |= ((irCommDataFrame_RX[10] & 0xF) << 60);
	irCommData_01 |= ((irCommDataFrame_RX[10] & 0x30) >> 4);
	
	for(int i = 11; i < 16; i++)
	{
		irCommData_01 |= ((irCommDataFrame_RX[i] & irCommDataMask) << irComm32);
		irComm32 += irCommBitShift;
	}

	irCommDataMask = 0xFF;
	
	irComm64 = 0;
	irComm32 = 0;
	irCommBitShift = 8;
	
	for (int i = 0; i < 8; i++)
	{
		newData_RX[i] = ((irCommData_00 & irCommDataMask) << irComm64);
		irComm64 += irCommBitShift;
	}
	
	for (int i = 8; i < 12; i++)
	{
		newData_RX[i] = ((irCommData_01 & irCommDataMask) << irComm32);
		irComm32 += irCommBitShift;
	}
}

	
	
	

	
	
/*
	
void DatabaseManegmentFlags::initialize();*/


/*

	bool IrCommDatabaseManegment::DatabaseManegmentFlags::checkDatabaseFlag_TX();
	void IrCommDatabaseManegment::DatabaseManegmentFlags::setDatabaseFlag_TX();
	void IrCommDatabaseManegment::DatabaseManegmentFlags::getDatabaseFlag_TX();
	bool IrCommDatabaseManegment::DatabaseManegmentFlags::checkDatabaseFlag_RX();
	void IrCommDatabaseManegment::DatabaseManegmentFlags::setDatabaseFlag_RX();
	void IrCommDatabaseManegment::DatabaseManegmentFlags::getDatabaseFlag_RX();	
	*/
	
	