/*
 * RobotHardwareControl.h
 *
 * Created: 08.08.2015 21:50:41
 *  Author: Fabio
 */ 


#ifndef ROBOTHARDWARECONTROL_H_
#define ROBOTHARDWARECONTROL_H_

#include <avr/io.h>


#define IR_COMMUNICATION_INPUT		DDRD &= ~(1 << PORTD2)		//input					DDRD |= 0x 1111 1011


#define	IR_LED_FRONT_MIDDLE_OUTPUT		DDRD |= (1 << PORTD7)			//output
#define IR_LED_FRONT_RIGHT_OUTPUT		DDRD |= (1 << PORTD5)
#define IR_LED_BACK_RIGHT_OUTPUT		DDRD |= (1 << PORTD4)
#define IR_LED_BACK_MIDDLE_OUTPUT		DDRD |= (1 << PORTD3)
#define IR_LED_BACK_LEFT_OUTPUT			DDRD |= (1 << PORTD1)
#define IR_LED_FRONT_LEFT_OUTPUT		DDRD |= (1 << PORTD0)

#define	IR_LED_FRONT_MIDDLE_OFF			PORTD &= ~(1 << PORTD7)		//high
#define IR_LED_FRONT_RIGHT_OFF			PORTD &= ~(1 << PORTD5)
#define IR_LED_BACK_RIGHT_OFF			PORTD &= ~(1 << PORTD4)
#define IR_LED_BACK_MIDDLE_OFF			PORTD &= ~(1 << PORTD3)
#define IR_LED_BACK_LEFT_OFF			PORTD &= ~(1 << PORTD1)
#define IR_LED_FRONT_LEFT_OFF			PORTD &= ~(1 << PORTD0)
#define	IR_LED_FRONT_MIDDLE_ON			PORTD |= (1 << PORTD7)		//low
#define IR_LED_FRONT_RIGHT_ON			PORTD |= (1 << PORTD5)
#define IR_LED_BACK_RIGHT_ON			PORTD |= (1 << PORTD4)
#define IR_LED_BACK_MIDDLE_ON			PORTD |= (1 << PORTD3)
#define IR_LED_BACK_LEFT_ON				PORTD |= (1 << PORTD1)
#define IR_LED_FRONT_LEFT_ON			PORTD |= (1 << PORTD0)
#define	IR_LED_FRONT_MIDDLE_TOGGLE		PORTD ^= (1 << PORTD7)		//toggle
#define IR_LED_FRONT_RIGHT_TOGGLE		PORTD ^= (1 << PORTD5)
#define IR_LED_BACK_RIGHT_TOGGLE		PORTD ^= (1 << PORTD4)
#define IR_LED_BACK_MIDDLE_TOGGLE		PORTD ^= (1 << PORTD3)
#define IR_LED_BACK_LEFT_TOGGLE			PORTD ^= (1 << PORTD1)
#define IR_LED_FRONT_LEFT_TOGGLE		PORTD ^= (1 << PORTD0)


#define	IR_PORT			PIND

#define IR_LED_FRONT_MIDDLE_PORT_BIT	0x80
#define IR_LED_FRONT_RIGHT_PORT_BIT		0x20
#define IR_LED_BACK_RIGHT_PORT_BIT		0x10
#define IR_LED_BACK_MIDDLE_PORT_BIT		0x08
#define IR_LED_BACK_LEFT_PORT_BIT		0x02
#define IR_LED_FRONT_LEFT_PORT_BIT		0x01

#define IR_LED_STATE_OFF			0
#define IR_LED_STATE_ON				1
#define IR_LED_STATE_TOGGLE			2





#define RGB_LED_RED_OUTPUT		DDRB |= (1 << PORTB2)
#define RGB_LED_GREEN_OUTPUT	DDRD |= (1 << PORTD6)
#define RGB_LED_BLUE_OUTPUT		DDRB |= (1 << PORTB1)

#define RGB_LED_RED_OFF			PORTB |= (1 << PORTB2)
#define RGB_LED_GREEN_OFF		PORTD |= (1 << PORTD6)
#define RGB_LED_BLUE_OFF		PORTB |= (1 << PORTB1)
#define RGB_LED_RED_ON			PORTB &= ~(1 << PORTB2)
#define RGB_LED_GREEN_ON		PORTD &= ~(1 << PORTD6)
#define RGB_LED_BLUE_ON			PORTB &= ~(1 << PORTB1)
#define RGB_LED_RED_TOGGLE		PORTB ^= (1 << PORTB2)
#define RGB_LED_GREEN_TOGGLE	PORTD ^= (1 << PORTD6)
#define RGB_LED_BLUE_TOGGLE		PORTB ^= (1 << PORTB1)


#define	RB_LED_PORT		PINB
#define G_LED_PORT		PIND

#define RGB_LED_R_PORT_BIT		0x04		//(1 << PORTB2)
#define RGB_LED_G_PORT_BIT		0x40		//(1 << PORTD6)
#define RGB_LED_B_PORT_BIT		0x02

#define RGB_LED_STATE_OFF			0
#define RGB_LED_STATE_ON			1
#define RGB_LED_STATE_TOGGLE		2

#define	RGB_LED_STATE_RED_ON		RGB_LED_STATE_ON
#define	RGB_LED_STATE_RED_OFF		RGB_LED_STATE_OFF
#define	RGB_LED_STATE_RED_TOGGLE	RGB_LED_STATE_TOGGLE
#define RGB_LED_STATE_GREEN_ON		RGB_LED_STATE_ON
#define RGB_LED_STATE_GREEN_OFF		RGB_LED_STATE_OFF
#define	RGB_LED_STATE_GREEN_TOGGLE	RGB_LED_STATE_TOGGLE
#define RGB_LED_STATE_BLUE_ON		RGB_LED_STATE_ON
#define RGB_LED_STATE_BLUE_OFF		RGB_LED_STATE_OFF
#define	RGB_LED_STATE_BLUE_TOGGLE	RGB_LED_STATE_TOGGLE







#define IR_TRANSISTOR_FRONT_MIDDLE_INPUT		ADMUX |= (0 << MUX3)|(0 << MUX2)|(0 << MUX1)|(0 << MUX0)		//Channel 0; Pin PC0
#define IR_TRANSISTOR_FRONT_RIGHT_INPUT			ADMUX |= (0 << MUX3)|(0 << MUX2)|(0 << MUX1)|(1 << MUX0)		//Channel 1; Pin PC1
#define IR_TRANSISTOR_BACK_RIGHT_INPUT			ADMUX |= (0 << MUX3)|(0 << MUX2)|(1 << MUX1)|(0 << MUX0)		//Channel 2; Pin PC2
#define IR_TRANSISTOR_BACK_MIDDLE_INPUT			ADMUX |= (0 << MUX3)|(0 << MUX2)|(1 << MUX1)|(1 << MUX0)		//Channel 3; Pin PC3
#define IR_TRANSISTOR_BACK_LEFT_INPUT			ADMUX |= (1 << MUX3)|(1 << MUX2)|(1 << MUX1)|(0 << MUX0)		//Channel 6; Pin PC0
#define IR_TRANSISTOR_FRONT_LEFT_INPUT			ADMUX |= (0 << MUX3)|(1 << MUX2)|(1 << MUX1)|(1 << MUX0)		//Channel 7; Pin PC0


#define DEFAULT_HARDWARE_STATE_CHECK_OK							// BLINKSCHEMA [----  --  ----  --  ----...] GREEN/5s
#define DEFAULT_HARDWARE_STATE_CHECK_FAIL						// BLINKSCHEMA [----  --  ----  --  ----...] RED/5s
#define SOFTWARE_HARDWARE_STATE_CHECK_OK
#define SOFTWARE_HARDWARE_STATE_CHECK_FAIL



class RobotHardwareControl
{
	public:
		RobotHardwareControl();
		//RobotHardwareControl(DEFAULT);
		
		void initialize();

		
		uint8_t getIrLedFrontMiddle();
		void setIrLedFrontMiddle(uint8_t irLedFrontMiddleOutput, uint8_t irLedFrontMiddleValue);
		uint8_t getIrLedFrontRight();
		void setIrLedFrontRight(uint8_t irLedFrontRight, uint8_t irLedFrontRightValue);
		uint8_t getIrLedBackRight();
		void setIrLedBackRight(uint8_t irLedBackRight, uint8_t irLedBackRightValue);
		uint8_t getIrLedBackMiddle();
		void setIrLedBackMiddle(uint8_t irLedBackMiddle, uint8_t irLedBackMiddleValue);
		uint8_t getIrLedBackLeft();
		void setIrLedBackLeft(uint8_t irLedBackLeft, uint8_t irLedBackLeftValue);
		uint8_t getIrLedFrontLeft();
		void setIrLedFrontLeft(uint8_t irLedFrontLeft, uint8_t irLedFrontLeftValue);
		
		
		uint8_t getRgbLedRed();
		void setRgbLedRed(uint8_t rgbLedRed, uint8_t rgbLedRedValue);
		uint8_t getRgbLedGreen();
		void setRgbLedGreen(uint8_t rgbLedGreen, uint8_t rgbLedGreenValue);
		uint8_t getRgbLedBlue();
		void setRgbLedBlue(uint8_t rgbLedBlue, uint8_t rgbLedBlueValue);
		
		
		uint8_t getIrTransistorFrontMiddle();
		void setIrTransistorFrontMiddle(uint8_t irTransistorFrontMiddle);
		uint8_t getIrTransistorFrontRight();
		void setIrTransistorFrontRight(uint8_t irTransistorFrontRight);
		uint8_t getIrTransistorBackRight();
		void setIrTransistorBackRight(uint8_t irTransistorBackRight);
		uint8_t getIrTransistorBackMiddle();
		void setIrTransistorBackMiddle(uint8_t irTransistorBackMiddle);
		uint8_t getIrTransistorBackLeft();
		void setIrTransistorBackLeft(uint8_t irTransistorBackLeft);
		uint8_t getIrTransistorFrontLeft();
		void setIrTransistorFrontLeft(uint8_t irTransistorFrontLeft);
		
		
		uint8_t getDefaultHardwareState();
		uint8_t getSoftwareHardwareState();
		
		
		
		
		
		
		
		union
		{
			uint8_t rgbLedStateRed;
			uint8_t rgbLedStateGreen;
			uint8_t rgbLedStateBlue;
			
		}rgbLedState_u;
		

		union
		{
			uint8_t irLedFrontMiddle;
			uint8_t irLedFrontRight;
			uint8_t irLedBackRight;
			uint8_t irLedBackMiddle;
			uint8_t irLedBackLeft;
			uint8_t irLedFrontLeft;
			
		}irLedState_u;
		
		
		
		union
		{
			uint8_t irTransistorFrontMiddle;
			uint8_t irTransistorFrontRight;
			uint8_t irTransistorBackRight;
			uint8_t irTransistorBackMiddle;
			uint8_t irTransistorBackLeft;
			uint8_t irTransistorFrontLeft;
			
		}irTransistorState_u;
		
		
	protected:
// 		typedef enum irLedState_e
// 		{
// 			
// 			
// 		};
		

			
		//uint8_t rgbLedState;
		uint8_t irTransistorState;
		
		
	private:

	
	
};


#endif /* ROBOTHARDWARECONTROL_H_ */