/* 
* srcMott.cpp
*
* Created: 08.10.2015 13:36:47
* Author: Fabio
*/


#include "srcMott.h"

// default constructor
srcMott::srcMott()
{
} //srcMott

// default destructor
srcMott::~srcMott()
{
} //~srcMott

void srcMott::configIO(int8_t ddr, int8_t pin, int8_t mode)
{
	switch (mode)
	{
		case OUTPUT:
		switch (ddr)
		{
			case DDR_B:
			DDRB |= (1 << pin);
			break;
			case DDR_C:
			DDRC |= (1 << pin);
			break;
			case DDR_D:
			DDRD |= (1 << pin);
			break;
		}
		break;
		case INPUT:
		switch (ddr)
		{
			case DDR_B:
			DDRB &= ~(1 << pin);
			break;
			case DDR_C:
			DDRC &= ~(1 << pin);
			break;
			case DDR_D:
			DDRD &= ~(1 << pin);
			break;
		}
		break;
	}
}

void srcMott::configOcrIO(int8_t ocr, int8_t mode)
{
	switch (mode)
	{
		case MOD_NORMAL:
		switch (ocr)
		{
			case OCR0_A:
			TCCR0A &= ~((1 << WGM01) | (1 << WGM00));
			TCCR0A &= ~((1 << COM0A1) | (1 << COM0A0));
			break;
			case OCR0_B:
			TCCR0A &= ~((1 << WGM01) | (1 << WGM00));
			TCCR0A &= ~((1 << COM0B1) | (1 << COM0B0));
			break;
			case OCR1_A:
			TCCR1A &= ~((1 << WGM10));
			TCCR1A &= ~((1 << COM1A1) | (1 << COM1A0));
			break;
			case OCR1_B:
			TCCR1A &= ~((1 << WGM10));
			TCCR1A &= ~((1 << COM1B1) | (1 << COM1B0));
			break;
			case OCR2_A:
			TCCR2A &= ~((1 << WGM21) | (1 << WGM20));
			TCCR2A &= ~((1 << COM2A1) | (1 << COM2A0));
			break;
			case OCR2_B:
			TCCR2A &= ~((1 << WGM21) | (1 << WGM20));
			TCCR2A &= ~((1 << COM2B1) | (1 << COM2B0));
			break;
		}
		break;
		case MOD_FAST_PWM:
		switch (ocr)
		{
			case OCR0_A:
			TCCR0A |= ((1 << WGM01) | (1 << WGM00));
			TCCR0A |= (1 << COM0A1);
			break;
			case OCR0_B:
			TCCR0A |= ((1 << WGM01) | (1 << WGM00));
			TCCR0A |= (1 << COM0B1);
			break;
			case OCR1_A:
			TCCR1A |= ((1 << WGM10));
			TCCR1A |= (1 << COM1A1);
			break;
			case OCR1_B:
			TCCR1A |= ((1 << WGM10));
			TCCR1A |= (1 << COM1B1);
			break;
			case OCR2_A:
			TCCR2A |= ((1 << WGM21) | (1 << WGM20));
			TCCR1A |= (1 << COM2A1);
			break;
			case OCR2_B:
			TCCR2A |= ((1 << WGM21) | (1 << WGM20));
			TCCR1A |= (1 << COM2B1);
			break;
		}
		break;
	}
}

void srcMott::valueIO(int8_t port, int8_t pin, int8_t value)
{
	switch (value)
	{
		case HIGH:
		switch (port)
		{
			case PORT_B:
			PORTB |= (1 << pin);
			break;
			case PORT_C:
			PORTC |= (1 << pin);
			break;
			case PORT_D:
			PORTD |= (1 << pin);
			break;
		}
		break;
		case LOW:
		switch (port)
		{
			case PORT_B:
			PORTB &= ~(1 << pin);
			break;
			case PORT_C:
			PORTC &= ~(1 << pin);
			break;
			case PORT_D:
			PORTD &= ~(1 << pin);
			break;
		}
		break;
	}
}