
/*
 * asm_ircom.s
 *
 * Created: 26.11.2015 16:28:51
 *  Author: Fabio
 */ 
#include <avr/io.h>

#include "c_ircom.h"

tmp = 16

 .global asm_rc5send


 .section .data

 rc5flags:	.byte 1
 .set rc5halfbittimingflag, 1
 .set rc5bittimingflag, 2
 
 
 
 .section .bss



 .section .text


 asm_rc5send:
				brne asm_popregtostp
 ret

 asm_popregtostp:

 ret

 .global asm_initRc5Tim
asm_initRc5Tim:

/*
	ldi r16, hi8(RAMEND)
	out _SFR_IO_ADDR(SPH), r16
	ldi r16, lo8(RAMEND)
	out _SFR_IO_ADDR(SPL), r16
*/

	ldi r16, 0x02
	out _SFR_IO_ADDR(TCCR0A), r16		;tim 0 ctc mode
	ldi r16, 0x02
	out _SFR_IO_ADDR(TCCR0B), r16		;tim 0 1/8 clock source
	ldi r16, 0x02
	sts TIMSK0, r16		;tim 0 comparer match A INT
	ldi r16, 0x04
	out _SFR_IO_ADDR(OCR0A), r16		;tim 0 TOP <- ocr0a

	ldi r16, 0x02
	sts TCCR2A, r16		;tim 2 ctc mode
	ldi r16, 0x01
	sts TCCR2B, r16		;tim 2 clock source
	ldi r16, 0x02
	sts TIMSK2, r16		;tim 2 compare match A INT
	ldi r16, 0x6e
	sts OCR2A, r16		; tim 2 TOP <- ocr2a

	rc5Timing:
	clr r16
	ori r16, !rc5halfbittimingflag
	eor r1, r16
	sts rc5flags, r1
//	ori r16, !rc5bittimingflag
	clr r17
	clr r18
	clr r19
	sei

 ret



 .global TIMER2_COMPA_vect
 	TIMER2_COMPA_vect:
		in r0, _SFR_IO_ADDR(SREG)
		lds r1, rc5flags
		sbrs r1, 0
		breq rc5send1
		sbrc r1, 0
		breq rc5send2
	rc5send1:	;low
		mov r25, r21
		and r25, r23
		cpse r25, r23
		breq rc5send4
		brne rc5send3
	rc5send2:	;high
		mov r25, r21
		com r25
		and r25, r23
		cpse r25, r23
		breq rc5send4
		brne rc5send3
	rc5send3:	;off
		cbi _SFR_IO_ADDR(PORTD), 7
		brne tim2CTCexit
	rc5send4:	;toggle
		in r1, _SFR_IO_ADDR(PORTD)
		ori r16, 128
		eor r1, r16
		out _SFR_IO_ADDR(PORTD), r1
	tim2CTCexit:
		out _SFR_IO_ADDR(SREG), r0
 reti



 .global TIMER0_COMPA_vect
	TIMER0_COMPA_vect:
		in r0, _SFR_IO_ADDR(SREG)		;store status register
		inc r17			;inc conter low byte
		brne rc5Timing1
		inc r18			;inc counter high byte
	rc5Timing1:
		cpi r18, 0x00
		brlo tim0CTCexit
	rc5Timing2:
		cpi r17, 0xb1
		brlo tim0CTCexit
	rc5Timing3:
		lds r1, rc5flags
		ori r16, rc5halfbittimingflag
		eor r1, r16
		sts rc5flags, r1
		clr r16
		ori r16, rc5bittimingflag
		eor r1, r16
		sts rc5flags, r1
		clr r16
		clr r17
		clr r18
		sbrs r1, 1
		lsr r23
		brlo rc5timing4
		jmp tim0CTCexit
	rc5timing4:
		ldi r23, 0x80
		mov r21, r22
	tim0CTCexit:
		out _SFR_IO_ADDR(SREG), r0	;restore status register
	reti