
/*
 * rc5_tx.s
 *
 * Created: 04.01.2016 23:05:49
 *  Author: Fabio
 */ 



  #include <avr/io.h>
 #include <avr/interrupt.h>
 #include "rc5/tx/h/rc5_tx.h"


  .section .data









	



 .section .text

	.set rc5halfbittimingflag, 1
	.set rc5nextbitflag, 2
	.set rc5togglebitflag, 4
	.set rc5txdoneflag, 8






 .global init_rc5_tx_asm
	init_rc5_tx_asm:


		ldi rc5tmp, 0x02
		out _SFR_IO_ADDR(TCCR0A), rc5tmp		;tim 0 ctc mode
		ldi rc5tmp, 0x01
		out _SFR_IO_ADDR(TCCR0B), rc5tmp		;tim 0 1/8 clock source
		ldi rc5tmp, 0x02
		sts TIMSK0, rc5tmp		;tim 0 comparer match A INT
		ldi rc5tmp, 0x03
		out _SFR_IO_ADDR(OCR0A), rc5tmp		;tim 0 TOP <- ocr0a
		/*
		ldi rc5tmp, 0x02
		sts TCCR2A, rc5tmp		;tim 2 ctc mode
		ldi rc5tmp, 0x01
		sts TCCR2B, rc5tmp		;tim 2 clock source
			ldi rc5tmp, 0x00
			sts TIMSK2, rc5tmp		;tim 2 compare match A INT
		ldi rc5tmp, 0x6e
		sts OCR2A, rc5tmp		; tim 2 TOP <- ocr2a
		*/

		ldi rc5tmp, 0xbb
		out _SFR_IO_ADDR(DDRD), rc5tmp

		ldi rc5tmp, 0b1000000
		mov rc5decodemask, rc5tmp

		ldi rc5tmp, 15
		mov rc5decodebits, rc5tmp



	sei


 ret


















  .global asm_rc5send
	asm_rc5send:

		//clr r17
		mov rc5tmp, r24
		ori rc5tmp, 0xc0
		mov rc5hibyte, rc5tmp
		mov rc5lobyte, r22
		ldi rc5tmp, 0b10000000
		mov rc5mask, rc5tmp
		ldi rc5tmp, 14
		mov rc5bits, rc5tmp

		ldi rc5tmp, 0x02
		cli
		sts TIMSK0, rc5tmp
//		cbi _SFR_IO_ADDR(EIMSK), 0
		sei

	asm_rc5send0:
		clr rc5tmp
		//		out _SFR_IO_ADDR(TCNT0), rc5tmp
		ori rc5tmp, rc5halfbittimingflag
		eor rc5tmpflag, rc5tmp

		mov rc5tmp, rc5hibyte
		and rc5tmp, rc5mask
		cpse rc5tmp, rc5mask
		breq asm_rc5send1		;0
		;	1
		ldi rc5tmp, 0x01
		cp rc5tmpflag, rc5tmp
		breq asm_rc5send3
		brne asm_rc5send2

	asm_rc5send1:
		;	0
		ldi rc5tmp, 0x01
		cp rc5tmpflag, rc5tmp
		breq asm_rc5send2
		brne asm_rc5send3

	asm_rc5send2:
		;	high
 		ldi rc5tmp, 0x02
		cli
		sts TIMSK2, rc5tmp
		sei
		brie asm_rc5send4

	asm_rc5send3:
		;	low
		ldi rc5tmp, 0x00
		cli
		sts TIMSK2, rc5tmp
		sei
		in r16, _SFR_IO_ADDR(PORTD)
		clr r16
		out _SFR_IO_ADDR(PORTD), r16


	asm_rc5send4:
		cpi rc5cnt, 0x61		//0x64
		brne asm_rc5send4

		clr rc5cnt
		ldi rc5tmp, 0x01
		cp rc5tmpflag, rc5tmp
		breq asm_rc5send6

	asm_rc5send5:
		lsr rc5mask
		dec rc5bits
		ldi rc5tmp, 0x00
		cp rc5mask, rc5tmp
		brne asm_rc5send6
		ldi rc5tmp, 0x80
		mov rc5mask, rc5tmp
		mov rc5hibyte, rc5lobyte

	asm_rc5send6:
		tst rc5bits
		brne asm_rc5send0

	done:
		clr rc5tmp
		cli
		sts TIMSK2, rc5tmp
		ldi rc5tmp, 0x01
		sts EICRA, rc5tmp
		sbi _SFR_IO_ADDR(EIMSK), 0
		sei
		in r16, _SFR_IO_ADDR(PORTD)
		clr r16
		out _SFR_IO_ADDR(PORTD), r16
		
		ldi rc5tmp, 255
	idle:
		
		cpi rc5cnt, 0x61
		brne idle
		clr rc5cnt
		dec rc5tmp
		tst rc5tmp
		brne idle
//		cli
//		sts TIMSK0, rc5tmp
//		sbi _SFR_IO_ADDR(EIMSK), 0
//		sei
	asm_rc5send_exit:

 ret




  .global TIMER2_COMPA_vect
 	TIMER2_COMPA_vect:
		
		in inreg, _SFR_IO_ADDR(SREG) ; Store SREG
		push inreg

		push rc5tmp
		clr rc5tmp
		in inreg, _SFR_IO_ADDR(PORTD)
		or rc5tmp, c_rc5led
		eor inreg, rc5tmp
		out _SFR_IO_ADDR(PORTD), inreg
		pop rc5tmp


		pop inreg
		out _SFR_IO_ADDR(SREG), inreg
		
 reti












