/*
 * IrCommHardwareControl.h
 *
 * Created: 11.08.2015 16:43:16
 *  Author: Fabio
 */ 


#ifndef IRCOMMHARDWARECONTROL_H_
#define IRCOMMHARDWARECONTROL_H_



#include <avr/io.h>




#define IR_COMMUNICATION_INPUT		DDRD &= ~(1 << DDD2)		//input					DDRD |= 0x 1111 1011

#define IR_LED_DDRD		DDRD

#define	IR_LED_FRONT_MIDDLE_OUTPUT		DDRD |= (1 << DDD7)			//output
#define IR_LED_FRONT_RIGHT_OUTPUT		DDRD |= (1 << DDD5)
#define IR_LED_BACK_RIGHT_OUTPUT		DDRD |= (1 << DDD4)
#define IR_LED_BACK_MIDDLE_OUTPUT		DDRD |= (1 << DDD3)
#define IR_LED_BACK_LEFT_OUTPUT			DDRD |= (1 << DDD1)
#define IR_LED_FRONT_LEFT_OUTPUT		DDRD |= (1 << DDD0)

#define	IR_LED_FRONT_MIDDLE_OFF			PORTD &= ~(1 << DDD7)		//high
#define IR_LED_FRONT_RIGHT_OFF			PORTD &= ~(1 << DDD5)
#define IR_LED_BACK_RIGHT_OFF			PORTD &= ~(1 << DDD4)
#define IR_LED_BACK_MIDDLE_OFF			PORTD &= ~(1 << DDD3)
#define IR_LED_BACK_LEFT_OFF			PORTD &= ~(1 << DDD1)
#define IR_LED_FRONT_LEFT_OFF			PORTD &= ~(1 << DDD0)
#define	IR_LED_FRONT_MIDDLE_ON			PORTD |= (1 << DDD7)		//low
#define IR_LED_FRONT_RIGHT_ON			PORTD |= (1 << DDD5)
#define IR_LED_BACK_RIGHT_ON			PORTD |= (1 << DDD4)
#define IR_LED_BACK_MIDDLE_ON			PORTD |= (1 << DDD3)
#define IR_LED_BACK_LEFT_ON				PORTD |= (1 << DDD1)
#define IR_LED_FRONT_LEFT_ON			PORTD |= (1 << DDD0)
#define	IR_LED_FRONT_MIDDLE_TOGGLE		PORTD ^= (1 << DDD7)		//toggle
#define IR_LED_FRONT_RIGHT_TOGGLE		PORTD ^= (1 << DDD5)
#define IR_LED_BACK_RIGHT_TOGGLE		PORTD ^= (1 << DDD4)
#define IR_LED_BACK_MIDDLE_TOGGLE		PORTD ^= (1 << DDD3)
#define IR_LED_BACK_LEFT_TOGGLE			PORTD ^= (1 << DDD1)
#define IR_LED_FRONT_LEFT_TOGGLE		PORTD ^= (1 << DDD0)


#define	IR_PORT			PIND

#define IR_LED_FRONT_MIDDLE_PORT_BIT	0x80
#define IR_LED_FRONT_RIGHT_PORT_BIT		0x20
#define IR_LED_BACK_RIGHT_PORT_BIT		0x10
#define IR_LED_BACK_MIDDLE_PORT_BIT		0x08
#define IR_LED_BACK_LEFT_PORT_BIT		0x02
#define IR_LED_FRONT_LEFT_PORT_BIT		0x01

#define IR_LED_STATE_OFF			0
#define IR_LED_STATE_ON				1
#define IR_LED_STATE_TOGGLE			2






#endif /* IRCOMMHARDWARECONTROL_H_ */