/*
 * StatusLightHardwareControl.cpp
 *
 * Created: 11.08.2015 16:30:26
 *  Author: Fabio
 */ 

#include "StatusLightHardwareControl.h"



StatusLightHardwareControl::StatusLightHardwareControl(){}


	
	
void StatusLightHardwareControl::initialize()
{
	setRgbLedRedOutput();
	setRgbLedGreenOutput();
	setRgbLedBlueOutput();
	
	setTimer0Config();
	setTimer1Config();
	setTimer2Config();
	setTimer2Off();

	

		
		
}



uint8_t StatusLightHardwareControl::getInitializeHardwareState()
{
	uint8_t initializeHardwareState;
	
	if (getRgbLedRedOutput() == ON_OK && 
		getRgbLedGreenOutput() == ON_OK && 
		getRgbLedBlueOutput() == ON_OK && 
		getTimer0Config() == ON_OK &&
		getTimer1Config() == ON_OK &&
		getTimer2Config() == ON_OK)
	{
		initializeHardwareState = ON_OK;
	}
	else
	{
		initializeHardwareState = OFF_FAIL;
	}
	
	return initializeHardwareState;
}






uint8_t StatusLightHardwareControl::getRgbLedRedOutput()
{
	uint8_t rgbLedRedOutput;
	if (RGB_LED_RED_BLUE_DDRB & RGB_LED_RED_OUTPUT_ON)
	{
		rgbLedRedOutput = ON_OK;
	}
	else if (RGB_LED_RED_BLUE_DDRB & RGB_LED_RED_OUTPUT_OFF)
	{
		rgbLedRedOutput = OFF_FAIL;
	}
	
	return rgbLedRedOutput;
}
void StatusLightHardwareControl::setRgbLedRedOutput()
{
	RGB_LED_RED_OUTPUT;
}


uint8_t StatusLightHardwareControl::getRgbLedGreenOutput()
{
	uint8_t rgbLedGreenOutput;
	if (RGB_LED_GREEN_DDRD & RGB_LED_GREEN_OUTPUT_ON)
	{
		rgbLedGreenOutput = ON_OK;
	}
	else if (RGB_LED_GREEN_DDRD & RGB_LED_GREEN_OUTPUT_OFF)
	{
		rgbLedGreenOutput = OFF_FAIL;
	}
	
	return rgbLedGreenOutput;
}
void StatusLightHardwareControl::setRgbLedGreenOutput()
{
	RGB_LED_GREEN_OUTPUT;
}


uint8_t StatusLightHardwareControl::getRgbLedBlueOutput()
{
	uint8_t rgbLedBlueOutput;
	if (RGB_LED_RED_BLUE_DDRB & RGB_LED_BLUE_OUTPUT_ON)
	{
		rgbLedBlueOutput = ON_OK;
	}
	else if (RGB_LED_RED_BLUE_DDRB & RGB_LED_BLUE_OUTPUT_OFF)
	{
		rgbLedBlueOutput = OFF_FAIL;
	}
	
	return rgbLedBlueOutput;
}
void StatusLightHardwareControl::setRgbLedBlueOutput()
{
	RGB_LED_BLUE_OUTPUT;
}









uint8_t StatusLightHardwareControl::getTimer0Config()
{
	uint8_t timer0Config;
	
	if ((TIMER0_CONTROL_REGISTER_0A & CLOCK_SELECT_BIT_NO_PRESCALING_TIMER0_ON) && (TIMER0_CONTROL_REGISTER_0B & COMPARE_OUTPUT_MODE_FAST_PWM_TIMER0_ON))
	{
		timer0Config = ON_OK;
	}
	else
	{
		timer0Config = OFF_FAIL;
	}
	
	return timer0Config;
}
void StatusLightHardwareControl::setTimer0Config()
{
	TIMER0_CONTROL_REGISTER_0A = COMPARE_OUTPUT_MODE_FAST_PWM_TIMER0;
	TIMER0_CONTROL_REGISTER_0B = CLOCK_SELECT_BIT_NO_PRESCALING_TIMER0;
}
void StatusLightHardwareControl::setTimer0Off()
{
	TIMER0_CONTROL_REGISTER_0B &= ~CLOCK_SELECT_BIT_NO_PRESCALING_TIMER0;
}
void StatusLightHardwareControl::setTimer0On()
{
	TIMER0_CONTROL_REGISTER_0B |= CLOCK_SELECT_BIT_NO_PRESCALING_TIMER0;
}


uint8_t StatusLightHardwareControl::getTimer1Config()
{
	uint8_t timer1Config;
	
	if ((TIMER1_CONTROL_REGISTER_1A & CLOCK_SELECT_BIT_NO_PRESCALING_TIMER1_ON) && 
		(TIMER1_CONTROL_REGISTER_1B & COMPARE_OUTPUT_MODE_FAST_PWM_TIMER1_ON))
	{
		timer1Config = ON_OK;
	}
	else
	{
		timer1Config = OFF_FAIL;
	}
	
	return timer1Config;
}
void StatusLightHardwareControl::setTimer1Config()
{
	TIMER1_CONTROL_REGISTER_1A = COMPARE_OUTPUT_MODE_FAST_PWM_TIMER1;
	
	TIMER1_CONTROL_REGISTER_1B = CLOCK_SELECT_BIT_NO_PRESCALING_TIMER1;
}
void StatusLightHardwareControl::setTimer1Off()
{

	TIMER1_CONTROL_REGISTER_1B &= ~CLOCK_SELECT_BIT_NO_PRESCALING_TIMER1;
}
void StatusLightHardwareControl::setTimer1On()
{

	TIMER1_CONTROL_REGISTER_1B |= CLOCK_SELECT_BIT_NO_PRESCALING_TIMER1;

}


uint8_t StatusLightHardwareControl::getTimer2Config()
{
	uint8_t timer2Config;
	
	if ((TIMER2_CONTROL_REGISTER_2A & COMPARE_OUTPUT_MODE_FAST_PWM_TIMER2_ON) &&
		(TIMER2_CONTROL_REGISTER_2B & CLOCK_SELECT_BIT_NO_PRESCALING_TIMER2_ON))
	{
		timer2Config = ON_OK;
	}
	else
	{
		timer2Config = OFF_FAIL;
	}
	
	return timer2Config;
}
void StatusLightHardwareControl::setTimer2Config()
{
	TIMER2_CONTROL_REGISTER_2A = COMPARE_OUTPUT_MODE_FAST_PWM_TIMER2;
	TIMER2_CONTROL_REGISTER_2B = CLOCK_SELECT_BIT_NO_PRESCALING_TIMER2;
	OUTPUT_COMPARE_REGISTER;
	TIMER2_COMPA_INTERRUPT;
	//sei();
}
void StatusLightHardwareControl::setTimer2Off()
{
	TIMER2_CONTROL_REGISTER_2B &= ~CLOCK_SELECT_BIT_NO_PRESCALING_TIMER2_OFF;
	cli();
}
void StatusLightHardwareControl::setTimer2On()
{
	TIMER2_CONTROL_REGISTER_2B |= CLOCK_SELECT_BIT_NO_PRESCALING_TIMER2_ON;
	sei();
}


 

// void StatusLightHardwareControl::setRgbLedLongPulse(uint16_t longPulse)
// {
// 		if (rhc.timer2Value <= 5000)
// 		{
// 			sl.setRgbLedCostumGreen(245);
// 		}else
// 		{
// 			sl.setRgbLedCostomOff();
// 		}
// }
 




// uint8_t StatusLightHardwareControl::getRgbLedRed()
// {
// 	if (!(RB_LED_PORT & RGB_LED_R_PORT_BIT))
// 	{
// 		rgbLedState_u.rgbLedStateRed = RGB_LED_STATE_ON;
// 	}
// 	else if (RB_LED_PORT & RGB_LED_R_PORT_BIT)
// 	{
// 		rgbLedState_u.rgbLedStateRed = RGB_LED_STATE_OFF;
// 	}
// 
// 	return rgbLedState_u.rgbLedStateRed;
// }
// 
// void StatusLightHardwareControl::setRgbLedRed(uint8_t rgbLedRed, uint8_t rgbLedRedValue){}
// 
// 
// uint8_t StatusLightHardwareControl::getRgbLedGreen()
// {
// 	if (!(G_LED_PORT & RGB_LED_G_PORT_BIT))
// 	{
// 		rgbLedState_u.rgbLedStateGreen = RGB_LED_STATE_ON;
// 	}
// 	else if (G_LED_PORT & RGB_LED_G_PORT_BIT)
// 	{
// 		rgbLedState_u.rgbLedStateGreen = RGB_LED_STATE_OFF;
// 	}
// 
// 	return rgbLedState_u.rgbLedStateGreen;
// }
// void StatusLightHardwareControl::setRgbLedGreen(uint8_t rgbLedGreen, uint8_t rgbLedGreenValue){}
// 
// 
// uint8_t StatusLightHardwareControl::getRgbLedBlue()
// {
// 	if (!(RB_LED_PORT & RGB_LED_B_PORT_BIT))
// 	{
// 		rgbLedState_u.rgbLedStateBlue = RGB_LED_STATE_ON;
// 	}
// 	else if (RB_LED_PORT & RGB_LED_B_PORT_BIT)
// 	{
// 		rgbLedState_u.rgbLedStateBlue = RGB_LED_STATE_OFF;
// 	}
// 
// 	return rgbLedState_u.rgbLedStateBlue;
// }
// void StatusLightHardwareControl::setRgbLedBlue(uint8_t rgbLedBlue, uint8_t rgbLedBlueValue){}



























