/*
 * StatusLightHardwareControl.h
 *
 * Created: 11.08.2015 16:30:33
 *  Author: Fabio
 */ 


#ifndef STATUSLIGHTHARDWARECONTROL_H_
#define STATUSLIGHTHARDWARECONTROL_H_

#include <avr/io.h>
#include <avr/interrupt.h>

#define RGB_LED_RED_OUTPUT		DDRB |= (1 << DDB2)
#define RGB_LED_GREEN_OUTPUT	DDRD |= (1 << DDD6)
#define RGB_LED_BLUE_OUTPUT		DDRB |= (1 << DDB1)

#define RGB_LED_RED_BLUE_DDRB	DDRB
#define RGB_LED_GREEN_DDRD		DDRD

#define RGB_LED_RED_OUTPUT_ON		(1 << DDB2)
#define RGB_LED_GREEN_OUTPUT_ON		(1 << DDD6)
#define RGB_LED_BLUE_OUTPUT_ON		(1 << DDB1)

#define RGB_LED_RED_OUTPUT_OFF		(0 << DDB2)
#define RGB_LED_GREEN_OUTPUT_OFF	(0 << DDD6)
#define RGB_LED_BLUE_OUTPUT_OFF		(0 << DDB1)

#define ON_OK		1
#define OFF_FAIL	0




#define TIMER0_CONTROL_REGISTER_0A		TCCR0A
#define TIMER0_CONTROL_REGISTER_0B		TCCR0B

#define CLOCK_SELECT_BIT_NO_PRESCALING_TIMER0			(1 << CS00)
#define COMPARE_OUTPUT_MODE_FAST_PWM_TIMER0				((1 << WGM01) | (1 << WGM00) | (1 << COM0A1))

#define CLOCK_SELECT_BIT_NO_PRESCALING_TIMER0_ON			(1 << CS00)
#define COMPARE_OUTPUT_MODE_FAST_PWM_TIMER0_ON				((1 << WGM01) | (1 << WGM00) | (1 << COM0A1))

#define CLOCK_SELECT_BIT_NO_PRESCALING_TIMER0_OFF			(0 << CS00)
#define COMPARE_OUTPUT_MODE_FAST_PWM_TIMER0_OFF				((0 << WGM01) | (0 << WGM00) | (0 << COM0A1))



#define TIMER1_CONTROL_REGISTER_1A		TCCR1A
#define TIMER1_CONTROL_REGISTER_1B		TCCR1B

#define CLOCK_SELECT_BIT_NO_PRESCALING_TIMER1			((1 << CS10) | (1 << WGM12))
#define COMPARE_OUTPUT_MODE_FAST_PWM_TIMER1				((1 << WGM10) | (1 << COM1A1) | (1 << COM1B1))

#define CLOCK_SELECT_BIT_NO_PRESCALING_TIMER1_ON			((1 << CS10) | (1 << WGM12))
#define COMPARE_OUTPUT_MODE_FAST_PWM_TIMER1_ON				((1 << WGM10) | (1 << COM1A1) | (1 << COM1B1))

#define CLOCK_SELECT_BIT_NO_PRESCALING_TIMER1_OFF			((0 << CS10) | (0 << WGM12))
#define COMPARE_OUTPUT_MODE_FAST_PWM_TIMER1_OFF				((0 << WGM10) | (0 << COM1A1) | (0 << COM1B1))



#define TIMER2_CONTROL_REGISTER_2A		TCCR2A
#define TIMER2_CONTROL_REGISTER_2B		TCCR2B

#define CLOCK_SELECT_BIT_NO_PRESCALING_TIMER2			(1 << CS22)			
#define COMPARE_OUTPUT_MODE_FAST_PWM_TIMER2				(1 << WGM21)

#define CLOCK_SELECT_BIT_NO_PRESCALING_TIMER2_ON		(1 << CS22)	
#define COMPARE_OUTPUT_MODE_FAST_PWM_TIMER2_ON			(1 << WGM21)	

#define CLOCK_SELECT_BIT_NO_PRESCALING_TIMER2_OFF		(0 << CS22)	
#define COMPARE_OUTPUT_MODE_FAST_PWM_TIMER2_OFF			(0 << WGM21)	


#define OUTPUT_COMPARE_REGISTER			(OCR2A = 124)
#define TIMER2_COMPA_INTERRUPT			(TIMSK2 = (1 << OCIE2A))




class StatusLightHardwareControl
{
	public:
		
		StatusLightHardwareControl();
		
		
		void initialize();
		uint8_t getInitializeHardwareState();
		uint8_t getSoftwareHardwareSate();
		
		
		uint8_t getRgbLedRedOutput();
		void setRgbLedRedOutput();
		uint8_t getRgbLedGreenOutput();
		void setRgbLedGreenOutput();
		uint8_t getRgbLedBlueOutput();
		void setRgbLedBlueOutput();
		
		
		
		
// 		uint8_t getRgbLedRed();
// 		void setRgbLedRed(uint8_t rgbLedRed, uint8_t rgbLedRedValue);
// 		uint8_t getRgbLedGreen();
// 		void setRgbLedGreen(uint8_t rgbLedGreen, uint8_t rgbLedGreenValue);
// 		uint8_t getRgbLedBlue();
// 		void setRgbLedBlue(uint8_t rgbLedBlue, uint8_t rgbLedBlueValue);
		
		

		uint8_t getTimer0Config();
		void setTimer0Config();
		void setTimer0Off();
		void setTimer0On();
		
		uint8_t getTimer1Config();
		void setTimer1Config();
		void setTimer1Off();
		void setTimer1On();	
		
		uint8_t getTimer2Config();
		void setTimer2Config();
		static void setTimer2Off();
		static void setTimer2On();
		
		
		

		
		
		union
		{
			uint8_t rgbLedStateRed;
			uint8_t rgbLedStateGreen;
			uint8_t rgbLedStateBlue;
			
		}rgbLedState_u;
		
		struct
		{
			uint8_t rgbLedCustomRedValue;
			uint8_t rgbLedCustomGreenValue;
			uint8_t rgbLedCustomBlueValue;
			
		
		}rgbLedCostumValue_u;
// 		






		
		
// 		
// 	class sss
// 	{	
// 		public:
// 		protected:
// 		private:
// 	};
	
				
	protected:
	
	
	
	private:
// 		uint8_t r;
// 		uint8_t g;
// 		uint8_t b;
		
		
		
		
		
		
		
		
		
		
		

		
		
};
















#endif /* STATUSLIGHTHARDWARECONTROL_H_ */



